#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeeexnex04/header/ppeeexnex04.phasespace.h"
void ppeeexnex04_ax_psp_240_dcx_ememepvexucx(int no_ps, phasespace_set & psi){
  static Logger logger("ppeeexnex04_ax_psp_240_dcx_ememepvexucx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(33);
  psi_needed_v_smin[no_ps].resize(33);
  int needed_v_smin_0[] = {   0,    1,    2,    8,    9,   12,   13,   14,   20,   21,   24,   25,   30,   31,   32,   33,   38,   39,   40,   41,   46,   47,   48,   49,   52,   53,   56,   57,   60,   61}; //  30
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 30);
  int needed_v_smin_1[] = {   0,   12}; //   2
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   0,    3,   12,   15}; //   4
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {   1,    2,   13,   14}; //   4
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 4);
  int needed_v_smin_4[] = {   1,    2,    5,    6,   13,   14,   17,   18}; //   8
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 8);
  int needed_v_smin_5[] = {   3,   10,   11,   15,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   42,   43,   44,   45,   50,   51,   54,   55,   58,   59,   62,   63}; //  26
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 26);
  int needed_v_smin_6[] = {   3,   15}; //   2
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 2);
  int needed_v_smin_7[] = {   4,    5,    6,   10,   11,   16,   17,   18,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   42,   43,   44,   45,   50,   51,   54,   55,   58,   59,   62,   63}; //  30
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 30);
  int needed_v_smin_8[] = {   4,   16}; //   2
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 2);
  int needed_v_smin_9[] = {   4,    7,   16,   19}; //   4
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 4);
  int needed_v_smin_10[] = {   5,    6,   17,   18}; //   4
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 4);
  int needed_v_smin_11[] = {   7,    8,    9,   19,   20,   21,   24,   25,   30,   31,   32,   33,   38,   39,   40,   41,   46,   47,   48,   49,   52,   53,   56,   57,   60,   61}; //  26
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 26);
  int needed_v_smin_12[] = {   7,   19}; //   2
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 2);
  int needed_v_smin_13[] = {   8,    9,   20,   21}; //   4
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 4);
  int needed_v_smin_14[] = {  10,   11,   22,   23}; //   4
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 4);
  int needed_v_smin_15[] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  24
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 24);
  int needed_v_smin_16[] = {  24,   25,   40,   41,   32,   33}; //   6
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 6);
  int needed_v_smin_17[] = {  24,   25,   32,   33,   40,   41}; //   6
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 6);
  int needed_v_smin_18[] = {  26,   27,   42,   43,   58,   59,   62,   63,   34,   35}; //  10
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 10);
  int needed_v_smin_19[] = {  26,   27,   34,   35,   42,   43}; //   6
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 6);
  int needed_v_smin_20[] = {  28,   29,   44,   45,   36,   37}; //   6
  psi_needed_v_smin[no_ps][ 20] = get_vector_from_array_int(needed_v_smin_20, 6);
  int needed_v_smin_21[] = {  28,   29,   36,   37,   44,   45}; //   6
  psi_needed_v_smin[no_ps][ 21] = get_vector_from_array_int(needed_v_smin_21, 6);
  int needed_v_smin_22[] = {  30,   31,   46,   47,   56,   57,   60,   61,   38,   39}; //  10
  psi_needed_v_smin[no_ps][ 22] = get_vector_from_array_int(needed_v_smin_22, 10);
  int needed_v_smin_23[] = {  30,   31,   38,   39,   46,   47}; //   6
  psi_needed_v_smin[no_ps][ 23] = get_vector_from_array_int(needed_v_smin_23, 6);
  int needed_v_smin_24[] = {  48,   49,   56,   57}; //   4
  psi_needed_v_smin[no_ps][ 24] = get_vector_from_array_int(needed_v_smin_24, 4);
  int needed_v_smin_25[] = {  50,   51,   58,   59}; //   4
  psi_needed_v_smin[no_ps][ 25] = get_vector_from_array_int(needed_v_smin_25, 4);
  int needed_v_smin_26[] = {  48,   49}; //   2
  psi_needed_v_smin[no_ps][ 26] = get_vector_from_array_int(needed_v_smin_26, 2);
  int needed_v_smin_27[] = {  50,   51}; //   2
  psi_needed_v_smin[no_ps][ 27] = get_vector_from_array_int(needed_v_smin_27, 2);
  int needed_v_smin_28[] = {  52,   53,   54,   55}; //   4
  psi_needed_v_smin[no_ps][ 28] = get_vector_from_array_int(needed_v_smin_28, 4);
  int needed_v_smin_29[] = {  52,   53}; //   2
  psi_needed_v_smin[no_ps][ 29] = get_vector_from_array_int(needed_v_smin_29, 2);
  int needed_v_smin_30[] = {  54,   55}; //   2
  psi_needed_v_smin[no_ps][ 30] = get_vector_from_array_int(needed_v_smin_30, 2);
  int needed_v_smin_31[] = {  60,   61}; //   2
  psi_needed_v_smin[no_ps][ 31] = get_vector_from_array_int(needed_v_smin_31, 2);
  int needed_v_smin_32[] = {  62,   63}; //   2
  psi_needed_v_smin[no_ps][ 32] = get_vector_from_array_int(needed_v_smin_32, 2);

  psi_v_smax[no_ps].resize(37);
  psi_needed_v_smax[no_ps].resize(37);
  int needed_v_smax_0[] = {   0,    1,    2,    8,    9,   12,   13,   14,   20,   21,   24,   25,   32,   33,   40,   41,   48,   49,   52,   53,   56,   57,   60,   61}; //  24
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 24);
  int needed_v_smax_1[] = {   0,    3,   12,   15}; //   4
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 4);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  24
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 24);
  int needed_v_smax_3[] = {   1,    2,    5,    6,   13,   14,   17,   18}; //   8
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 8);
  int needed_v_smax_4[] = {   3,   10,   11,   15,   22,   23,   26,   27,   34,   35,   42,   43}; //  12
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 12);
  int needed_v_smax_5[] = {   4,    5,    6,   16,   17,   18,   28,   29,   36,   37,   44,   45,   50,   51,   54,   55,   58,   59,   62,   63}; //  20
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 20);
  int needed_v_smax_6[] = {   4,    7,   16,   19}; //   4
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 4);
  int needed_v_smax_7[] = {   7,   19,   30,   31,   38,   39,   46,   47}; //   8
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 8);
  int needed_v_smax_8[] = {   8,    9,   20,   21,   32,   33,   52,   53,   60,   61}; //  10
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 10);
  int needed_v_smax_9[] = {  10,   11,   22,   23,   34,   35}; //   6
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 6);
  int needed_v_smax_10[] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  48
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 48);
  int needed_v_smax_11[] = {  24,   25,   40,   41}; //   4
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 4);
  int needed_v_smax_12[] = {  24,   25,   40,   41}; //   4
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 4);
  int needed_v_smax_13[] = {  26,   27,   42,   43}; //   4
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 4);
  int needed_v_smax_14[] = {  26,   27,   42,   43}; //   4
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 4);
  int needed_v_smax_15[] = {  28,   29,   44,   45}; //   4
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 4);
  int needed_v_smax_16[] = {  28,   29,   44,   45}; //   4
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 4);
  int needed_v_smax_17[] = {  30,   31,   46,   47}; //   4
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 4);
  int needed_v_smax_18[] = {  30,   31,   46,   47}; //   4
  psi_needed_v_smax[no_ps][ 18] = get_vector_from_array_int(needed_v_smax_18, 4);
  int needed_v_smax_19[] = {  36,   37,   54,   55,   62,   63}; //   6
  psi_needed_v_smax[no_ps][ 19] = get_vector_from_array_int(needed_v_smax_19, 6);
  int needed_v_smax_20[] = {  38,   39}; //   2
  psi_needed_v_smax[no_ps][ 20] = get_vector_from_array_int(needed_v_smax_20, 2);
  int needed_v_smax_21[] = {  48,   49,   56,   57}; //   4
  psi_needed_v_smax[no_ps][ 21] = get_vector_from_array_int(needed_v_smax_21, 4);
  int needed_v_smax_22[] = {  48,   49,   56,   57}; //   4
  psi_needed_v_smax[no_ps][ 22] = get_vector_from_array_int(needed_v_smax_22, 4);
  int needed_v_smax_23[] = {  50,   51,   58,   59}; //   4
  psi_needed_v_smax[no_ps][ 23] = get_vector_from_array_int(needed_v_smax_23, 4);
  int needed_v_smax_24[] = {  50,   51,   58,   59}; //   4
  psi_needed_v_smax[no_ps][ 24] = get_vector_from_array_int(needed_v_smax_24, 4);
  int needed_v_smax_25[] = {  56,   57}; //   2
  psi_needed_v_smax[no_ps][ 25] = get_vector_from_array_int(needed_v_smax_25, 2);
  int needed_v_smax_26[] = {  58,   59}; //   2
  psi_needed_v_smax[no_ps][ 26] = get_vector_from_array_int(needed_v_smax_26, 2);
  int needed_v_smax_27[] = {  60,   61,   38,   39}; //   4
  psi_needed_v_smax[no_ps][ 27] = get_vector_from_array_int(needed_v_smax_27, 4);
  int needed_v_smax_28[] = {  62,   63,   34,   35}; //   4
  psi_needed_v_smax[no_ps][ 28] = get_vector_from_array_int(needed_v_smax_28, 4);
  int needed_v_smax_29[] = {  32,   33}; //   2
  psi_needed_v_smax[no_ps][ 29] = get_vector_from_array_int(needed_v_smax_29, 2);
  int needed_v_smax_30[] = {  36,   37}; //   2
  psi_needed_v_smax[no_ps][ 30] = get_vector_from_array_int(needed_v_smax_30, 2);
  int needed_v_smax_31[] = {  48,   49,   52,   53}; //   4
  psi_needed_v_smax[no_ps][ 31] = get_vector_from_array_int(needed_v_smax_31, 4);
  int needed_v_smax_32[] = {  50,   51,   54,   55}; //   4
  psi_needed_v_smax[no_ps][ 32] = get_vector_from_array_int(needed_v_smax_32, 4);
  int needed_v_smax_33[] = {  52,   53}; //   2
  psi_needed_v_smax[no_ps][ 33] = get_vector_from_array_int(needed_v_smax_33, 2);
  int needed_v_smax_34[] = {  54,   55}; //   2
  psi_needed_v_smax[no_ps][ 34] = get_vector_from_array_int(needed_v_smax_34, 2);
  int needed_v_smax_35[] = {  60,   61}; //   2
  psi_needed_v_smax[no_ps][ 35] = get_vector_from_array_int(needed_v_smax_35, 2);
  int needed_v_smax_36[] = {  62,   63}; //   2
  psi_needed_v_smax[no_ps][ 36] = get_vector_from_array_int(needed_v_smax_36, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(46);
  psi_needed_g_p[no_ps].resize(46);
  int needed_g_p_0[] = {   0,    2,    9,   12,   14,   21,   25,   33,   41,   49,   53,   57,   61}; //  13
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 13);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_1[] = {   0,   12}; //   2
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,    3,   12,   15}; //   4
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 4);
  psi_container_IS_name.push_back("propagator_24_smin2_smax2");
  int needed_g_p_3[] = {   1,    8,   13,   20,   24,   32,   40,   48,   52,   56,   60}; //  11
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 11);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_4[] = {   1,    2,   13,   14}; //   4
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 4);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_5[] = {   1,    2,    5,    6,   13,   14,   17,   18}; //   8
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 8);
  psi_container_IS_name.push_back("propagator_24_smin4_smax2");
  int needed_g_p_6[] = {   3,   10,   11,   15,   22,   23,   26,   27,   34,   35,   42,   43}; //  12
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 12);
  psi_container_IS_name.push_back("propagator_24_smin5_smax4");
  int needed_g_p_7[] = {   3,   15}; //   2
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 2);
  psi_container_IS_name.push_back("propagator_0_smin6_smax1");
  int needed_g_p_8[] = {   4,    6,   16,   18,   29,   37,   45,   51,   55,   59,   63}; //  11
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 11);
  psi_container_IS_name.push_back("propagator_23_smin7_smax5");
  int needed_g_p_9[] = {   4,   16}; //   2
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax6");
  int needed_g_p_10[] = {   4,    7,   16,   19}; //   4
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 4);
  psi_container_IS_name.push_back("propagator_24_smin9_smax2");
  int needed_g_p_11[] = {   5,   17,   28,   36,   44,   50,   54,   58,   62}; //   9
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 9);
  psi_container_IS_name.push_back("propagator_0_smin7_smax5");
  int needed_g_p_12[] = {   5,    6,   17,   18}; //   4
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 4);
  psi_container_IS_name.push_back("propagator_0_smin10_smax3");
  int needed_g_p_13[] = {   7,   19,   30,   31,   38,   39,   46,   47}; //   8
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 8);
  psi_container_IS_name.push_back("propagator_24_smin11_smax7");
  int needed_g_p_14[] = {   7,   19}; //   2
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 2);
  psi_container_IS_name.push_back("propagator_0_smin12_smax6");
  int needed_g_p_15[] = {   8,    9,   20,   21,   32,   33,   52,   53,   60,   61}; //  10
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 10);
  psi_container_IS_name.push_back("propagator_24_smin11_smax8");
  int needed_g_p_16[] = {   8,    9,   20,   21}; //   4
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 4);
  psi_container_IS_name.push_back("propagator_24_smin13_smax2");
  int needed_g_p_17[] = {  10,   22,   34}; //   3
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 3);
  psi_container_IS_name.push_back("propagator_0_smin7_smax9");
  int needed_g_p_18[] = {  10,   11,   22,   23}; //   4
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 4);
  psi_container_IS_name.push_back("propagator_24_smin14_smax2");
  int needed_g_p_19[] = {  11,   23,   35}; //   3
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 3);
  psi_container_IS_name.push_back("propagator_23_smin7_smax9");
  int needed_g_p_20[] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  12
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 12);
  psi_container_IS_name.push_back("propagator_0_smin15_smax10");
  int needed_g_p_21[] = {  24,   25,   40,   41}; //   4
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 4);
  psi_container_IS_name.push_back("propagator_0_smin16_smax11");
  int needed_g_p_22[] = {  24,   25,   40,   41}; //   4
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 4);
  psi_container_IS_name.push_back("propagator_24_smin11_smax12");
  int needed_g_p_23[] = {  24,   25}; //   2
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 2);
  psi_container_IS_name.push_back("propagator_0_smin17_smax10");
  int needed_g_p_24[] = {  26,   27,   42,   43}; //   4
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 4);
  psi_container_IS_name.push_back("propagator_0_smin18_smax13");
  int needed_g_p_25[] = {  26,   42}; //   2
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 2);
  psi_container_IS_name.push_back("propagator_0_smin7_smax14");
  int needed_g_p_26[] = {  26,   27}; //   2
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 2);
  psi_container_IS_name.push_back("propagator_0_smin19_smax10");
  int needed_g_p_27[] = {  27,   43}; //   2
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 2);
  psi_container_IS_name.push_back("propagator_23_smin7_smax14");
  int needed_g_p_28[] = {  28,   29,   44,   45}; //   4
  psi_needed_g_p[no_ps][28] = get_vector_from_array_int(needed_g_p_28, 4);
  psi_container_IS_name.push_back("propagator_0_smin20_smax15");
  int needed_g_p_29[] = {  28,   29,   44,   45}; //   4
  psi_needed_g_p[no_ps][29] = get_vector_from_array_int(needed_g_p_29, 4);
  psi_container_IS_name.push_back("propagator_24_smin5_smax16");
  int needed_g_p_30[] = {  28,   29}; //   2
  psi_needed_g_p[no_ps][30] = get_vector_from_array_int(needed_g_p_30, 2);
  psi_container_IS_name.push_back("propagator_0_smin21_smax10");
  int needed_g_p_31[] = {  30,   31,   46,   47}; //   4
  psi_needed_g_p[no_ps][31] = get_vector_from_array_int(needed_g_p_31, 4);
  psi_container_IS_name.push_back("propagator_0_smin22_smax17");
  int needed_g_p_32[] = {  30,   46}; //   2
  psi_needed_g_p[no_ps][32] = get_vector_from_array_int(needed_g_p_32, 2);
  psi_container_IS_name.push_back("propagator_0_smin0_smax18");
  int needed_g_p_33[] = {  30,   31}; //   2
  psi_needed_g_p[no_ps][33] = get_vector_from_array_int(needed_g_p_33, 2);
  psi_container_IS_name.push_back("propagator_0_smin23_smax10");
  int needed_g_p_34[] = {  31,   47}; //   2
  psi_needed_g_p[no_ps][34] = get_vector_from_array_int(needed_g_p_34, 2);
  psi_container_IS_name.push_back("propagator_23_smin0_smax18");
  int needed_g_p_35[] = {  36,   37,   54,   55,   62,   63}; //   6
  psi_needed_g_p[no_ps][35] = get_vector_from_array_int(needed_g_p_35, 6);
  psi_container_IS_name.push_back("propagator_24_smin5_smax19");
  int needed_g_p_36[] = {  38}; //   1
  psi_needed_g_p[no_ps][36] = get_vector_from_array_int(needed_g_p_36, 1);
  psi_container_IS_name.push_back("propagator_0_smin0_smax20");
  int needed_g_p_37[] = {  39}; //   1
  psi_needed_g_p[no_ps][37] = get_vector_from_array_int(needed_g_p_37, 1);
  psi_container_IS_name.push_back("propagator_23_smin0_smax20");
  int needed_g_p_38[] = {  48,   49,   56,   57}; //   4
  psi_needed_g_p[no_ps][38] = get_vector_from_array_int(needed_g_p_38, 4);
  psi_container_IS_name.push_back("propagator_0_smin24_smax21");
  int needed_g_p_39[] = {  48,   49,   56,   57}; //   4
  psi_needed_g_p[no_ps][39] = get_vector_from_array_int(needed_g_p_39, 4);
  psi_container_IS_name.push_back("propagator_24_smin11_smax22");
  int needed_g_p_40[] = {  50,   51,   58,   59}; //   4
  psi_needed_g_p[no_ps][40] = get_vector_from_array_int(needed_g_p_40, 4);
  psi_container_IS_name.push_back("propagator_0_smin25_smax23");
  int needed_g_p_41[] = {  50,   51,   58,   59}; //   4
  psi_needed_g_p[no_ps][41] = get_vector_from_array_int(needed_g_p_41, 4);
  psi_container_IS_name.push_back("propagator_24_smin5_smax24");
  int needed_g_p_42[] = {  56,   57}; //   2
  psi_needed_g_p[no_ps][42] = get_vector_from_array_int(needed_g_p_42, 2);
  psi_container_IS_name.push_back("propagator_0_smin22_smax25");
  int needed_g_p_43[] = {  58,   59}; //   2
  psi_needed_g_p[no_ps][43] = get_vector_from_array_int(needed_g_p_43, 2);
  psi_container_IS_name.push_back("propagator_0_smin18_smax26");
  int needed_g_p_44[] = {  60,   61}; //   2
  psi_needed_g_p[no_ps][44] = get_vector_from_array_int(needed_g_p_44, 2);
  psi_container_IS_name.push_back("propagator_0_smin22_smax27");
  int needed_g_p_45[] = {  62,   63}; //   2
  psi_needed_g_p[no_ps][45] = get_vector_from_array_int(needed_g_p_45, 2);
  psi_container_IS_name.push_back("propagator_0_smin18_smax28");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(17);
  psi_needed_g_f[no_ps].resize(17);
  int needed_g_f_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 12);
  psi_container_IS_name.push_back("timelikeinvariant_smin15_smax10");
  int needed_g_f_1[] = {  32,   33}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin16_smax29");
  int needed_g_f_2[] = {  32,   33,   40,   41}; //   4
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin17_smax10");
  int needed_g_f_3[] = {  34,   35}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin18_smax28");
  int needed_g_f_4[] = {  34,   35,   42,   43}; //   4
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin19_smax10");
  int needed_g_f_5[] = {  36,   37}; //   2
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin20_smax30");
  int needed_g_f_6[] = {  36,   37,   44,   45}; //   4
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin21_smax10");
  int needed_g_f_7[] = {  38,   39}; //   2
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin22_smax27");
  int needed_g_f_8[] = {  38,   39,   46,   47}; //   4
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin23_smax10");
  int needed_g_f_9[] = {  48,   49}; //   2
  psi_needed_g_f[no_ps][9] = get_vector_from_array_int(needed_g_f_9, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin26_smax31");
  int needed_g_f_10[] = {  50,   51}; //   2
  psi_needed_g_f[no_ps][10] = get_vector_from_array_int(needed_g_f_10, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin27_smax32");
  int needed_g_f_11[] = {  52,   53}; //   2
  psi_needed_g_f[no_ps][11] = get_vector_from_array_int(needed_g_f_11, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin28_smax33");
  int needed_g_f_12[] = {  52,   53}; //   2
  psi_needed_g_f[no_ps][12] = get_vector_from_array_int(needed_g_f_12, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin29_smax31");
  int needed_g_f_13[] = {  54,   55}; //   2
  psi_needed_g_f[no_ps][13] = get_vector_from_array_int(needed_g_f_13, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin28_smax34");
  int needed_g_f_14[] = {  54,   55}; //   2
  psi_needed_g_f[no_ps][14] = get_vector_from_array_int(needed_g_f_14, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin30_smax32");
  int needed_g_f_15[] = {  60,   61}; //   2
  psi_needed_g_f[no_ps][15] = get_vector_from_array_int(needed_g_f_15, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin31_smax35");
  int needed_g_f_16[] = {  62,   63}; //   2
  psi_needed_g_f[no_ps][16] = get_vector_from_array_int(needed_g_f_16, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin32_smax36");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(24);
  psi_needed_g_t[no_ps].resize(24);
  int needed_g_t_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  48
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 48);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__128_124");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__128_124");
  int needed_g_t_1[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 12);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__130_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__130_1__64_60");
  int needed_g_t_2[] = {  32,   33,   40,   41}; //   4
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_130__36_88");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_130__36_88");
  int needed_g_t_3[] = {  32,   33}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_37__64_24");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_37__64_24");
  int needed_g_t_4[] = {  34,   35,   42,   43}; //   4
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_130__20_104");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_130__20_104");
  int needed_g_t_5[] = {  34,   35}; //   2
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_21__64_40");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_21__64_40");
  int needed_g_t_6[] = {  36,   37,   44,   45}; //   4
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_130__40_84");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_130__40_84");
  int needed_g_t_7[] = {  36,   37}; //   2
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_41__64_20");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_41__64_20");
  int needed_g_t_8[] = {  38,   39,   46,   47}; //   4
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_130__24_100");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_130__24_100");
  int needed_g_t_9[] = {  38,   39}; //   2
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_25__64_36");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_25__64_36");
  int needed_g_t_10[] = {  48,   49,   52,   53}; //   4
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__36_216");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__36_216");
  int needed_g_t_11[] = {  48,   49}; //   2
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_37__152_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_37__152_64");
  int needed_g_t_12[] = {  50,   51,   54,   55}; //   4
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__40_212");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__40_212");
  int needed_g_t_13[] = {  50,   51}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_41__148_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_41__148_64");
  int needed_g_t_14[] = {  52,   53}; //   2
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_37__24_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_37__24_192");
  int needed_g_t_15[] = {  52,   53}; //   2
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__37_26__64_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__37_26__64_128");
  int needed_g_t_16[] = {  54,   55}; //   2
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_41__20_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_41__20_192");
  int needed_g_t_17[] = {  54,   55}; //   2
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__41_22__64_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__41_22__64_128");
  int needed_g_t_18[] = {  56,   57}; //   2
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__100_152");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__100_152");
  int needed_g_t_19[] = {  58,   59}; //   2
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__104_148");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__104_148");
  int needed_g_t_20[] = {  60,   61}; //   2
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__24_228");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__24_228");
  int needed_g_t_21[] = {  60,   61}; //   2
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_26__100_128");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_26__100_128");
  int needed_g_t_22[] = {  62,   63}; //   2
  psi_needed_g_t[no_ps][22] = get_vector_from_array_int(needed_g_t_22, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__20_232");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__20_232");
  int needed_g_t_23[] = {  62,   63}; //   2
  psi_needed_g_t[no_ps][23] = get_vector_from_array_int(needed_g_t_23, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_22__104_128");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_22__104_128");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(26);
  psi_needed_g_d[no_ps].resize(26);
  int needed_g_d_0[] = {   0,    3,   12,   15}; //   4
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_1[] = {   0,   12}; //   2
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 2);
  psi_container_IS_name.push_back("costheta_of_decay_56__32_24");
  psi_container_IS_name.push_back("phi_of_decay_56__32_24");
  int needed_g_d_2[] = {   0,    1,    2,    8,    9,   12,   13,   14,   20,   21,   24,   25,   30,   31,   32,   33,   38,   39,   40,   41,   46,   47,   48,   49,   52,   53,   56,   57,   60,   61}; //  30
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 30);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_3[] = {   1,    2,    5,    6,   13,   14,   17,   18}; //   8
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_4[] = {   1,    2,   13,   14}; //   4
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_5[] = {   3,   15}; //   2
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 2);
  psi_container_IS_name.push_back("costheta_of_decay_56__16_40");
  psi_container_IS_name.push_back("phi_of_decay_56__16_40");
  int needed_g_d_6[] = {   3,   10,   11,   15,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   42,   43,   44,   45,   50,   51,   54,   55,   58,   59,   62,   63}; //  26
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 26);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_7[] = {   4,    7,   16,   19}; //   4
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_8[] = {   4,   16}; //   2
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 2);
  psi_container_IS_name.push_back("costheta_of_decay_52__32_20");
  psi_container_IS_name.push_back("phi_of_decay_52__32_20");
  int needed_g_d_9[] = {   4,    5,    6,   10,   11,   16,   17,   18,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   42,   43,   44,   45,   50,   51,   54,   55,   58,   59,   62,   63}; //  30
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 30);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_10[] = {   5,    6,   17,   18}; //   4
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_11[] = {   7,   19}; //   2
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 2);
  psi_container_IS_name.push_back("costheta_of_decay_52__16_36");
  psi_container_IS_name.push_back("phi_of_decay_52__16_36");
  int needed_g_d_12[] = {   7,    8,    9,   19,   20,   21,   24,   25,   30,   31,   32,   33,   38,   39,   40,   41,   46,   47,   48,   49,   52,   53,   56,   57,   60,   61}; //  26
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 26);
  psi_container_IS_name.push_back("costheta_of_decay_36__4_32");
  psi_container_IS_name.push_back("phi_of_decay_36__4_32");
  int needed_g_d_13[] = {   8,    9,   20,   21}; //   4
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__36_24");
  psi_container_IS_name.push_back("phi_of_decay_60__36_24");
  int needed_g_d_14[] = {  10,   11,   22,   23}; //   4
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__20_40");
  psi_container_IS_name.push_back("phi_of_decay_60__20_40");
  int needed_g_d_15[] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  12
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 12);
  psi_container_IS_name.push_back("costheta_of_decay_124__64_60");
  psi_container_IS_name.push_back("phi_of_decay_124__64_60");
  int needed_g_d_16[] = {  24,   25}; //   2
  psi_needed_g_d[no_ps][16] = get_vector_from_array_int(needed_g_d_16, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__36_88");
  psi_container_IS_name.push_back("phi_of_decay_124__36_88");
  int needed_g_d_17[] = {  24,   25,   40,   41}; //   4
  psi_needed_g_d[no_ps][17] = get_vector_from_array_int(needed_g_d_17, 4);
  psi_container_IS_name.push_back("costheta_of_decay_88__64_24");
  psi_container_IS_name.push_back("phi_of_decay_88__64_24");
  int needed_g_d_18[] = {  26,   27}; //   2
  psi_needed_g_d[no_ps][18] = get_vector_from_array_int(needed_g_d_18, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__20_104");
  psi_container_IS_name.push_back("phi_of_decay_124__20_104");
  int needed_g_d_19[] = {  26,   27,   42,   43,   58,   59,   62,   63}; //   8
  psi_needed_g_d[no_ps][19] = get_vector_from_array_int(needed_g_d_19, 8);
  psi_container_IS_name.push_back("costheta_of_decay_104__64_40");
  psi_container_IS_name.push_back("phi_of_decay_104__64_40");
  int needed_g_d_20[] = {  28,   29}; //   2
  psi_needed_g_d[no_ps][20] = get_vector_from_array_int(needed_g_d_20, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__40_84");
  psi_container_IS_name.push_back("phi_of_decay_124__40_84");
  int needed_g_d_21[] = {  28,   29,   44,   45}; //   4
  psi_needed_g_d[no_ps][21] = get_vector_from_array_int(needed_g_d_21, 4);
  psi_container_IS_name.push_back("costheta_of_decay_84__64_20");
  psi_container_IS_name.push_back("phi_of_decay_84__64_20");
  int needed_g_d_22[] = {  30,   31}; //   2
  psi_needed_g_d[no_ps][22] = get_vector_from_array_int(needed_g_d_22, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__24_100");
  psi_container_IS_name.push_back("phi_of_decay_124__24_100");
  int needed_g_d_23[] = {  30,   31,   46,   47,   56,   57,   60,   61}; //   8
  psi_needed_g_d[no_ps][23] = get_vector_from_array_int(needed_g_d_23, 8);
  psi_container_IS_name.push_back("costheta_of_decay_100__64_36");
  psi_container_IS_name.push_back("phi_of_decay_100__64_36");
  int needed_g_d_24[] = {  48,   49,   56,   57}; //   4
  psi_needed_g_d[no_ps][24] = get_vector_from_array_int(needed_g_d_24, 4);
  psi_container_IS_name.push_back("costheta_of_decay_152__128_24");
  psi_container_IS_name.push_back("phi_of_decay_152__128_24");
  int needed_g_d_25[] = {  50,   51,   58,   59}; //   4
  psi_needed_g_d[no_ps][25] = get_vector_from_array_int(needed_g_d_25, 4);
  psi_container_IS_name.push_back("costheta_of_decay_148__128_20");
  psi_container_IS_name.push_back("phi_of_decay_148__128_20");

  psi_c_p[no_ps].resize(64);
  psi_c_f[no_ps].resize(64);
  psi_c_t[no_ps].resize(64);
  psi_c_d[no_ps].resize(64);

  int c_p_0[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 3);
  int c_f_0[] = {  0}; //   1
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 1);
  int c_t_0[] = {  0,   1}; //   2
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 2);
  int c_d_0[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 3);

  int c_p_1[] = {  3,   4,   5}; //   3
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 3);
  int c_f_1[] = {  0}; //   1
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 1);
  int c_t_1[] = {  0,   1}; //   2
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 2);
  int c_d_1[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  0,   4,   5}; //   3
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 3);
  int c_f_2[] = {  0}; //   1
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 1);
  int c_t_2[] = {  0,   1}; //   2
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 2);
  int c_d_2[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  6,   7,   2}; //   3
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 3);
  int c_f_3[] = {  0}; //   1
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 1);
  int c_t_3[] = {  0,   1}; //   2
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 2);
  int c_d_3[] = {  0,   5,   6}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  8,   9,  10}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {  0}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = {  0,   1}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  7,   8,   9}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = { 11,  12,   5}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {  0}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = {  0,   1}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  3,  10,   9}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  8,  12,   5}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {  0}; //   1
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 1);
  int c_t_6[] = {  0,   1}; //   2
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 2);
  int c_d_6[] = {  3,  10,   9}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = { 13,  14,  10}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {  0}; //   1
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 1);
  int c_t_7[] = {  0,   1}; //   2
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 2);
  int c_d_7[] = {  7,  11,  12}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  3,  15,  16}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {  0}; //   1
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 1);
  int c_t_8[] = {  0,   1}; //   2
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 2);
  int c_d_8[] = { 13,  12,   2}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = {  0,  15,  16}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {  0}; //   1
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 1);
  int c_t_9[] = {  0,   1}; //   2
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 2);
  int c_d_9[] = { 13,  12,   2}; //   3
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 3);

  int c_p_10[] = {  6,  17,  18}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {  0}; //   1
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 1);
  int c_t_10[] = {  0,   1}; //   2
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 2);
  int c_d_10[] = { 14,   9,   6}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  6,  19,  18}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {  0}; //   1
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 1);
  int c_t_11[] = {  0,   1}; //   2
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 2);
  int c_d_11[] = { 14,   9,   6}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = {  0,   1,   2,  20}; //   4
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 4);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  0}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = { 15,   0,   1,   2}; //   4
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 4);

  int c_p_13[] = {  3,   4,   5,  20}; //   4
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 4);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  0}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = { 15,   3,   4,   2}; //   4
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 4);

  int c_p_14[] = {  0,   4,   5,  20}; //   4
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 4);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  0}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = { 15,   3,   4,   2}; //   4
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 4);

  int c_p_15[] = {  6,   7,   2,  20}; //   4
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 4);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  0}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = { 15,   0,   5,   6}; //   4
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 4);

  int c_p_16[] = {  8,   9,  10,  20}; //   4
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 4);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {  0}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = { 15,   7,   8,   9}; //   4
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 4);

  int c_p_17[] = { 11,  12,   5,  20}; //   4
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 4);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {  0}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = { 15,   3,  10,   9}; //   4
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 4);

  int c_p_18[] = {  8,  12,   5,  20}; //   4
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 4);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {  0}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = { 15,   3,  10,   9}; //   4
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 4);

  int c_p_19[] = { 13,  14,  10,  20}; //   4
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 4);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {  0}; //   1
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 1);
  int c_d_19[] = { 15,   7,  11,  12}; //   4
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 4);

  int c_p_20[] = {  3,  15,  16,  20}; //   4
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 4);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {  0}; //   1
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 1);
  int c_d_20[] = { 15,  13,  12,   2}; //   4
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 4);

  int c_p_21[] = {  0,  15,  16,  20}; //   4
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 4);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {  0}; //   1
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 1);
  int c_d_21[] = { 15,  13,  12,   2}; //   4
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 4);

  int c_p_22[] = {  6,  17,  18,  20}; //   4
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 4);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {  0}; //   1
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 1);
  int c_d_22[] = { 15,  14,   9,   6}; //   4
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 4);

  int c_p_23[] = {  6,  19,  18,  20}; //   4
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 4);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {  0}; //   1
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 1);
  int c_d_23[] = { 15,  14,   9,   6}; //   4
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 4);

  int c_p_24[] = {  3,  21,  22,  23}; //   4
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 4);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {  0}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = { 16,  12,  17,   2}; //   4
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 4);

  int c_p_25[] = {  0,  21,  22,  23}; //   4
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 4);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {  0}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = { 16,  12,  17,   2}; //   4
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 4);

  int c_p_26[] = {  6,  24,  25,  26}; //   4
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 4);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {  0}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = { 18,   9,  19,   6}; //   4
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 4);

  int c_p_27[] = {  6,  24,  27,  26}; //   4
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 4);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {  0}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = { 18,   9,  19,   6}; //   4
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 4);

  int c_p_28[] = { 11,  28,  29,  30}; //   4
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 4);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {  0}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = { 20,   6,  21,   9}; //   4
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 4);

  int c_p_29[] = {  8,  28,  29,  30}; //   4
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 4);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {  0}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = { 20,   6,  21,   9}; //   4
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 4);

  int c_p_30[] = { 13,  31,  32,  33}; //   4
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 4);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {  0}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = { 22,   2,  23,  12}; //   4
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 4);

  int c_p_31[] = { 13,  31,  34,  33}; //   4
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 4);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {  0}; //   1
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 1);
  int c_d_31[] = { 22,   2,  23,  12}; //   4
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 4);

  int c_p_32[] = {  3,  15}; //   2
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 2);
  int c_f_32[] = {  1,   2}; //   2
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 2);
  int c_t_32[] = {  0,   2,   3}; //   3
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 3);
  int c_d_32[] = { 12,   2}; //   2
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 2);

  int c_p_33[] = {  0,  15}; //   2
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 2);
  int c_f_33[] = {  1,   2}; //   2
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 2);
  int c_t_33[] = {  0,   2,   3}; //   3
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 3);
  int c_d_33[] = { 12,   2}; //   2
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 2);

  int c_p_34[] = {  6,  17}; //   2
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 2);
  int c_f_34[] = {  3,   4}; //   2
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 2);
  int c_t_34[] = {  0,   4,   5}; //   3
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 3);
  int c_d_34[] = {  9,   6}; //   2
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 2);

  int c_p_35[] = {  6,  19}; //   2
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 2);
  int c_f_35[] = {  3,   4}; //   2
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 2);
  int c_t_35[] = {  0,   4,   5}; //   3
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 3);
  int c_d_35[] = {  9,   6}; //   2
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 2);

  int c_p_36[] = { 11,  35}; //   2
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 2);
  int c_f_36[] = {  5,   6}; //   2
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 2);
  int c_t_36[] = {  0,   6,   7}; //   3
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 3);
  int c_d_36[] = {  6,   9}; //   2
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 2);

  int c_p_37[] = {  8,  35}; //   2
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 2);
  int c_f_37[] = {  5,   6}; //   2
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 2);
  int c_t_37[] = {  0,   6,   7}; //   3
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 3);
  int c_d_37[] = {  6,   9}; //   2
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 2);

  int c_p_38[] = { 13,  36}; //   2
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 2);
  int c_f_38[] = {  7,   8}; //   2
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 2);
  int c_t_38[] = {  0,   8,   9}; //   3
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 3);
  int c_d_38[] = {  2,  12}; //   2
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 2);

  int c_p_39[] = { 13,  37}; //   2
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 2);
  int c_f_39[] = {  7,   8}; //   2
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 2);
  int c_t_39[] = {  0,   8,   9}; //   3
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 3);
  int c_d_39[] = {  2,  12}; //   2
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 2);

  int c_p_40[] = {  3,  21,  22}; //   3
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 3);
  int c_f_40[] = {  2}; //   1
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 1);
  int c_t_40[] = {  0,   2}; //   2
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 2);
  int c_d_40[] = { 12,  17,   2}; //   3
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 3);

  int c_p_41[] = {  0,  21,  22}; //   3
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 3);
  int c_f_41[] = {  2}; //   1
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 1);
  int c_t_41[] = {  0,   2}; //   2
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 2);
  int c_d_41[] = { 12,  17,   2}; //   3
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 3);

  int c_p_42[] = {  6,  24,  25}; //   3
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 3);
  int c_f_42[] = {  4}; //   1
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 1);
  int c_t_42[] = {  0,   4}; //   2
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 2);
  int c_d_42[] = {  9,  19,   6}; //   3
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 3);

  int c_p_43[] = {  6,  24,  27}; //   3
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 3);
  int c_f_43[] = {  4}; //   1
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 1);
  int c_t_43[] = {  0,   4}; //   2
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 2);
  int c_d_43[] = {  9,  19,   6}; //   3
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 3);

  int c_p_44[] = { 11,  28,  29}; //   3
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 3);
  int c_f_44[] = {  6}; //   1
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 1);
  int c_t_44[] = {  0,   6}; //   2
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 2);
  int c_d_44[] = {  6,  21,   9}; //   3
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 3);

  int c_p_45[] = {  8,  28,  29}; //   3
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 3);
  int c_f_45[] = {  6}; //   1
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 1);
  int c_t_45[] = {  0,   6}; //   2
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 2);
  int c_d_45[] = {  6,  21,   9}; //   3
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 3);

  int c_p_46[] = { 13,  31,  32}; //   3
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 3);
  int c_f_46[] = {  8}; //   1
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 1);
  int c_t_46[] = {  0,   8}; //   2
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 2);
  int c_d_46[] = {  2,  23,  12}; //   3
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 3);

  int c_p_47[] = { 13,  31,  34}; //   3
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 3);
  int c_f_47[] = {  8}; //   1
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 1);
  int c_t_47[] = {  0,   8}; //   2
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 2);
  int c_d_47[] = {  2,  23,  12}; //   3
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 3);

  int c_p_48[] = {  3,  38,  39}; //   3
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 3);
  int c_f_48[] = {  9}; //   1
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 1);
  int c_t_48[] = { 10,  11}; //   2
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 2);
  int c_d_48[] = { 12,  24,   2}; //   3
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 3);

  int c_p_49[] = {  0,  38,  39}; //   3
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 3);
  int c_f_49[] = {  9}; //   1
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 1);
  int c_t_49[] = { 10,  11}; //   2
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 2);
  int c_d_49[] = { 12,  24,   2}; //   3
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 3);

  int c_p_50[] = { 11,  40,  41}; //   3
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 3);
  int c_f_50[] = { 10}; //   1
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 1);
  int c_t_50[] = { 12,  13}; //   2
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 2);
  int c_d_50[] = {  6,  25,   9}; //   3
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 3);

  int c_p_51[] = {  8,  40,  41}; //   3
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 3);
  int c_f_51[] = { 10}; //   1
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 1);
  int c_t_51[] = { 12,  13}; //   2
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 2);
  int c_d_51[] = {  6,  25,   9}; //   3
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 3);

  int c_p_52[] = {  3,  15}; //   2
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 2);
  int c_f_52[] = { 11,  12}; //   2
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 2);
  int c_t_52[] = { 10,  14,  15}; //   3
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 3);
  int c_d_52[] = { 12,   2}; //   2
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 2);

  int c_p_53[] = {  0,  15}; //   2
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 2);
  int c_f_53[] = { 11,  12}; //   2
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 2);
  int c_t_53[] = { 10,  14,  15}; //   3
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 3);
  int c_d_53[] = { 12,   2}; //   2
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 2);

  int c_p_54[] = { 11,  35}; //   2
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 2);
  int c_f_54[] = { 13,  14}; //   2
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 2);
  int c_t_54[] = { 12,  16,  17}; //   3
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 3);
  int c_d_54[] = {  6,   9}; //   2
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 2);

  int c_p_55[] = {  8,  35}; //   2
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 2);
  int c_f_55[] = { 13,  14}; //   2
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 2);
  int c_t_55[] = { 12,  16,  17}; //   3
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 3);
  int c_d_55[] = {  6,   9}; //   2
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 2);

  int c_p_56[] = {  3,  38,  39,  42}; //   4
  psi_c_p[no_ps][56] = get_vector_from_array_int(c_p_56, 4);
  int c_f_56[] = {}; //   0
  psi_c_f[no_ps][56] = get_vector_from_array_int(c_f_56, 0);
  int c_t_56[] = { 18}; //   1
  psi_c_t[no_ps][56] = get_vector_from_array_int(c_t_56, 1);
  int c_d_56[] = { 23,  12,  24,   2}; //   4
  psi_c_d[no_ps][56] = get_vector_from_array_int(c_d_56, 4);

  int c_p_57[] = {  0,  38,  39,  42}; //   4
  psi_c_p[no_ps][57] = get_vector_from_array_int(c_p_57, 4);
  int c_f_57[] = {}; //   0
  psi_c_f[no_ps][57] = get_vector_from_array_int(c_f_57, 0);
  int c_t_57[] = { 18}; //   1
  psi_c_t[no_ps][57] = get_vector_from_array_int(c_t_57, 1);
  int c_d_57[] = { 23,  12,  24,   2}; //   4
  psi_c_d[no_ps][57] = get_vector_from_array_int(c_d_57, 4);

  int c_p_58[] = { 11,  40,  41,  43}; //   4
  psi_c_p[no_ps][58] = get_vector_from_array_int(c_p_58, 4);
  int c_f_58[] = {}; //   0
  psi_c_f[no_ps][58] = get_vector_from_array_int(c_f_58, 0);
  int c_t_58[] = { 19}; //   1
  psi_c_t[no_ps][58] = get_vector_from_array_int(c_t_58, 1);
  int c_d_58[] = { 19,   6,  25,   9}; //   4
  psi_c_d[no_ps][58] = get_vector_from_array_int(c_d_58, 4);

  int c_p_59[] = {  8,  40,  41,  43}; //   4
  psi_c_p[no_ps][59] = get_vector_from_array_int(c_p_59, 4);
  int c_f_59[] = {}; //   0
  psi_c_f[no_ps][59] = get_vector_from_array_int(c_f_59, 0);
  int c_t_59[] = { 19}; //   1
  psi_c_t[no_ps][59] = get_vector_from_array_int(c_t_59, 1);
  int c_d_59[] = { 19,   6,  25,   9}; //   4
  psi_c_d[no_ps][59] = get_vector_from_array_int(c_d_59, 4);

  int c_p_60[] = {  3,  15,  44}; //   3
  psi_c_p[no_ps][60] = get_vector_from_array_int(c_p_60, 3);
  int c_f_60[] = { 15}; //   1
  psi_c_f[no_ps][60] = get_vector_from_array_int(c_f_60, 1);
  int c_t_60[] = { 20,  21}; //   2
  psi_c_t[no_ps][60] = get_vector_from_array_int(c_t_60, 2);
  int c_d_60[] = { 23,  12,   2}; //   3
  psi_c_d[no_ps][60] = get_vector_from_array_int(c_d_60, 3);

  int c_p_61[] = {  0,  15,  44}; //   3
  psi_c_p[no_ps][61] = get_vector_from_array_int(c_p_61, 3);
  int c_f_61[] = { 15}; //   1
  psi_c_f[no_ps][61] = get_vector_from_array_int(c_f_61, 1);
  int c_t_61[] = { 20,  21}; //   2
  psi_c_t[no_ps][61] = get_vector_from_array_int(c_t_61, 2);
  int c_d_61[] = { 23,  12,   2}; //   3
  psi_c_d[no_ps][61] = get_vector_from_array_int(c_d_61, 3);

  int c_p_62[] = { 11,  35,  45}; //   3
  psi_c_p[no_ps][62] = get_vector_from_array_int(c_p_62, 3);
  int c_f_62[] = { 16}; //   1
  psi_c_f[no_ps][62] = get_vector_from_array_int(c_f_62, 1);
  int c_t_62[] = { 22,  23}; //   2
  psi_c_t[no_ps][62] = get_vector_from_array_int(c_t_62, 2);
  int c_d_62[] = { 19,   6,   9}; //   3
  psi_c_d[no_ps][62] = get_vector_from_array_int(c_d_62, 3);

  int c_p_63[] = {  8,  35,  45}; //   3
  psi_c_p[no_ps][63] = get_vector_from_array_int(c_p_63, 3);
  int c_f_63[] = { 16}; //   1
  psi_c_f[no_ps][63] = get_vector_from_array_int(c_f_63, 1);
  int c_t_63[] = { 22,  23}; //   2
  psi_c_t[no_ps][63] = get_vector_from_array_int(c_t_63, 2);
  int c_d_63[] = { 19,   6,   9}; //   3
  psi_c_d[no_ps][63] = get_vector_from_array_int(c_d_63, 3);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
