#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeex02/header/ppeex02.phasespace.h"
void ppeex02_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppeex02_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppeex02_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeex02_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 16;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 16;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 16;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 16;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 16;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 16;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 16;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 8;}
  else if (psi_no_map[no_ps] == 10){n_channel = 8;}
  else if (psi_no_map[no_ps] == 11){n_channel = 8;}
  else if (psi_no_map[no_ps] == 13){n_channel = 16;}
  else if (psi_no_map[no_ps] == 14){n_channel = 16;}
  else if (psi_no_map[no_ps] == 15){n_channel = 8;}
  else if (psi_no_map[no_ps] == 16){n_channel = 8;}
  else if (psi_no_map[no_ps] == 17){n_channel = 8;}
  else if (psi_no_map[no_ps] == 18){n_channel = 8;}
  else if (psi_no_map[no_ps] == 20){n_channel = 8;}
  else if (psi_no_map[no_ps] == 22){n_channel = 8;}
  else if (psi_no_map[no_ps] == 23){n_channel = 16;}
  else if (psi_no_map[no_ps] == 24){n_channel = 8;}
  else if (psi_no_map[no_ps] == 25){n_channel = 8;}
  else if (psi_no_map[no_ps] == 27){n_channel = 16;}
  else if (psi_no_map[no_ps] == 28){n_channel = 8;}
  else if (psi_no_map[no_ps] == 29){n_channel = 16;}
  else if (psi_no_map[no_ps] == 30){n_channel = 8;}
  else if (psi_no_map[no_ps] == 31){n_channel = 8;}
  else if (psi_no_map[no_ps] == 32){n_channel = 8;}
  else if (psi_no_map[no_ps] == 34){n_channel = 8;}
  else if (psi_no_map[no_ps] == 35){n_channel = 16;}
  else if (psi_no_map[no_ps] == 36){n_channel = 8;}
  else if (psi_no_map[no_ps] == 37){n_channel = 8;}
  else if (psi_no_map[no_ps] == 38){n_channel = 8;}
  else if (psi_no_map[no_ps] == 40){n_channel = 16;}
  else if (psi_no_map[no_ps] == 41){n_channel = 8;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeex02_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppeex02_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 41){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeex02_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeex02_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppeex02_ax_psp_220_gg_emepddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppeex02_ax_psp_220_gg_emepuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppeex02_ax_psp_220_gd_emepgd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppeex02_ax_psp_220_gu_emepgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppeex02_ax_psp_220_gdx_emepgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppeex02_ax_psp_220_gux_emepgux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppeex02_ax_psp_220_dd_emepdd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppeex02_ax_psp_220_du_emepdu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppeex02_ax_psp_220_ds_emepds(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppeex02_ax_psp_220_dc_emepdc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppeex02_ax_psp_220_ddx_emepgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppeex02_ax_psp_220_ddx_emepddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppeex02_ax_psp_220_ddx_emepuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppeex02_ax_psp_220_ddx_emepssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppeex02_ax_psp_220_ddx_emepccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppeex02_ax_psp_220_dux_emepdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppeex02_ax_psp_220_dsx_emepdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppeex02_ax_psp_220_dcx_emepdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppeex02_ax_psp_220_uu_emepuu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppeex02_ax_psp_220_uc_emepuc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 25){ppeex02_ax_psp_220_udx_emepudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 27){ppeex02_ax_psp_220_uux_emepgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 28){ppeex02_ax_psp_220_uux_emepddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 29){ppeex02_ax_psp_220_uux_emepuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 30){ppeex02_ax_psp_220_uux_emepssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 31){ppeex02_ax_psp_220_uux_emepccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 32){ppeex02_ax_psp_220_usx_emepusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 34){ppeex02_ax_psp_220_ucx_emepucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 35){ppeex02_ax_psp_220_dxdx_emepdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 36){ppeex02_ax_psp_220_dxux_emepdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 37){ppeex02_ax_psp_220_dxsx_emepdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 38){ppeex02_ax_psp_220_dxcx_emepdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 40){ppeex02_ax_psp_220_uxux_emepuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 41){ppeex02_ax_psp_220_uxcx_emepuxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
