#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexexne04/header/ppeexexne04.phasespace.h"
void ppeexexne04_ax_psp_240_udx_emepepveccx(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexexne04_ax_psp_240_udx_emepepveccx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(28);
  psi_needed_v_smin[no_ps].resize(28);
  int needed_v_smin_0[] = {   0,    9,   10,   11,   12,   18,   19,   24,   25,   26,   27,   28,   38,   39,   46,   47,   48,   49,   50,   51,   58,   59,   60,   61,   62,   63}; //  26
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 26);
  int needed_v_smin_1[] = {   0,   28}; //   2
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   0,    5,   28,   29}; //   4
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {   0,    5,    6,    7,    8,   13,   14,   15,   16,   17,   18,   19,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 48);
  int needed_v_smin_4[] = {   1,    2,    3,    4,    5,    6,    7,   16,   17,   20,   21,   22,   23,   29,   30,   31,   36,   37,   40,   41,   42,   43,   44,   45,   52,   53,   54,   55,   56,   57}; //  30
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 30);
  int needed_v_smin_5[] = {   1,    2,   20,   21}; //   4
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 4);
  int needed_v_smin_6[] = {   1,    2,   20,   21}; //   4
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 4);
  int needed_v_smin_7[] = {   1,    2,    3,    4,    8,   16,   17,   20,   21,   22,   23,   32,   36,   37,   40,   41,   42,   43,   44,   45,   52,   53,   54,   55,   56,   57}; //  26
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 26);
  int needed_v_smin_8[] = {   3,    4,   22,   23}; //   4
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 4);
  int needed_v_smin_9[] = {   3,    4,   22,   23}; //   4
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 4);
  int needed_v_smin_10[] = {   5,   29}; //   2
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 2);
  int needed_v_smin_11[] = {   6,    7,   30,   31}; //   4
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 4);
  int needed_v_smin_12[] = {   6,    7,   14,   15,   30,   31,   34,   35}; //   8
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 8);
  int needed_v_smin_13[] = {   8,   32}; //   2
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 2);
  int needed_v_smin_14[] = {   8,   13,   32,   33}; //   4
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 4);
  int needed_v_smin_15[] = {   9,   10,   11,   12,   13,   14,   15,   18,   19,   24,   25,   26,   27,   33,   34,   35,   38,   39,   46,   47,   48,   49,   50,   51,   58,   59,   60,   61,   62,   63}; //  30
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 30);
  int needed_v_smin_16[] = {   9,   10,   24,   25}; //   4
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 4);
  int needed_v_smin_17[] = {   9,   10,   24,   25}; //   4
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 4);
  int needed_v_smin_18[] = {  11,   12,   26,   27}; //   4
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 4);
  int needed_v_smin_19[] = {  11,   12,   26,   27}; //   4
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 4);
  int needed_v_smin_20[] = {  13,   33}; //   2
  psi_needed_v_smin[no_ps][ 20] = get_vector_from_array_int(needed_v_smin_20, 2);
  int needed_v_smin_21[] = {  14,   15,   34,   35}; //   4
  psi_needed_v_smin[no_ps][ 21] = get_vector_from_array_int(needed_v_smin_21, 4);
  int needed_v_smin_22[] = {  16,   17,   36,   37,   44,   45,   56,   57}; //   8
  psi_needed_v_smin[no_ps][ 22] = get_vector_from_array_int(needed_v_smin_22, 8);
  int needed_v_smin_23[] = {  18,   19,   38,   39,   50,   51,   62,   63}; //   8
  psi_needed_v_smin[no_ps][ 23] = get_vector_from_array_int(needed_v_smin_23, 8);
  int needed_v_smin_24[] = {  40,   41,   42,   43}; //   4
  psi_needed_v_smin[no_ps][ 24] = get_vector_from_array_int(needed_v_smin_24, 4);
  int needed_v_smin_25[] = {  46,   47,   48,   49}; //   4
  psi_needed_v_smin[no_ps][ 25] = get_vector_from_array_int(needed_v_smin_25, 4);
  int needed_v_smin_26[] = {  52,   53,   54,   55}; //   4
  psi_needed_v_smin[no_ps][ 26] = get_vector_from_array_int(needed_v_smin_26, 4);
  int needed_v_smin_27[] = {  58,   59,   60,   61}; //   4
  psi_needed_v_smin[no_ps][ 27] = get_vector_from_array_int(needed_v_smin_27, 4);

  psi_v_smax[no_ps].resize(48);
  psi_needed_v_smax[no_ps].resize(48);
  int needed_v_smax_0[] = {   0,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51}; //  11
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 11);
  int needed_v_smax_1[] = {   0,    5}; //   2
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   0,    5,    6,    7,    8,   13,   14,   15,   16,   17,   18,   19}; //  12
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 12);
  int needed_v_smax_3[] = {   0,    5,    6,    7,    8,   13,   14,   15,   16,   17,   18,   19}; //  12
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 12);
  int needed_v_smax_4[] = {   1,    2,    3,    4,    5,    6,    7,   54,   55,   56,   57}; //  11
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 11);
  int needed_v_smax_5[] = {   1,    2}; //   2
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 2);
  int needed_v_smax_6[] = {   1,    2,    3,    4}; //   4
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 4);
  int needed_v_smax_7[] = {   1,    2,    3,    4}; //   4
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 4);
  int needed_v_smax_8[] = {   3,    4}; //   2
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 2);
  int needed_v_smax_9[] = {   6,    7,   14,   15}; //   4
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 4);
  int needed_v_smax_10[] = {   8,   16,   17,   20,   21,   22,   23,   42,   43,   44,   45}; //  11
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 11);
  int needed_v_smax_11[] = {   8,   13}; //   2
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 2);
  int needed_v_smax_12[] = {   9,   10,   11,   12,   13,   14,   15,   60,   61,   62,   63}; //  11
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 11);
  int needed_v_smax_13[] = {   9,   10}; //   2
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 2);
  int needed_v_smax_14[] = {   9,   10,   11,   12}; //   4
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 4);
  int needed_v_smax_15[] = {   9,   10,   11,   12}; //   4
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 4);
  int needed_v_smax_16[] = {  11,   12}; //   2
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 2);
  int needed_v_smax_17[] = {  16,   17,   20,   21,   22,   23,   44,   45}; //   8
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 8);
  int needed_v_smax_18[] = {  18,   19,   24,   25,   26,   27,   50,   51}; //   8
  psi_needed_v_smax[no_ps][ 18] = get_vector_from_array_int(needed_v_smax_18, 8);
  int needed_v_smax_19[] = {  20,   21}; //   2
  psi_needed_v_smax[no_ps][ 19] = get_vector_from_array_int(needed_v_smax_19, 2);
  int needed_v_smax_20[] = {  20,   21,   22,   23,   52,   53,   54,   55}; //   8
  psi_needed_v_smax[no_ps][ 20] = get_vector_from_array_int(needed_v_smax_20, 8);
  int needed_v_smax_21[] = {  22,   23}; //   2
  psi_needed_v_smax[no_ps][ 21] = get_vector_from_array_int(needed_v_smax_21, 2);
  int needed_v_smax_22[] = {  24,   25}; //   2
  psi_needed_v_smax[no_ps][ 22] = get_vector_from_array_int(needed_v_smax_22, 2);
  int needed_v_smax_23[] = {  24,   25,   26,   27,   58,   59,   60,   61}; //   8
  psi_needed_v_smax[no_ps][ 23] = get_vector_from_array_int(needed_v_smax_23, 8);
  int needed_v_smax_24[] = {  26,   27}; //   2
  psi_needed_v_smax[no_ps][ 24] = get_vector_from_array_int(needed_v_smax_24, 2);
  int needed_v_smax_25[] = {  28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   46,   47,   52,   53,   58,   59}; //  20
  psi_needed_v_smax[no_ps][ 25] = get_vector_from_array_int(needed_v_smax_25, 20);
  int needed_v_smax_26[] = {  28,   38,   39,   46,   47}; //   5
  psi_needed_v_smax[no_ps][ 26] = get_vector_from_array_int(needed_v_smax_26, 5);
  int needed_v_smax_27[] = {  28,   29}; //   2
  psi_needed_v_smax[no_ps][ 27] = get_vector_from_array_int(needed_v_smax_27, 2);
  int needed_v_smax_28[] = {  28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   44,   45,   50,   51,   56,   57,   62,   63}; //  20
  psi_needed_v_smax[no_ps][ 28] = get_vector_from_array_int(needed_v_smax_28, 20);
  int needed_v_smax_29[] = {  29,   30,   31,   52,   53}; //   5
  psi_needed_v_smax[no_ps][ 29] = get_vector_from_array_int(needed_v_smax_29, 5);
  int needed_v_smax_30[] = {  30,   31,   34,   35}; //   4
  psi_needed_v_smax[no_ps][ 30] = get_vector_from_array_int(needed_v_smax_30, 4);
  int needed_v_smax_31[] = {  32,   36,   37,   40,   41}; //   5
  psi_needed_v_smax[no_ps][ 31] = get_vector_from_array_int(needed_v_smax_31, 5);
  int needed_v_smax_32[] = {  32,   33}; //   2
  psi_needed_v_smax[no_ps][ 32] = get_vector_from_array_int(needed_v_smax_32, 2);
  int needed_v_smax_33[] = {  33,   34,   35,   58,   59}; //   5
  psi_needed_v_smax[no_ps][ 33] = get_vector_from_array_int(needed_v_smax_33, 5);
  int needed_v_smax_34[] = {  36,   37,   40,   41,   42,   43}; //   6
  psi_needed_v_smax[no_ps][ 34] = get_vector_from_array_int(needed_v_smax_34, 6);
  int needed_v_smax_35[] = {  38,   39,   46,   47,   48,   49}; //   6
  psi_needed_v_smax[no_ps][ 35] = get_vector_from_array_int(needed_v_smax_35, 6);
  int needed_v_smax_36[] = {  42,   43}; //   2
  psi_needed_v_smax[no_ps][ 36] = get_vector_from_array_int(needed_v_smax_36, 2);
  int needed_v_smax_37[] = {  44,   45,   56,   57}; //   4
  psi_needed_v_smax[no_ps][ 37] = get_vector_from_array_int(needed_v_smax_37, 4);
  int needed_v_smax_38[] = {  48,   49}; //   2
  psi_needed_v_smax[no_ps][ 38] = get_vector_from_array_int(needed_v_smax_38, 2);
  int needed_v_smax_39[] = {  50,   51,   62,   63}; //   4
  psi_needed_v_smax[no_ps][ 39] = get_vector_from_array_int(needed_v_smax_39, 4);
  int needed_v_smax_40[] = {  52,   53,   54,   55}; //   4
  psi_needed_v_smax[no_ps][ 40] = get_vector_from_array_int(needed_v_smax_40, 4);
  int needed_v_smax_41[] = {  54,   55}; //   2
  psi_needed_v_smax[no_ps][ 41] = get_vector_from_array_int(needed_v_smax_41, 2);
  int needed_v_smax_42[] = {  56,   57}; //   2
  psi_needed_v_smax[no_ps][ 42] = get_vector_from_array_int(needed_v_smax_42, 2);
  int needed_v_smax_43[] = {  58,   59,   60,   61}; //   4
  psi_needed_v_smax[no_ps][ 43] = get_vector_from_array_int(needed_v_smax_43, 4);
  int needed_v_smax_44[] = {  60,   61}; //   2
  psi_needed_v_smax[no_ps][ 44] = get_vector_from_array_int(needed_v_smax_44, 2);
  int needed_v_smax_45[] = {  62,   63}; //   2
  psi_needed_v_smax[no_ps][ 45] = get_vector_from_array_int(needed_v_smax_45, 2);
  int needed_v_smax_46[] = {  40,   41,   42,   43}; //   4
  psi_needed_v_smax[no_ps][ 46] = get_vector_from_array_int(needed_v_smax_46, 4);
  int needed_v_smax_47[] = {  46,   47,   48,   49}; //   4
  psi_needed_v_smax[no_ps][ 47] = get_vector_from_array_int(needed_v_smax_47, 4);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(72);
  psi_needed_g_p[no_ps].resize(72);
  int needed_g_p_0[] = {   0,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51}; //  11
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 11);
  psi_container_IS_name.push_back("propagator_24_smin0_smax0");
  int needed_g_p_1[] = {   0}; //   1
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 1);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,    5}; //   2
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 2);
  psi_container_IS_name.push_back("propagator_24_smin2_smax2");
  int needed_g_p_3[] = {   0,    5,    6,    7,    8,   13,   14,   15,   16,   17,   18,   19}; //  12
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 12);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_4[] = {   1,    3,    6,   54,   56}; //   5
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 5);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_5[] = {   1,    2}; //   2
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax5");
  int needed_g_p_6[] = {   1,    2}; //   2
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 2);
  psi_container_IS_name.push_back("propagator_0_smin6_smax6");
  int needed_g_p_7[] = {   1,    2,    3,    4}; //   4
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 4);
  psi_container_IS_name.push_back("propagator_24_smin7_smax7");
  int needed_g_p_8[] = {   2,    4,    5,    7,   55,   57}; //   6
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 6);
  psi_container_IS_name.push_back("propagator_23_smin4_smax4");
  int needed_g_p_9[] = {   3,    4}; //   2
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax8");
  int needed_g_p_10[] = {   3,    4}; //   2
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 2);
  psi_container_IS_name.push_back("propagator_0_smin9_smax6");
  int needed_g_p_11[] = {   5}; //   1
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 1);
  psi_container_IS_name.push_back("propagator_0_smin10_smax1");
  int needed_g_p_12[] = {   6,    7}; //   2
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 2);
  psi_container_IS_name.push_back("propagator_0_smin11_smax9");
  int needed_g_p_13[] = {   6,    7,   14,   15}; //   4
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 4);
  psi_container_IS_name.push_back("propagator_24_smin12_smax2");
  int needed_g_p_14[] = {   8,   16,   17,   20,   21,   22,   23,   42,   43,   44,   45}; //  11
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 11);
  psi_container_IS_name.push_back("propagator_24_smin7_smax10");
  int needed_g_p_15[] = {   8}; //   1
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 1);
  psi_container_IS_name.push_back("propagator_0_smin13_smax11");
  int needed_g_p_16[] = {   8,   13}; //   2
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 2);
  psi_container_IS_name.push_back("propagator_24_smin14_smax2");
  int needed_g_p_17[] = {   9,   11,   14,   60,   62}; //   5
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 5);
  psi_container_IS_name.push_back("propagator_0_smin15_smax12");
  int needed_g_p_18[] = {   9,   10}; //   2
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 2);
  psi_container_IS_name.push_back("propagator_0_smin16_smax13");
  int needed_g_p_19[] = {   9,   10}; //   2
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 2);
  psi_container_IS_name.push_back("propagator_0_smin17_smax14");
  int needed_g_p_20[] = {   9,   10,   11,   12}; //   4
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 4);
  psi_container_IS_name.push_back("propagator_24_smin0_smax15");
  int needed_g_p_21[] = {  10,   12,   13,   15,   61,   63}; //   6
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 6);
  psi_container_IS_name.push_back("propagator_23_smin15_smax12");
  int needed_g_p_22[] = {  11,   12}; //   2
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 2);
  psi_container_IS_name.push_back("propagator_0_smin18_smax16");
  int needed_g_p_23[] = {  11,   12}; //   2
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 2);
  psi_container_IS_name.push_back("propagator_0_smin19_smax14");
  int needed_g_p_24[] = {  13}; //   1
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 1);
  psi_container_IS_name.push_back("propagator_0_smin20_smax11");
  int needed_g_p_25[] = {  14,   15}; //   2
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 2);
  psi_container_IS_name.push_back("propagator_0_smin21_smax9");
  int needed_g_p_26[] = {  16,   20,   22,   44}; //   4
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 4);
  psi_container_IS_name.push_back("propagator_0_smin4_smax17");
  int needed_g_p_27[] = {  16,   17}; //   2
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 2);
  psi_container_IS_name.push_back("propagator_24_smin22_smax2");
  int needed_g_p_28[] = {  17,   21,   23,   45}; //   4
  psi_needed_g_p[no_ps][28] = get_vector_from_array_int(needed_g_p_28, 4);
  psi_container_IS_name.push_back("propagator_23_smin4_smax17");
  int needed_g_p_29[] = {  18,   24,   26,   50}; //   4
  psi_needed_g_p[no_ps][29] = get_vector_from_array_int(needed_g_p_29, 4);
  psi_container_IS_name.push_back("propagator_0_smin15_smax18");
  int needed_g_p_30[] = {  18,   19}; //   2
  psi_needed_g_p[no_ps][30] = get_vector_from_array_int(needed_g_p_30, 2);
  psi_container_IS_name.push_back("propagator_24_smin23_smax2");
  int needed_g_p_31[] = {  19,   25,   27,   51}; //   4
  psi_needed_g_p[no_ps][31] = get_vector_from_array_int(needed_g_p_31, 4);
  psi_container_IS_name.push_back("propagator_23_smin15_smax18");
  int needed_g_p_32[] = {  20,   21}; //   2
  psi_needed_g_p[no_ps][32] = get_vector_from_array_int(needed_g_p_32, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax19");
  int needed_g_p_33[] = {  20,   21}; //   2
  psi_needed_g_p[no_ps][33] = get_vector_from_array_int(needed_g_p_33, 2);
  psi_container_IS_name.push_back("propagator_0_smin6_smax20");
  int needed_g_p_34[] = {  22,   23}; //   2
  psi_needed_g_p[no_ps][34] = get_vector_from_array_int(needed_g_p_34, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax21");
  int needed_g_p_35[] = {  22,   23}; //   2
  psi_needed_g_p[no_ps][35] = get_vector_from_array_int(needed_g_p_35, 2);
  psi_container_IS_name.push_back("propagator_0_smin9_smax20");
  int needed_g_p_36[] = {  24,   25}; //   2
  psi_needed_g_p[no_ps][36] = get_vector_from_array_int(needed_g_p_36, 2);
  psi_container_IS_name.push_back("propagator_0_smin16_smax22");
  int needed_g_p_37[] = {  24,   25}; //   2
  psi_needed_g_p[no_ps][37] = get_vector_from_array_int(needed_g_p_37, 2);
  psi_container_IS_name.push_back("propagator_0_smin17_smax23");
  int needed_g_p_38[] = {  26,   27}; //   2
  psi_needed_g_p[no_ps][38] = get_vector_from_array_int(needed_g_p_38, 2);
  psi_container_IS_name.push_back("propagator_0_smin18_smax24");
  int needed_g_p_39[] = {  26,   27}; //   2
  psi_needed_g_p[no_ps][39] = get_vector_from_array_int(needed_g_p_39, 2);
  psi_container_IS_name.push_back("propagator_0_smin19_smax23");
  int needed_g_p_40[] = {  28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   46,   47,   52,   53,   58,   59}; //  20
  psi_needed_g_p[no_ps][40] = get_vector_from_array_int(needed_g_p_40, 20);
  psi_container_IS_name.push_back("propagator_0_smin3_smax25");
  int needed_g_p_41[] = {  28,   38,   39,   46,   47}; //   5
  psi_needed_g_p[no_ps][41] = get_vector_from_array_int(needed_g_p_41, 5);
  psi_container_IS_name.push_back("propagator_24_smin0_smax26");
  int needed_g_p_42[] = {  28}; //   1
  psi_needed_g_p[no_ps][42] = get_vector_from_array_int(needed_g_p_42, 1);
  psi_container_IS_name.push_back("propagator_0_smin1_smax27");
  int needed_g_p_43[] = {  28,   29}; //   2
  psi_needed_g_p[no_ps][43] = get_vector_from_array_int(needed_g_p_43, 2);
  psi_container_IS_name.push_back("propagator_24_smin2_smax28");
  int needed_g_p_44[] = {  29,   31,   53}; //   3
  psi_needed_g_p[no_ps][44] = get_vector_from_array_int(needed_g_p_44, 3);
  psi_container_IS_name.push_back("propagator_23_smin4_smax29");
  int needed_g_p_45[] = {  29}; //   1
  psi_needed_g_p[no_ps][45] = get_vector_from_array_int(needed_g_p_45, 1);
  psi_container_IS_name.push_back("propagator_0_smin10_smax27");
  int needed_g_p_46[] = {  30,   52}; //   2
  psi_needed_g_p[no_ps][46] = get_vector_from_array_int(needed_g_p_46, 2);
  psi_container_IS_name.push_back("propagator_0_smin4_smax29");
  int needed_g_p_47[] = {  30,   31}; //   2
  psi_needed_g_p[no_ps][47] = get_vector_from_array_int(needed_g_p_47, 2);
  psi_container_IS_name.push_back("propagator_0_smin11_smax30");
  int needed_g_p_48[] = {  30,   31,   34,   35}; //   4
  psi_needed_g_p[no_ps][48] = get_vector_from_array_int(needed_g_p_48, 4);
  psi_container_IS_name.push_back("propagator_24_smin12_smax28");
  int needed_g_p_49[] = {  32,   36,   37,   40,   41}; //   5
  psi_needed_g_p[no_ps][49] = get_vector_from_array_int(needed_g_p_49, 5);
  psi_container_IS_name.push_back("propagator_24_smin7_smax31");
  int needed_g_p_50[] = {  32}; //   1
  psi_needed_g_p[no_ps][50] = get_vector_from_array_int(needed_g_p_50, 1);
  psi_container_IS_name.push_back("propagator_0_smin13_smax32");
  int needed_g_p_51[] = {  32,   33}; //   2
  psi_needed_g_p[no_ps][51] = get_vector_from_array_int(needed_g_p_51, 2);
  psi_container_IS_name.push_back("propagator_24_smin14_smax28");
  int needed_g_p_52[] = {  33,   35,   59}; //   3
  psi_needed_g_p[no_ps][52] = get_vector_from_array_int(needed_g_p_52, 3);
  psi_container_IS_name.push_back("propagator_23_smin15_smax33");
  int needed_g_p_53[] = {  33}; //   1
  psi_needed_g_p[no_ps][53] = get_vector_from_array_int(needed_g_p_53, 1);
  psi_container_IS_name.push_back("propagator_0_smin20_smax32");
  int needed_g_p_54[] = {  34,   58}; //   2
  psi_needed_g_p[no_ps][54] = get_vector_from_array_int(needed_g_p_54, 2);
  psi_container_IS_name.push_back("propagator_0_smin15_smax33");
  int needed_g_p_55[] = {  34,   35}; //   2
  psi_needed_g_p[no_ps][55] = get_vector_from_array_int(needed_g_p_55, 2);
  psi_container_IS_name.push_back("propagator_0_smin21_smax30");
  int needed_g_p_56[] = {  36,   40,   42}; //   3
  psi_needed_g_p[no_ps][56] = get_vector_from_array_int(needed_g_p_56, 3);
  psi_container_IS_name.push_back("propagator_0_smin4_smax34");
  int needed_g_p_57[] = {  36,   37}; //   2
  psi_needed_g_p[no_ps][57] = get_vector_from_array_int(needed_g_p_57, 2);
  psi_container_IS_name.push_back("propagator_24_smin22_smax28");
  int needed_g_p_58[] = {  37,   41,   43}; //   3
  psi_needed_g_p[no_ps][58] = get_vector_from_array_int(needed_g_p_58, 3);
  psi_container_IS_name.push_back("propagator_23_smin4_smax34");
  int needed_g_p_59[] = {  38,   46,   48}; //   3
  psi_needed_g_p[no_ps][59] = get_vector_from_array_int(needed_g_p_59, 3);
  psi_container_IS_name.push_back("propagator_0_smin15_smax35");
  int needed_g_p_60[] = {  38,   39}; //   2
  psi_needed_g_p[no_ps][60] = get_vector_from_array_int(needed_g_p_60, 2);
  psi_container_IS_name.push_back("propagator_24_smin23_smax28");
  int needed_g_p_61[] = {  39,   47,   49}; //   3
  psi_needed_g_p[no_ps][61] = get_vector_from_array_int(needed_g_p_61, 3);
  psi_container_IS_name.push_back("propagator_23_smin15_smax35");
  int needed_g_p_62[] = {  42,   43}; //   2
  psi_needed_g_p[no_ps][62] = get_vector_from_array_int(needed_g_p_62, 2);
  psi_container_IS_name.push_back("propagator_0_smin3_smax36");
  int needed_g_p_63[] = {  44,   45,   56,   57}; //   4
  psi_needed_g_p[no_ps][63] = get_vector_from_array_int(needed_g_p_63, 4);
  psi_container_IS_name.push_back("propagator_0_smin3_smax37");
  int needed_g_p_64[] = {  48,   49}; //   2
  psi_needed_g_p[no_ps][64] = get_vector_from_array_int(needed_g_p_64, 2);
  psi_container_IS_name.push_back("propagator_0_smin3_smax38");
  int needed_g_p_65[] = {  50,   51,   62,   63}; //   4
  psi_needed_g_p[no_ps][65] = get_vector_from_array_int(needed_g_p_65, 4);
  psi_container_IS_name.push_back("propagator_0_smin3_smax39");
  int needed_g_p_66[] = {  52,   53,   54,   55}; //   4
  psi_needed_g_p[no_ps][66] = get_vector_from_array_int(needed_g_p_66, 4);
  psi_container_IS_name.push_back("propagator_24_smin7_smax40");
  int needed_g_p_67[] = {  54,   55}; //   2
  psi_needed_g_p[no_ps][67] = get_vector_from_array_int(needed_g_p_67, 2);
  psi_container_IS_name.push_back("propagator_0_smin3_smax41");
  int needed_g_p_68[] = {  56,   57}; //   2
  psi_needed_g_p[no_ps][68] = get_vector_from_array_int(needed_g_p_68, 2);
  psi_container_IS_name.push_back("propagator_24_smin7_smax42");
  int needed_g_p_69[] = {  58,   59,   60,   61}; //   4
  psi_needed_g_p[no_ps][69] = get_vector_from_array_int(needed_g_p_69, 4);
  psi_container_IS_name.push_back("propagator_24_smin0_smax43");
  int needed_g_p_70[] = {  60,   61}; //   2
  psi_needed_g_p[no_ps][70] = get_vector_from_array_int(needed_g_p_70, 2);
  psi_container_IS_name.push_back("propagator_0_smin3_smax44");
  int needed_g_p_71[] = {  62,   63}; //   2
  psi_needed_g_p[no_ps][71] = get_vector_from_array_int(needed_g_p_71, 2);
  psi_container_IS_name.push_back("propagator_24_smin0_smax45");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(6);
  psi_needed_g_f[no_ps].resize(6);
  int needed_g_f_0[] = {  40,   41,   42,   43}; //   4
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin24_smax46");
  int needed_g_f_1[] = {  44,   45,   56,   57}; //   4
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin22_smax28");
  int needed_g_f_2[] = {  46,   47,   48,   49}; //   4
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin25_smax47");
  int needed_g_f_3[] = {  50,   51,   62,   63}; //   4
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin23_smax28");
  int needed_g_f_4[] = {  52,   53,   54,   55}; //   4
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin26_smax20");
  int needed_g_f_5[] = {  58,   59,   60,   61}; //   4
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin27_smax23");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(20);
  psi_needed_g_t[no_ps].resize(20);
  int needed_g_t_0[] = {   0,    5,    6,    7,    8,   13,   14,   15,   16,   17,   18,   19,   44,   45,   50,   51,   56,   57,   62,   63}; //  20
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 20);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__192_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__192_60");
  int needed_g_t_1[] = {   1,    2,    3,    4,   52,   53,   54,   55}; //   8
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_204");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_204");
  int needed_g_t_2[] = {   9,   10,   11,   12,   58,   59,   60,   61}; //   8
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__40_212");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__40_212");
  int needed_g_t_3[] = {  20,   21,   22,   23}; //   4
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__48_204");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__48_204");
  int needed_g_t_4[] = {  24,   25,   26,   27}; //   4
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__40_212");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__40_212");
  int needed_g_t_5[] = {  28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  12
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 12);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__192_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__192_60");
  int needed_g_t_6[] = {  40,   41,   42,   43}; //   4
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__12_240");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__12_240");
  int needed_g_t_7[] = {  40,   41}; //   2
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__192_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__192_48");
  int needed_g_t_8[] = {  42,   43}; //   2
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__48_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__48_192");
  int needed_g_t_9[] = {  44,   45}; //   2
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__48_12");
  int needed_g_t_10[] = {  46,   47,   48,   49}; //   4
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__20_232");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__20_232");
  int needed_g_t_11[] = {  46,   47}; //   2
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_21__192_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_21__192_40");
  int needed_g_t_12[] = {  48,   49}; //   2
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_21__40_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_21__40_192");
  int needed_g_t_13[] = {  50,   51}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__40_20");
  int needed_g_t_14[] = {  52,   53}; //   2
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_49__192_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_49__192_12");
  int needed_g_t_15[] = {  54,   55}; //   2
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_49__12_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_49__12_192");
  int needed_g_t_16[] = {  56,   57}; //   2
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__12_48");
  int needed_g_t_17[] = {  58,   59}; //   2
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_41__192_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_41__192_20");
  int needed_g_t_18[] = {  60,   61}; //   2
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_41__20_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_41__20_192");
  int needed_g_t_19[] = {  62,   63}; //   2
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__20_40");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(24);
  psi_needed_g_d[no_ps].resize(24);
  int needed_g_d_0[] = {   0,    5,    6,    7,    8,   13,   14,   15,   16,   17,   18,   19,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 48);
  psi_container_IS_name.push_back("costheta_of_decay_192__64_128");
  psi_container_IS_name.push_back("phi_of_decay_192__64_128");
  int needed_g_d_1[] = {   0,    5,   28,   29}; //   4
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_2[] = {   0,   28}; //   2
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 2);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_3[] = {   0,    9,   10,   11,   12,   18,   19,   24,   25,   26,   27,   28,   38,   39,   46,   47,   48,   49,   50,   51,   58,   59,   60,   61,   62,   63}; //  26
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 26);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_4[] = {   1,    2,    3,    4,    8,   16,   17,   20,   21,   22,   23,   32,   36,   37,   40,   41,   42,   43,   44,   45,   52,   53,   54,   55,   56,   57}; //  26
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 26);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_5[] = {   1,    2,   20,   21}; //   4
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 4);
  psi_container_IS_name.push_back("costheta_of_decay_204__64_140");
  psi_container_IS_name.push_back("phi_of_decay_204__64_140");
  int needed_g_d_6[] = {   1,    2,   20,   21}; //   4
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 4);
  psi_container_IS_name.push_back("costheta_of_decay_140__128_12");
  psi_container_IS_name.push_back("phi_of_decay_140__128_12");
  int needed_g_d_7[] = {   1,    2,    3,    4,    5,    6,    7,   16,   17,   20,   21,   22,   23,   29,   30,   31,   36,   37,   40,   41,   42,   43,   44,   45,   52,   53,   54,   55,   56,   57}; //  30
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 30);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_8[] = {   3,    4,   22,   23}; //   4
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 4);
  psi_container_IS_name.push_back("costheta_of_decay_204__128_76");
  psi_container_IS_name.push_back("phi_of_decay_204__128_76");
  int needed_g_d_9[] = {   3,    4,   22,   23}; //   4
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 4);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_10[] = {   5,   29}; //   2
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 2);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_11[] = {   6,    7,   14,   15,   30,   31,   34,   35}; //   8
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_12[] = {   6,    7,   30,   31}; //   4
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_13[] = {   8,   13,   32,   33}; //   4
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_14[] = {   8,   32}; //   2
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 2);
  psi_container_IS_name.push_back("costheta_of_decay_52__4_48");
  psi_container_IS_name.push_back("phi_of_decay_52__4_48");
  int needed_g_d_15[] = {   9,   10,   24,   25}; //   4
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 4);
  psi_container_IS_name.push_back("costheta_of_decay_212__64_148");
  psi_container_IS_name.push_back("phi_of_decay_212__64_148");
  int needed_g_d_16[] = {   9,   10,   24,   25}; //   4
  psi_needed_g_d[no_ps][16] = get_vector_from_array_int(needed_g_d_16, 4);
  psi_container_IS_name.push_back("costheta_of_decay_148__128_20");
  psi_container_IS_name.push_back("phi_of_decay_148__128_20");
  int needed_g_d_17[] = {   9,   10,   11,   12,   13,   14,   15,   18,   19,   24,   25,   26,   27,   33,   34,   35,   38,   39,   46,   47,   48,   49,   50,   51,   58,   59,   60,   61,   62,   63}; //  30
  psi_needed_g_d[no_ps][17] = get_vector_from_array_int(needed_g_d_17, 30);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_18[] = {  11,   12,   26,   27}; //   4
  psi_needed_g_d[no_ps][18] = get_vector_from_array_int(needed_g_d_18, 4);
  psi_container_IS_name.push_back("costheta_of_decay_212__128_84");
  psi_container_IS_name.push_back("phi_of_decay_212__128_84");
  int needed_g_d_19[] = {  11,   12,   26,   27}; //   4
  psi_needed_g_d[no_ps][19] = get_vector_from_array_int(needed_g_d_19, 4);
  psi_container_IS_name.push_back("costheta_of_decay_84__64_20");
  psi_container_IS_name.push_back("phi_of_decay_84__64_20");
  int needed_g_d_20[] = {  13,   33}; //   2
  psi_needed_g_d[no_ps][20] = get_vector_from_array_int(needed_g_d_20, 2);
  psi_container_IS_name.push_back("costheta_of_decay_52__32_20");
  psi_container_IS_name.push_back("phi_of_decay_52__32_20");
  int needed_g_d_21[] = {  14,   15,   34,   35}; //   4
  psi_needed_g_d[no_ps][21] = get_vector_from_array_int(needed_g_d_21, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_22[] = {  16,   17,   36,   37}; //   4
  psi_needed_g_d[no_ps][22] = get_vector_from_array_int(needed_g_d_22, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_23[] = {  18,   19,   38,   39}; //   4
  psi_needed_g_d[no_ps][23] = get_vector_from_array_int(needed_g_d_23, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__20_40");
  psi_container_IS_name.push_back("phi_of_decay_60__20_40");

  psi_c_p[no_ps].resize(64);
  psi_c_f[no_ps].resize(64);
  psi_c_t[no_ps].resize(64);
  psi_c_d[no_ps].resize(64);

  int c_p_0[] = {  0,   1,   2,   3}; //   4
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 4);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {  0}; //   1
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 1);
  int c_d_0[] = {  0,   1,   2,   3}; //   4
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 4);

  int c_p_1[] = {  4,   5,   6,   7}; //   4
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 4);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {  1}; //   1
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 1);
  int c_d_1[] = {  4,   5,   6,   7}; //   4
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 4);

  int c_p_2[] = {  8,   5,   6,   7}; //   4
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 4);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {  1}; //   1
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 1);
  int c_d_2[] = {  4,   5,   6,   7}; //   4
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 4);

  int c_p_3[] = {  4,   9,  10,   7}; //   4
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 4);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {  1}; //   1
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 1);
  int c_d_3[] = {  4,   8,   9,   7}; //   4
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 4);

  int c_p_4[] = {  8,   9,  10,   7}; //   4
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 4);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {  1}; //   1
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 1);
  int c_d_4[] = {  4,   8,   9,   7}; //   4
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 4);

  int c_p_5[] = {  8,  11,   2,   3}; //   4
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 4);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {  0}; //   1
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 1);
  int c_d_5[] = {  0,   1,  10,   7}; //   4
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 4);

  int c_p_6[] = {  4,  12,  13,   3}; //   4
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 4);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {  0}; //   1
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 1);
  int c_d_6[] = {  0,  11,  12,   7}; //   4
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 4);

  int c_p_7[] = {  8,  12,  13,   3}; //   4
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 4);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  0}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  0,  11,  12,   7}; //   4
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 4);

  int c_p_8[] = { 14,  15,  16,   3}; //   4
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 4);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {  0}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = {  0,  13,  14,   4}; //   4
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 4);

  int c_p_9[] = { 17,  18,  19,  20}; //   4
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 4);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  2}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  3,  15,  16,  17}; //   4
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 4);

  int c_p_10[] = { 21,  18,  19,  20}; //   4
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 4);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  2}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  3,  15,  16,  17}; //   4
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 4);

  int c_p_11[] = { 17,  22,  23,  20}; //   4
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 4);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  2}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  3,  18,  19,  17}; //   4
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 4);

  int c_p_12[] = { 21,  22,  23,  20}; //   4
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 4);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  2}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  3,  18,  19,  17}; //   4
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 4);

  int c_p_13[] = { 21,  24,  16,   3}; //   4
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 4);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  0}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  0,  13,  20,  17}; //   4
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 4);

  int c_p_14[] = { 17,  25,  13,   3}; //   4
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 4);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  0}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  0,  11,  21,  17}; //   4
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 4);

  int c_p_15[] = { 21,  25,  13,   3}; //   4
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 4);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  0}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  0,  11,  21,  17}; //   4
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 4);

  int c_p_16[] = { 14,  26,  27,   3}; //   4
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 4);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {  0}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = {  0,  22,   7,   4}; //   4
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 4);

  int c_p_17[] = { 14,  28,  27,   3}; //   4
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 4);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {  0}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = {  0,  22,   7,   4}; //   4
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 4);

  int c_p_18[] = {  0,  29,  30,   3}; //   4
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 4);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {  0}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = {  0,  23,  17,   3}; //   4
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 4);

  int c_p_19[] = {  0,  31,  30,   3}; //   4
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 4);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {  0}; //   1
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 1);
  int c_d_19[] = {  0,  23,  17,   3}; //   4
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 4);

  int c_p_20[] = { 14,  26,  32,  33}; //   4
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 4);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {  3}; //   1
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 1);
  int c_d_20[] = {  5,   6,   7,   4}; //   4
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 4);

  int c_p_21[] = { 14,  28,  32,  33}; //   4
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 4);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {  3}; //   1
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 1);
  int c_d_21[] = {  5,   6,   7,   4}; //   4
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 4);

  int c_p_22[] = { 14,  26,  34,  35}; //   4
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 4);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {  3}; //   1
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 1);
  int c_d_22[] = {  8,   9,   7,   4}; //   4
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 4);

  int c_p_23[] = { 14,  28,  34,  35}; //   4
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 4);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {  3}; //   1
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 1);
  int c_d_23[] = {  8,   9,   7,   4}; //   4
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 4);

  int c_p_24[] = {  0,  29,  36,  37}; //   4
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 4);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {  4}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = { 15,  16,  17,   3}; //   4
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 4);

  int c_p_25[] = {  0,  31,  36,  37}; //   4
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 4);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {  4}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = { 15,  16,  17,   3}; //   4
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 4);

  int c_p_26[] = {  0,  29,  38,  39}; //   4
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 4);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {  4}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = { 18,  19,  17,   3}; //   4
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 4);

  int c_p_27[] = {  0,  31,  38,  39}; //   4
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 4);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {  4}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = { 18,  19,  17,   3}; //   4
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 4);

  int c_p_28[] = { 40,  41,  42,  43}; //   4
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 4);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {  5}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = {  1,   2,   3,   0}; //   4
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 4);

  int c_p_29[] = { 40,  44,  45,  43}; //   4
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 4);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {  5}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = {  1,  10,   7,   0}; //   4
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 4);

  int c_p_30[] = { 40,  46,  47,  48}; //   4
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 4);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {  5}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = { 11,  12,   7,   0}; //   4
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 4);

  int c_p_31[] = { 40,  44,  47,  48}; //   4
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 4);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {  5}; //   1
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 1);
  int c_d_31[] = { 11,  12,   7,   0}; //   4
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 4);

  int c_p_32[] = { 40,  49,  50,  51}; //   4
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 4);
  int c_f_32[] = {}; //   0
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 0);
  int c_t_32[] = {  5}; //   1
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 1);
  int c_d_32[] = { 13,  14,   4,   0}; //   4
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 4);

  int c_p_33[] = { 40,  52,  53,  51}; //   4
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 4);
  int c_f_33[] = {}; //   0
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 0);
  int c_t_33[] = {  5}; //   1
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 1);
  int c_d_33[] = { 13,  20,  17,   0}; //   4
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 4);

  int c_p_34[] = { 40,  54,  55,  48}; //   4
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 4);
  int c_f_34[] = {}; //   0
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 0);
  int c_t_34[] = {  5}; //   1
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 1);
  int c_d_34[] = { 11,  21,  17,   0}; //   4
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 4);

  int c_p_35[] = { 40,  52,  55,  48}; //   4
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 4);
  int c_f_35[] = {}; //   0
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 0);
  int c_t_35[] = {  5}; //   1
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 1);
  int c_d_35[] = { 11,  21,  17,   0}; //   4
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 4);

  int c_p_36[] = { 40,  49,  56,  57}; //   4
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 4);
  int c_f_36[] = {}; //   0
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 0);
  int c_t_36[] = {  5}; //   1
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 1);
  int c_d_36[] = { 22,   7,   4,   0}; //   4
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 4);

  int c_p_37[] = { 40,  49,  58,  57}; //   4
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 4);
  int c_f_37[] = {}; //   0
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 0);
  int c_t_37[] = {  5}; //   1
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 1);
  int c_d_37[] = { 22,   7,   4,   0}; //   4
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 4);

  int c_p_38[] = { 40,  41,  59,  60}; //   4
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 4);
  int c_f_38[] = {}; //   0
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 0);
  int c_t_38[] = {  5}; //   1
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 1);
  int c_d_38[] = { 23,  17,   3,   0}; //   4
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 4);

  int c_p_39[] = { 40,  41,  61,  60}; //   4
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 4);
  int c_f_39[] = {}; //   0
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 0);
  int c_t_39[] = {  5}; //   1
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 1);
  int c_d_39[] = { 23,  17,   3,   0}; //   4
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 4);

  int c_p_40[] = { 40,  49,  56}; //   3
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 3);
  int c_f_40[] = {  0}; //   1
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 1);
  int c_t_40[] = {  6,   7}; //   2
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 2);
  int c_d_40[] = {  7,   4,   0}; //   3
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 3);

  int c_p_41[] = { 40,  49,  58}; //   3
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 3);
  int c_f_41[] = {  0}; //   1
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 1);
  int c_t_41[] = {  6,   7}; //   2
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 2);
  int c_d_41[] = {  7,   4,   0}; //   3
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 3);

  int c_p_42[] = { 14,  62,  56}; //   3
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 3);
  int c_f_42[] = {  0}; //   1
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 1);
  int c_t_42[] = {  6,   8}; //   2
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 2);
  int c_d_42[] = {  7,   0,   4}; //   3
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 3);

  int c_p_43[] = { 14,  62,  58}; //   3
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 3);
  int c_f_43[] = {  0}; //   1
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 1);
  int c_t_43[] = {  6,   8}; //   2
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 2);
  int c_d_43[] = {  7,   0,   4}; //   3
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 3);

  int c_p_44[] = { 14,  26,  63}; //   3
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 3);
  int c_f_44[] = {  1}; //   1
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 1);
  int c_t_44[] = {  0,   9}; //   2
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 2);
  int c_d_44[] = {  0,   7,   4}; //   3
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 3);

  int c_p_45[] = { 14,  28,  63}; //   3
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 3);
  int c_f_45[] = {  1}; //   1
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 1);
  int c_t_45[] = {  0,   9}; //   2
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 2);
  int c_d_45[] = {  0,   7,   4}; //   3
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 3);

  int c_p_46[] = { 40,  41,  59}; //   3
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 3);
  int c_f_46[] = {  2}; //   1
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 1);
  int c_t_46[] = { 10,  11}; //   2
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 2);
  int c_d_46[] = { 17,   3,   0}; //   3
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 3);

  int c_p_47[] = { 40,  41,  61}; //   3
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 3);
  int c_f_47[] = {  2}; //   1
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 1);
  int c_t_47[] = { 10,  11}; //   2
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 2);
  int c_d_47[] = { 17,   3,   0}; //   3
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 3);

  int c_p_48[] = {  0,  64,  59}; //   3
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 3);
  int c_f_48[] = {  2}; //   1
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 1);
  int c_t_48[] = { 10,  12}; //   2
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 2);
  int c_d_48[] = { 17,   0,   3}; //   3
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 3);

  int c_p_49[] = {  0,  64,  61}; //   3
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 3);
  int c_f_49[] = {  2}; //   1
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 1);
  int c_t_49[] = { 10,  12}; //   2
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 2);
  int c_d_49[] = { 17,   0,   3}; //   3
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 3);

  int c_p_50[] = {  0,  29,  65}; //   3
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 3);
  int c_f_50[] = {  3}; //   1
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 1);
  int c_t_50[] = {  0,  13}; //   2
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 2);
  int c_d_50[] = {  0,  17,   3}; //   3
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 3);

  int c_p_51[] = {  0,  31,  65}; //   3
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 3);
  int c_f_51[] = {  3}; //   1
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 1);
  int c_t_51[] = {  0,  13}; //   2
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 2);
  int c_d_51[] = {  0,  17,   3}; //   3
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 3);

  int c_p_52[] = { 40,  46,  66}; //   3
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 3);
  int c_f_52[] = {  4}; //   1
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 1);
  int c_t_52[] = {  1,  14}; //   2
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 2);
  int c_d_52[] = {  4,   7,   0}; //   3
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 3);

  int c_p_53[] = { 40,  44,  66}; //   3
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 3);
  int c_f_53[] = {  4}; //   1
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 1);
  int c_t_53[] = {  1,  14}; //   2
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 2);
  int c_d_53[] = {  4,   7,   0}; //   3
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 3);

  int c_p_54[] = {  4,  67,  66}; //   3
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 3);
  int c_f_54[] = {  4}; //   1
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 1);
  int c_t_54[] = {  1,  15}; //   2
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 2);
  int c_d_54[] = {  4,   0,   7}; //   3
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 3);

  int c_p_55[] = {  8,  67,  66}; //   3
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 3);
  int c_f_55[] = {  4}; //   1
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 1);
  int c_t_55[] = {  1,  15}; //   2
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 2);
  int c_d_55[] = {  4,   0,   7}; //   3
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 3);

  int c_p_56[] = {  4,  68,  63}; //   3
  psi_c_p[no_ps][56] = get_vector_from_array_int(c_p_56, 3);
  int c_f_56[] = {  1}; //   1
  psi_c_f[no_ps][56] = get_vector_from_array_int(c_f_56, 1);
  int c_t_56[] = {  0,  16}; //   2
  psi_c_t[no_ps][56] = get_vector_from_array_int(c_t_56, 2);
  int c_d_56[] = {  0,   4,   7}; //   3
  psi_c_d[no_ps][56] = get_vector_from_array_int(c_d_56, 3);

  int c_p_57[] = {  8,  68,  63}; //   3
  psi_c_p[no_ps][57] = get_vector_from_array_int(c_p_57, 3);
  int c_f_57[] = {  1}; //   1
  psi_c_f[no_ps][57] = get_vector_from_array_int(c_f_57, 1);
  int c_t_57[] = {  0,  16}; //   2
  psi_c_t[no_ps][57] = get_vector_from_array_int(c_t_57, 2);
  int c_d_57[] = {  0,   4,   7}; //   3
  psi_c_d[no_ps][57] = get_vector_from_array_int(c_d_57, 3);

  int c_p_58[] = { 40,  54,  69}; //   3
  psi_c_p[no_ps][58] = get_vector_from_array_int(c_p_58, 3);
  int c_f_58[] = {  5}; //   1
  psi_c_f[no_ps][58] = get_vector_from_array_int(c_f_58, 1);
  int c_t_58[] = {  2,  17}; //   2
  psi_c_t[no_ps][58] = get_vector_from_array_int(c_t_58, 2);
  int c_d_58[] = {  3,  17,   0}; //   3
  psi_c_d[no_ps][58] = get_vector_from_array_int(c_d_58, 3);

  int c_p_59[] = { 40,  52,  69}; //   3
  psi_c_p[no_ps][59] = get_vector_from_array_int(c_p_59, 3);
  int c_f_59[] = {  5}; //   1
  psi_c_f[no_ps][59] = get_vector_from_array_int(c_f_59, 1);
  int c_t_59[] = {  2,  17}; //   2
  psi_c_t[no_ps][59] = get_vector_from_array_int(c_t_59, 2);
  int c_d_59[] = {  3,  17,   0}; //   3
  psi_c_d[no_ps][59] = get_vector_from_array_int(c_d_59, 3);

  int c_p_60[] = { 17,  70,  69}; //   3
  psi_c_p[no_ps][60] = get_vector_from_array_int(c_p_60, 3);
  int c_f_60[] = {  5}; //   1
  psi_c_f[no_ps][60] = get_vector_from_array_int(c_f_60, 1);
  int c_t_60[] = {  2,  18}; //   2
  psi_c_t[no_ps][60] = get_vector_from_array_int(c_t_60, 2);
  int c_d_60[] = {  3,   0,  17}; //   3
  psi_c_d[no_ps][60] = get_vector_from_array_int(c_d_60, 3);

  int c_p_61[] = { 21,  70,  69}; //   3
  psi_c_p[no_ps][61] = get_vector_from_array_int(c_p_61, 3);
  int c_f_61[] = {  5}; //   1
  psi_c_f[no_ps][61] = get_vector_from_array_int(c_f_61, 1);
  int c_t_61[] = {  2,  18}; //   2
  psi_c_t[no_ps][61] = get_vector_from_array_int(c_t_61, 2);
  int c_d_61[] = {  3,   0,  17}; //   3
  psi_c_d[no_ps][61] = get_vector_from_array_int(c_d_61, 3);

  int c_p_62[] = { 17,  71,  65}; //   3
  psi_c_p[no_ps][62] = get_vector_from_array_int(c_p_62, 3);
  int c_f_62[] = {  3}; //   1
  psi_c_f[no_ps][62] = get_vector_from_array_int(c_f_62, 1);
  int c_t_62[] = {  0,  19}; //   2
  psi_c_t[no_ps][62] = get_vector_from_array_int(c_t_62, 2);
  int c_d_62[] = {  0,   3,  17}; //   3
  psi_c_d[no_ps][62] = get_vector_from_array_int(c_d_62, 3);

  int c_p_63[] = { 21,  71,  65}; //   3
  psi_c_p[no_ps][63] = get_vector_from_array_int(c_p_63, 3);
  int c_f_63[] = {  3}; //   1
  psi_c_f[no_ps][63] = get_vector_from_array_int(c_f_63, 1);
  int c_t_63[] = {  0,  19}; //   2
  psi_c_t[no_ps][63] = get_vector_from_array_int(c_t_63, 2);
  int c_d_63[] = {  0,   3,  17}; //   3
  psi_c_d[no_ps][63] = get_vector_from_array_int(c_d_63, 3);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
