#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppemexnmx04/header/ppemexnmx04.phasespace.h"
void ppemexnmx04_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppemexnmx04_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppemexnmx04_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppemexnmx04_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 38;}
  else if (psi_no_map[no_ps] == 1){n_channel = 24;}
  else if (psi_no_map[no_ps] == 2){n_channel = 24;}
  else if (psi_no_map[no_ps] == 3){n_channel = 24;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppemexnmx04_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppemexnmx04_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 3){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppemexnmx04_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppemexnmx04_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 1){ppemexnmx04_ax_psp_140_gd_emmumepvmxu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 2){ppemexnmx04_ax_psp_140_gux_emmumepvmxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 3){ppemexnmx04_ax_psp_140_dux_emmumepvmxg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
