#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppenex02/header/ppenex02.phasespace.h"
void ppenex02_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppenex02_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppenex02_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppenex02_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==   0){n_channel = 60;}
  else if (psi_no_map[no_ps] ==   1){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   2){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   3){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   4){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   5){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   6){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   7){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   8){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   9){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  10){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  11){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  12){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  13){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  14){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  15){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  16){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  17){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  18){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  19){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  20){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  25){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  26){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  28){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  29){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  30){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  32){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  35){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  36){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  37){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  38){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  40){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  42){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  43){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  44){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  45){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  46){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  47){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  48){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  49){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  50){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  51){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  52){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  53){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  56){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  58){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  59){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  62){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  64){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  67){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  69){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  70){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  71){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  72){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  73){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  74){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  76){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  79){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  82){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  85){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  88){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  89){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  90){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  92){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  93){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  95){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  96){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  97){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  98){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  99){n_channel = 2;}
  else if (psi_no_map[no_ps] == 100){n_channel = 2;}
  else if (psi_no_map[no_ps] == 101){n_channel = 2;}
  else if (psi_no_map[no_ps] == 102){n_channel = 2;}
  else if (psi_no_map[no_ps] == 103){n_channel = 2;}
  else if (psi_no_map[no_ps] == 109){n_channel = 4;}
  else if (psi_no_map[no_ps] == 111){n_channel = 4;}
  else if (psi_no_map[no_ps] == 114){n_channel = 2;}
  else if (psi_no_map[no_ps] == 115){n_channel = 4;}
  else if (psi_no_map[no_ps] == 118){n_channel = 2;}
  else if (psi_no_map[no_ps] == 119){n_channel = 2;}
  else if (psi_no_map[no_ps] == 120){n_channel = 2;}
  else if (psi_no_map[no_ps] == 121){n_channel = 2;}
  else if (psi_no_map[no_ps] == 122){n_channel = 2;}
  else if (psi_no_map[no_ps] == 125){n_channel = 2;}
  else if (psi_no_map[no_ps] == 128){n_channel = 8;}
  else if (psi_no_map[no_ps] == 129){n_channel = 2;}
  else if (psi_no_map[no_ps] == 132){n_channel = 4;}
  else if (psi_no_map[no_ps] == 134){n_channel = 2;}
  else if (psi_no_map[no_ps] == 135){n_channel = 4;}
  else if (psi_no_map[no_ps] == 136){n_channel = 2;}
  else if (psi_no_map[no_ps] == 137){n_channel = 2;}
  else if (psi_no_map[no_ps] == 138){n_channel = 2;}
  else if (psi_no_map[no_ps] == 141){n_channel = 2;}
  else if (psi_no_map[no_ps] == 142){n_channel = 2;}
  else if (psi_no_map[no_ps] == 143){n_channel = 4;}
  else if (psi_no_map[no_ps] == 144){n_channel = 2;}
  else if (psi_no_map[no_ps] == 145){n_channel = 2;}
  else if (psi_no_map[no_ps] == 146){n_channel = 4;}
  else if (psi_no_map[no_ps] == 147){n_channel = 2;}
  else if (psi_no_map[no_ps] == 148){n_channel = 8;}
  else if (psi_no_map[no_ps] == 149){n_channel = 2;}
  else if (psi_no_map[no_ps] == 152){n_channel = 2;}
  else if (psi_no_map[no_ps] == 153){n_channel = 2;}
  else if (psi_no_map[no_ps] == 154){n_channel = 2;}
  else if (psi_no_map[no_ps] == 155){n_channel = 4;}
  else if (psi_no_map[no_ps] == 156){n_channel = 2;}
  else if (psi_no_map[no_ps] == 158){n_channel = 4;}
  else if (psi_no_map[no_ps] == 161){n_channel = 2;}
  else if (psi_no_map[no_ps] == 164){n_channel = 2;}
  else if (psi_no_map[no_ps] == 167){n_channel = 2;}
  else if (psi_no_map[no_ps] == 169){n_channel = 2;}
  else if (psi_no_map[no_ps] == 170){n_channel = 4;}
  else if (psi_no_map[no_ps] == 174){n_channel = 2;}
  else if (psi_no_map[no_ps] == 175){n_channel = 2;}
  else if (psi_no_map[no_ps] == 176){n_channel = 2;}
  else if (psi_no_map[no_ps] == 177){n_channel = 2;}
  else if (psi_no_map[no_ps] == 178){n_channel = 2;}
  else if (psi_no_map[no_ps] == 179){n_channel = 2;}
  else if (psi_no_map[no_ps] == 180){n_channel = 4;}
  else if (psi_no_map[no_ps] == 181){n_channel = 4;}
  else if (psi_no_map[no_ps] == 182){n_channel = 4;}
  else if (psi_no_map[no_ps] == 186){n_channel = 4;}
  else if (psi_no_map[no_ps] == 188){n_channel = 4;}
  else if (psi_no_map[no_ps] == 189){n_channel = 2;}
  else if (psi_no_map[no_ps] == 192){n_channel = 2;}
  else if (psi_no_map[no_ps] == 195){n_channel = 8;}
  else if (psi_no_map[no_ps] == 196){n_channel = 2;}
  else if (psi_no_map[no_ps] == 199){n_channel = 4;}
  else if (psi_no_map[no_ps] == 202){n_channel = 2;}
  else if (psi_no_map[no_ps] == 204){n_channel = 2;}
  else if (psi_no_map[no_ps] == 205){n_channel = 2;}
  else if (psi_no_map[no_ps] == 206){n_channel = 2;}
  else if (psi_no_map[no_ps] == 207){n_channel = 2;}
  else if (psi_no_map[no_ps] == 208){n_channel = 4;}
  else if (psi_no_map[no_ps] == 210){n_channel = 2;}
  else if (psi_no_map[no_ps] == 213){n_channel = 2;}
  else if (psi_no_map[no_ps] == 215){n_channel = 8;}
  else if (psi_no_map[no_ps] == 216){n_channel = 2;}
  else if (psi_no_map[no_ps] == 219){n_channel = 2;}
  else if (psi_no_map[no_ps] == 220){n_channel = 2;}
  else if (psi_no_map[no_ps] == 222){n_channel = 2;}
  else if (psi_no_map[no_ps] == 225){n_channel = 4;}
  else if (psi_no_map[no_ps] == 226){n_channel = 2;}
  else if (psi_no_map[no_ps] == 227){n_channel = 2;}
  else if (psi_no_map[no_ps] == 228){n_channel = 4;}
  else if (psi_no_map[no_ps] == 229){n_channel = 2;}
  else if (psi_no_map[no_ps] == 230){n_channel = 2;}
  else if (psi_no_map[no_ps] == 231){n_channel = 4;}
  else if (psi_no_map[no_ps] == 232){n_channel = 2;}
  else if (psi_no_map[no_ps] == 233){n_channel = 2;}
  else if (psi_no_map[no_ps] == 234){n_channel = 4;}
  else if (psi_no_map[no_ps] == 235){n_channel = 4;}
  else if (psi_no_map[no_ps] == 236){n_channel = 2;}
  else if (psi_no_map[no_ps] == 237){n_channel = 2;}
  else if (psi_no_map[no_ps] == 241){n_channel = 4;}
  else if (psi_no_map[no_ps] == 242){n_channel = 2;}
  else if (psi_no_map[no_ps] == 243){n_channel = 2;}
  else if (psi_no_map[no_ps] == 247){n_channel = 4;}
  else if (psi_no_map[no_ps] == 249){n_channel = 4;}
  else if (psi_no_map[no_ps] == 250){n_channel = 4;}
  else if (psi_no_map[no_ps] == 254){n_channel = 2;}
  else if (psi_no_map[no_ps] == 256){n_channel = 4;}
  else if (psi_no_map[no_ps] == 257){n_channel = 2;}
  else if (psi_no_map[no_ps] == 259){n_channel = 2;}
  else if (psi_no_map[no_ps] == 260){n_channel = 2;}
  else if (psi_no_map[no_ps] == 261){n_channel = 2;}
  else if (psi_no_map[no_ps] == 262){n_channel = 2;}
  else if (psi_no_map[no_ps] == 263){n_channel = 2;}
  else if (psi_no_map[no_ps] == 264){n_channel = 2;}
  else if (psi_no_map[no_ps] == 267){n_channel = 2;}
  else if (psi_no_map[no_ps] == 269){n_channel = 2;}
  else if (psi_no_map[no_ps] == 270){n_channel = 4;}
  else if (psi_no_map[no_ps] == 272){n_channel = 2;}
  else if (psi_no_map[no_ps] == 274){n_channel = 4;}
  else if (psi_no_map[no_ps] == 275){n_channel = 2;}
  else if (psi_no_map[no_ps] == 278){n_channel = 4;}
  else if (psi_no_map[no_ps] == 281){n_channel = 4;}
  else if (psi_no_map[no_ps] == 282){n_channel = 4;}
  else if (psi_no_map[no_ps] == 285){n_channel = 2;}
  else if (psi_no_map[no_ps] == 287){n_channel = 2;}
  else if (psi_no_map[no_ps] == 288){n_channel = 4;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppenex02_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppenex02_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==   1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  19){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  26){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  42){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  43){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  44){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  45){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  46){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  47){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  48){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  49){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  50){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  51){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  52){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  53){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  56){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  58){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  59){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  62){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  64){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  67){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  69){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  70){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  71){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  72){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  73){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  74){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  76){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  79){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  82){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  85){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  88){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  89){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  90){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  92){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  93){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  95){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  96){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  97){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  98){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  99){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 100){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 101){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 102){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 103){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 109){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 111){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 114){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 115){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 118){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 119){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 120){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 121){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 122){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 125){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 128){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 129){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 132){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 134){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 135){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 136){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 137){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 138){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 141){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 142){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 143){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 144){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 145){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 146){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 147){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 148){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 149){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 152){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 153){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 154){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 155){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 156){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 158){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 161){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 164){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 167){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 169){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 170){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 174){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 175){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 176){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 177){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 178){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 179){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 180){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 181){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 182){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 186){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 188){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 189){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 192){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 195){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 196){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 199){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 202){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 204){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 205){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 206){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 207){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 208){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 210){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 213){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 215){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 216){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 219){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 220){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 222){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 225){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 226){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 227){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 228){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 229){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 230){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 231){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 232){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 233){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 234){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 235){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 236){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 237){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 241){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 242){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 243){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 247){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 249){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 250){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 254){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 256){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 257){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 259){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 260){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 261){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 262){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 263){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 264){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 267){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 269){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 270){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 272){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 274){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 275){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 278){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 281){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 282){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 285){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 287){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 288){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppenex02_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppenex02_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==   1){ppenex02_ax_psp_220_gg_emvexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   2){ppenex02_ax_psp_220_gg_emvexusx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   3){ppenex02_ax_psp_220_gg_emvexubx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   4){ppenex02_ax_psp_220_gg_emvexcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   5){ppenex02_ax_psp_220_gg_emvexcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   6){ppenex02_ax_psp_220_gg_emvexcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   7){ppenex02_ax_psp_220_gd_emvexgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   8){ppenex02_ax_psp_220_gd_emvexgc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   9){ppenex02_ax_psp_220_gs_emvexgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  10){ppenex02_ax_psp_220_gs_emvexgc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  11){ppenex02_ax_psp_220_gb_emvexgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  12){ppenex02_ax_psp_220_gb_emvexgc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  13){ppenex02_ax_psp_220_gux_emvexgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  14){ppenex02_ax_psp_220_gux_emvexgsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  15){ppenex02_ax_psp_220_gux_emvexgbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  16){ppenex02_ax_psp_220_gcx_emvexgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  17){ppenex02_ax_psp_220_gcx_emvexgsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  18){ppenex02_ax_psp_220_gcx_emvexgbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  19){ppenex02_ax_psp_220_dd_emvexdu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  20){ppenex02_ax_psp_220_dd_emvexdc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  25){ppenex02_ax_psp_220_du_emvexuu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  26){ppenex02_ax_psp_220_du_emvexuc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  28){ppenex02_ax_psp_220_ds_emvexdu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  29){ppenex02_ax_psp_220_ds_emvexdc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  30){ppenex02_ax_psp_220_ds_emvexus(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  32){ppenex02_ax_psp_220_ds_emvexsc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  35){ppenex02_ax_psp_220_dc_emvexuc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  36){ppenex02_ax_psp_220_dc_emvexcc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  37){ppenex02_ax_psp_220_db_emvexdu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  38){ppenex02_ax_psp_220_db_emvexdc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  40){ppenex02_ax_psp_220_db_emvexub(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  42){ppenex02_ax_psp_220_db_emvexcb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  43){ppenex02_ax_psp_220_ddx_emvexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  44){ppenex02_ax_psp_220_ddx_emvexusx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  45){ppenex02_ax_psp_220_ddx_emvexubx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  46){ppenex02_ax_psp_220_ddx_emvexcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  47){ppenex02_ax_psp_220_ddx_emvexcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  48){ppenex02_ax_psp_220_ddx_emvexcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  49){ppenex02_ax_psp_220_dux_emvexgg(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  50){ppenex02_ax_psp_220_dux_emvexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  51){ppenex02_ax_psp_220_dux_emvexdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  52){ppenex02_ax_psp_220_dux_emvexdbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  53){ppenex02_ax_psp_220_dux_emvexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  56){ppenex02_ax_psp_220_dux_emvexssx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  58){ppenex02_ax_psp_220_dux_emvexcux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  59){ppenex02_ax_psp_220_dux_emvexccx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  62){ppenex02_ax_psp_220_dux_emvexbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  64){ppenex02_ax_psp_220_dsx_emvexusx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  67){ppenex02_ax_psp_220_dsx_emvexcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  69){ppenex02_ax_psp_220_dcx_emvexgg(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  70){ppenex02_ax_psp_220_dcx_emvexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  71){ppenex02_ax_psp_220_dcx_emvexdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  72){ppenex02_ax_psp_220_dcx_emvexdbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  73){ppenex02_ax_psp_220_dcx_emvexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  74){ppenex02_ax_psp_220_dcx_emvexucx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  76){ppenex02_ax_psp_220_dcx_emvexssx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  79){ppenex02_ax_psp_220_dcx_emvexccx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  82){ppenex02_ax_psp_220_dcx_emvexbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  85){ppenex02_ax_psp_220_dbx_emvexubx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  88){ppenex02_ax_psp_220_dbx_emvexcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  89){ppenex02_ax_psp_220_us_emvexuu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  90){ppenex02_ax_psp_220_us_emvexuc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  92){ppenex02_ax_psp_220_ub_emvexuu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  93){ppenex02_ax_psp_220_ub_emvexuc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  95){ppenex02_ax_psp_220_uux_emvexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  96){ppenex02_ax_psp_220_uux_emvexusx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  97){ppenex02_ax_psp_220_uux_emvexubx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  98){ppenex02_ax_psp_220_uux_emvexcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  99){ppenex02_ax_psp_220_uux_emvexcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 100){ppenex02_ax_psp_220_uux_emvexcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 101){ppenex02_ax_psp_220_ucx_emvexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 102){ppenex02_ax_psp_220_ucx_emvexusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 103){ppenex02_ax_psp_220_ucx_emvexubx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 109){ppenex02_ax_psp_220_ss_emvexus(no_ps, psi);}
  else if (psi_no_map[no_ps] == 111){ppenex02_ax_psp_220_ss_emvexsc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 114){ppenex02_ax_psp_220_sc_emvexuc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 115){ppenex02_ax_psp_220_sc_emvexcc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 118){ppenex02_ax_psp_220_sb_emvexus(no_ps, psi);}
  else if (psi_no_map[no_ps] == 119){ppenex02_ax_psp_220_sb_emvexub(no_ps, psi);}
  else if (psi_no_map[no_ps] == 120){ppenex02_ax_psp_220_sb_emvexsc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 121){ppenex02_ax_psp_220_sb_emvexcb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 122){ppenex02_ax_psp_220_sdx_emvexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 125){ppenex02_ax_psp_220_sdx_emvexcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 128){ppenex02_ax_psp_220_sux_emvexgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 129){ppenex02_ax_psp_220_sux_emvexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 132){ppenex02_ax_psp_220_sux_emvexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 134){ppenex02_ax_psp_220_sux_emvexsdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 135){ppenex02_ax_psp_220_sux_emvexssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 136){ppenex02_ax_psp_220_sux_emvexsbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 137){ppenex02_ax_psp_220_sux_emvexcux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 138){ppenex02_ax_psp_220_sux_emvexccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 141){ppenex02_ax_psp_220_sux_emvexbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 142){ppenex02_ax_psp_220_ssx_emvexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 143){ppenex02_ax_psp_220_ssx_emvexusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 144){ppenex02_ax_psp_220_ssx_emvexubx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 145){ppenex02_ax_psp_220_ssx_emvexcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 146){ppenex02_ax_psp_220_ssx_emvexcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 147){ppenex02_ax_psp_220_ssx_emvexcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 148){ppenex02_ax_psp_220_scx_emvexgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 149){ppenex02_ax_psp_220_scx_emvexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 152){ppenex02_ax_psp_220_scx_emvexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 153){ppenex02_ax_psp_220_scx_emvexucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 154){ppenex02_ax_psp_220_scx_emvexsdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 155){ppenex02_ax_psp_220_scx_emvexssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 156){ppenex02_ax_psp_220_scx_emvexsbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 158){ppenex02_ax_psp_220_scx_emvexccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 161){ppenex02_ax_psp_220_scx_emvexbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 164){ppenex02_ax_psp_220_sbx_emvexubx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 167){ppenex02_ax_psp_220_sbx_emvexcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 169){ppenex02_ax_psp_220_cb_emvexuc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 170){ppenex02_ax_psp_220_cb_emvexcc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 174){ppenex02_ax_psp_220_cux_emvexcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 175){ppenex02_ax_psp_220_cux_emvexcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 176){ppenex02_ax_psp_220_cux_emvexcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 177){ppenex02_ax_psp_220_ccx_emvexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 178){ppenex02_ax_psp_220_ccx_emvexusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 179){ppenex02_ax_psp_220_ccx_emvexubx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 180){ppenex02_ax_psp_220_ccx_emvexcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 181){ppenex02_ax_psp_220_ccx_emvexcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 182){ppenex02_ax_psp_220_ccx_emvexcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 186){ppenex02_ax_psp_220_bb_emvexub(no_ps, psi);}
  else if (psi_no_map[no_ps] == 188){ppenex02_ax_psp_220_bb_emvexcb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 189){ppenex02_ax_psp_220_bdx_emvexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 192){ppenex02_ax_psp_220_bdx_emvexcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 195){ppenex02_ax_psp_220_bux_emvexgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 196){ppenex02_ax_psp_220_bux_emvexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 199){ppenex02_ax_psp_220_bux_emvexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 202){ppenex02_ax_psp_220_bux_emvexssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 204){ppenex02_ax_psp_220_bux_emvexcux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 205){ppenex02_ax_psp_220_bux_emvexccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 206){ppenex02_ax_psp_220_bux_emvexbdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 207){ppenex02_ax_psp_220_bux_emvexbsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 208){ppenex02_ax_psp_220_bux_emvexbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 210){ppenex02_ax_psp_220_bsx_emvexusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 213){ppenex02_ax_psp_220_bsx_emvexcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 215){ppenex02_ax_psp_220_bcx_emvexgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 216){ppenex02_ax_psp_220_bcx_emvexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 219){ppenex02_ax_psp_220_bcx_emvexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 220){ppenex02_ax_psp_220_bcx_emvexucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 222){ppenex02_ax_psp_220_bcx_emvexssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 225){ppenex02_ax_psp_220_bcx_emvexccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 226){ppenex02_ax_psp_220_bcx_emvexbdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 227){ppenex02_ax_psp_220_bcx_emvexbsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 228){ppenex02_ax_psp_220_bcx_emvexbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 229){ppenex02_ax_psp_220_bbx_emvexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 230){ppenex02_ax_psp_220_bbx_emvexusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 231){ppenex02_ax_psp_220_bbx_emvexubx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 232){ppenex02_ax_psp_220_bbx_emvexcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 233){ppenex02_ax_psp_220_bbx_emvexcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 234){ppenex02_ax_psp_220_bbx_emvexcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 235){ppenex02_ax_psp_220_dxux_emvexdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 236){ppenex02_ax_psp_220_dxux_emvexdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 237){ppenex02_ax_psp_220_dxux_emvexdxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 241){ppenex02_ax_psp_220_dxcx_emvexdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 242){ppenex02_ax_psp_220_dxcx_emvexdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 243){ppenex02_ax_psp_220_dxcx_emvexdxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 247){ppenex02_ax_psp_220_uxux_emvexdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 249){ppenex02_ax_psp_220_uxux_emvexuxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 250){ppenex02_ax_psp_220_uxux_emvexuxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 254){ppenex02_ax_psp_220_uxsx_emvexdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 256){ppenex02_ax_psp_220_uxsx_emvexsxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 257){ppenex02_ax_psp_220_uxsx_emvexsxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 259){ppenex02_ax_psp_220_uxcx_emvexdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 260){ppenex02_ax_psp_220_uxcx_emvexdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 261){ppenex02_ax_psp_220_uxcx_emvexuxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 262){ppenex02_ax_psp_220_uxcx_emvexuxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 263){ppenex02_ax_psp_220_uxcx_emvexsxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 264){ppenex02_ax_psp_220_uxcx_emvexcxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 267){ppenex02_ax_psp_220_uxbx_emvexdxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 269){ppenex02_ax_psp_220_uxbx_emvexsxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 270){ppenex02_ax_psp_220_uxbx_emvexbxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 272){ppenex02_ax_psp_220_sxcx_emvexdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 274){ppenex02_ax_psp_220_sxcx_emvexsxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 275){ppenex02_ax_psp_220_sxcx_emvexsxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 278){ppenex02_ax_psp_220_cxcx_emvexdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 281){ppenex02_ax_psp_220_cxcx_emvexsxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 282){ppenex02_ax_psp_220_cxcx_emvexcxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 285){ppenex02_ax_psp_220_cxbx_emvexdxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 287){ppenex02_ax_psp_220_cxbx_emvexsxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 288){ppenex02_ax_psp_220_cxbx_emvexbxbx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
