#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppenex02/header/ppenex02.phasespace.h"
void ppenex02_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppenex02_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppenex02_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppenex02_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 12;}
  else if (psi_no_map[no_ps] ==  1){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 2;}
  else if (psi_no_map[no_ps] == 10){n_channel = 2;}
  else if (psi_no_map[no_ps] == 11){n_channel = 2;}
  else if (psi_no_map[no_ps] == 12){n_channel = 2;}
  else if (psi_no_map[no_ps] == 13){n_channel = 2;}
  else if (psi_no_map[no_ps] == 14){n_channel = 2;}
  else if (psi_no_map[no_ps] == 15){n_channel = 2;}
  else if (psi_no_map[no_ps] == 16){n_channel = 2;}
  else if (psi_no_map[no_ps] == 17){n_channel = 2;}
  else if (psi_no_map[no_ps] == 18){n_channel = 2;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppenex02_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppenex02_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppenex02_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppenex02_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  1){ppenex02_ax_psp_120_gd_emvexu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  2){ppenex02_ax_psp_120_gd_emvexc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppenex02_ax_psp_120_gs_emvexu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppenex02_ax_psp_120_gs_emvexc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppenex02_ax_psp_120_gb_emvexu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppenex02_ax_psp_120_gb_emvexc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppenex02_ax_psp_120_gux_emvexdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppenex02_ax_psp_120_gux_emvexsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppenex02_ax_psp_120_gux_emvexbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppenex02_ax_psp_120_gcx_emvexdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppenex02_ax_psp_120_gcx_emvexsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 12){ppenex02_ax_psp_120_gcx_emvexbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppenex02_ax_psp_120_dux_emvexg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppenex02_ax_psp_120_dcx_emvexg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppenex02_ax_psp_120_sux_emvexg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppenex02_ax_psp_120_scx_emvexg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppenex02_ax_psp_120_bux_emvexg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppenex02_ax_psp_120_bcx_emvexg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
