#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppenexa03/header/ppenexa03.phasespace.h"
void ppenexa03_ax_psp_230_uux_emvexacsx(int no_ps, phasespace_set & psi){
  static Logger logger("ppenexa03_ax_psp_230_uux_emvexacsx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(16);
  psi_needed_v_smin[no_ps].resize(16);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13}; //  12
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 12);
  int needed_v_smin_1[] = {   0,    3,   10,   12}; //   4
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 4);
  int needed_v_smin_2[] = {   0,   12}; //   2
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 2);
  int needed_v_smin_3[] = {   1,    2,   11,   13}; //   4
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 4);
  int needed_v_smin_4[] = {   1,   13}; //   2
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 2);
  int needed_v_smin_5[] = {   2}; //   1
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 1);
  int needed_v_smin_6[] = {   3}; //   1
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 1);
  int needed_v_smin_7[] = {   4,    5}; //   2
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 2);
  int needed_v_smin_8[] = {   4,    6}; //   2
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 2);
  int needed_v_smin_9[] = {   5,    7}; //   2
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 2);
  int needed_v_smin_10[] = {   6,    7}; //   2
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 2);
  int needed_v_smin_11[] = {   6,    7}; //   2
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 2);
  int needed_v_smin_12[] = {   8,   10}; //   2
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 2);
  int needed_v_smin_13[] = {   8}; //   1
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 1);
  int needed_v_smin_14[] = {   9,   11}; //   2
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 2);
  int needed_v_smin_15[] = {   9}; //   1
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 1);

  psi_v_smax[no_ps].resize(14);
  psi_needed_v_smax[no_ps].resize(14);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13}; //  10
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 10);
  int needed_v_smax_1[] = {   0,    3,   10,   12}; //   4
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 4);
  int needed_v_smax_2[] = {   0,    1,   12,   13}; //   4
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 4);
  int needed_v_smax_3[] = {   1,    2,   11,   13}; //   4
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 4);
  int needed_v_smax_4[] = {   2,    5,    7,    8}; //   4
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 4);
  int needed_v_smax_5[] = {   3,    4,    6,    9}; //   4
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 4);
  int needed_v_smax_6[] = {   4,    5,    6,    7}; //   4
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 4);
  int needed_v_smax_7[] = {   6,    7}; //   2
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 2);
  int needed_v_smax_8[] = {   8}; //   1
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 1);
  int needed_v_smax_9[] = {   8}; //   1
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 1);
  int needed_v_smax_10[] = {   9}; //   1
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 1);
  int needed_v_smax_11[] = {   9}; //   1
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 1);
  int needed_v_smax_12[] = {  10}; //   1
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 1);
  int needed_v_smax_13[] = {  11}; //   1
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 1);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(20);
  psi_needed_g_p[no_ps].resize(20);
  int needed_g_p_0[] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13}; //  10
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 10);
  psi_container_IS_name.push_back("propagator_24_smin0_smax0");
  int needed_g_p_1[] = {   0,    3,   10,   12}; //   4
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 4);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,   12}; //   2
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 2);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {   1,    2,   11,   13}; //   4
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 4);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_4[] = {   1,   13}; //   2
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 2);
  psi_container_IS_name.push_back("propagator_0_smin4_smax2");
  int needed_g_p_5[] = {   2}; //   1
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 1);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_6[] = {   3}; //   1
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 1);
  psi_container_IS_name.push_back("propagator_0_smin6_smax5");
  int needed_g_p_7[] = {   4,    5}; //   2
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 2);
  psi_container_IS_name.push_back("propagator_24_smin7_smax6");
  int needed_g_p_8[] = {   4,    6}; //   2
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax5");
  int needed_g_p_9[] = {   5,    7}; //   2
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 2);
  psi_container_IS_name.push_back("propagator_0_smin9_smax4");
  int needed_g_p_10[] = {   6,    7}; //   2
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 2);
  psi_container_IS_name.push_back("propagator_0_smin10_smax7");
  int needed_g_p_11[] = {   6,    7}; //   2
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 2);
  psi_container_IS_name.push_back("propagator_24_smin11_smax6");
  int needed_g_p_12[] = {   8}; //   1
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 1);
  psi_container_IS_name.push_back("propagator_0_smin12_smax8");
  int needed_g_p_13[] = {   8}; //   1
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 1);
  psi_container_IS_name.push_back("propagator_24_smin0_smax9");
  int needed_g_p_14[] = {   8}; //   1
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 1);
  psi_container_IS_name.push_back("propagator_0_smin13_smax4");
  int needed_g_p_15[] = {   9}; //   1
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 1);
  psi_container_IS_name.push_back("propagator_0_smin14_smax10");
  int needed_g_p_16[] = {   9}; //   1
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 1);
  psi_container_IS_name.push_back("propagator_24_smin0_smax11");
  int needed_g_p_17[] = {   9}; //   1
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 1);
  psi_container_IS_name.push_back("propagator_0_smin15_smax5");
  int needed_g_p_18[] = {  10}; //   1
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 1);
  psi_container_IS_name.push_back("propagator_0_smin12_smax12");
  int needed_g_p_19[] = {  11}; //   1
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 1);
  psi_container_IS_name.push_back("propagator_0_smin14_smax13");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(0);
  psi_needed_g_f[no_ps].resize(0);

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(2);
  psi_needed_g_t[no_ps].resize(2);
  int needed_g_t_0[] = {   0,    1}; //   2
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_108");
  int needed_g_t_1[] = {  12,   13}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_108");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(20);
  psi_needed_g_d[no_ps].resize(20);
  int needed_g_d_0[] = {   0,   12}; //   2
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 2);
  psi_container_IS_name.push_back("costheta_of_decay_108__32_76");
  psi_container_IS_name.push_back("phi_of_decay_108__32_76");
  int needed_g_d_1[] = {   0,    3,   10,   12}; //   4
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 4);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_2[] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13}; //  12
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 12);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_3[] = {   1,   13}; //   2
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 2);
  psi_container_IS_name.push_back("costheta_of_decay_108__64_44");
  psi_container_IS_name.push_back("phi_of_decay_108__64_44");
  int needed_g_d_4[] = {   1,    2,   11,   13}; //   4
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 4);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_5[] = {   2,    5,    7,    8}; //   4
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 4);
  psi_container_IS_name.push_back("costheta_of_decay_124__64_60");
  psi_container_IS_name.push_back("phi_of_decay_124__64_60");
  int needed_g_d_6[] = {   2}; //   1
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 1);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_7[] = {   3,    4,    6,    9}; //   4
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 4);
  psi_container_IS_name.push_back("costheta_of_decay_124__32_92");
  psi_container_IS_name.push_back("phi_of_decay_124__32_92");
  int needed_g_d_8[] = {   3}; //   1
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 1);
  psi_container_IS_name.push_back("costheta_of_decay_92__16_76");
  psi_container_IS_name.push_back("phi_of_decay_92__16_76");
  int needed_g_d_9[] = {   4,    6}; //   2
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 2);
  psi_container_IS_name.push_back("costheta_of_decay_92__64_28");
  psi_container_IS_name.push_back("phi_of_decay_92__64_28");
  int needed_g_d_10[] = {   4,    5}; //   2
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 2);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_11[] = {   5,    7}; //   2
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_12[] = {   6,    7}; //   2
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 2);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_13[] = {   6,    7}; //   2
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 2);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_14[] = {   8}; //   1
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 1);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_15[] = {   8,   10}; //   2
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 2);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_16[] = {   9}; //   1
  psi_needed_g_d[no_ps][16] = get_vector_from_array_int(needed_g_d_16, 1);
  psi_container_IS_name.push_back("costheta_of_decay_92__12_80");
  psi_container_IS_name.push_back("phi_of_decay_92__12_80");
  int needed_g_d_17[] = {   9,   11}; //   2
  psi_needed_g_d[no_ps][17] = get_vector_from_array_int(needed_g_d_17, 2);
  psi_container_IS_name.push_back("costheta_of_decay_80__16_64");
  psi_container_IS_name.push_back("phi_of_decay_80__16_64");
  int needed_g_d_18[] = {  10}; //   1
  psi_needed_g_d[no_ps][18] = get_vector_from_array_int(needed_g_d_18, 1);
  psi_container_IS_name.push_back("costheta_of_decay_124__48_76");
  psi_container_IS_name.push_back("phi_of_decay_124__48_76");
  int needed_g_d_19[] = {  11}; //   1
  psi_needed_g_d[no_ps][19] = get_vector_from_array_int(needed_g_d_19, 1);
  psi_container_IS_name.push_back("costheta_of_decay_124__80_44");
  psi_container_IS_name.push_back("phi_of_decay_124__80_44");

  psi_c_p[no_ps].resize(14);
  psi_c_f[no_ps].resize(14);
  psi_c_t[no_ps].resize(14);
  psi_c_d[no_ps].resize(14);

  int c_p_0[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 3);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {  0}; //   1
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 1);
  int c_d_0[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 3);

  int c_p_1[] = {  0,   3,   4}; //   3
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 3);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {  0}; //   1
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 1);
  int c_d_1[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  0,   3,   5}; //   3
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 3);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {}; //   0
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 0);
  int c_d_2[] = {  5,   6,   4,   2}; //   4
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 4);

  int c_p_3[] = {  0,   1,   6}; //   3
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 3);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {}; //   0
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 0);
  int c_d_3[] = {  7,   8,   1,   2}; //   4
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 4);

  int c_p_4[] = {  0,   7,   8}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {}; //   0
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 0);
  int c_d_4[] = {  7,   9,  10,   2}; //   4
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 4);

  int c_p_5[] = {  0,   7,   9}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {}; //   0
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 0);
  int c_d_5[] = {  5,  11,  10,   2}; //   4
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 4);

  int c_p_6[] = { 10,  11,   8}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {}; //   0
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 0);
  int c_d_6[] = {  7,   9,  12,  13}; //   4
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 4);

  int c_p_7[] = { 10,  11,   9}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {}; //   0
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 0);
  int c_d_7[] = {  5,  11,  12,  13}; //   4
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 4);

  int c_p_8[] = { 12,  13,  14}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {}; //   0
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 0);
  int c_d_8[] = {  5,  14,   2,  15}; //   4
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 4);

  int c_p_9[] = { 15,  16,  17}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {}; //   0
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 0);
  int c_d_9[] = {  7,  16,   2,  17}; //   4
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 4);

  int c_p_10[] = {  0,   1,  18}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {}; //   0
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 0);
  int c_d_10[] = { 18,  15,   1,   2}; //   4
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 4);

  int c_p_11[] = {  0,   3,  19}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {}; //   0
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 0);
  int c_d_11[] = { 19,  17,   4,   2}; //   4
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 4);

  int c_p_12[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 3);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  1}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = {  0,   3,   4}; //   3
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 3);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  1}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
