#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppw01/header/ppw01.phasespace.h"
void ppw01_optimize_minv_born(phasespace_set & psi){
  static Logger logger("ppw01_optimize_minv_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.born.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppw01_determination_MCchannels_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppw01_determination_MCchannels_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 4;}
  else if (psi_no_map[no_ps] == 1){n_channel = 1;}
  else if (psi_no_map[no_ps] == 2){n_channel = 1;}
  else if (psi_no_map[no_ps] == 3){n_channel = 1;}
  else if (psi_no_map[no_ps] == 4){n_channel = 1;}
  else if (psi_no_map[no_ps] == 5){n_channel = 1;}
  else if (psi_no_map[no_ps] == 6){n_channel = 1;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppw01_ac_tau_psp_born(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppw01_ac_tau_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 6){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppw01_ax_psp_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppw01_ax_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 1){ppw01_ax_psp_010_dux_wm(no_ps, psi);}
  else if (psi_no_map[no_ps] == 2){ppw01_ax_psp_010_dcx_wm(no_ps, psi);}
  else if (psi_no_map[no_ps] == 3){ppw01_ax_psp_010_sux_wm(no_ps, psi);}
  else if (psi_no_map[no_ps] == 4){ppw01_ax_psp_010_scx_wm(no_ps, psi);}
  else if (psi_no_map[no_ps] == 5){ppw01_ax_psp_010_bux_wm(no_ps, psi);}
  else if (psi_no_map[no_ps] == 6){ppw01_ax_psp_010_bcx_wm(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
