#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwx01/header/ppwx01.phasespace.h"
void ppwx01_optimize_minv_born(phasespace_set & psi){
  static Logger logger("ppwx01_optimize_minv_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.born.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppwx01_determination_MCchannels_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppwx01_determination_MCchannels_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 4;}
  else if (psi_no_map[no_ps] == 1){n_channel = 1;}
  else if (psi_no_map[no_ps] == 2){n_channel = 1;}
  else if (psi_no_map[no_ps] == 3){n_channel = 1;}
  else if (psi_no_map[no_ps] == 4){n_channel = 1;}
  else if (psi_no_map[no_ps] == 5){n_channel = 1;}
  else if (psi_no_map[no_ps] == 6){n_channel = 1;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppwx01_ac_tau_psp_born(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppwx01_ac_tau_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 6){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppwx01_ax_psp_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppwx01_ax_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 1){ppwx01_ax_psp_010_udx_wp(no_ps, psi);}
  else if (psi_no_map[no_ps] == 2){ppwx01_ax_psp_010_usx_wp(no_ps, psi);}
  else if (psi_no_map[no_ps] == 3){ppwx01_ax_psp_010_ubx_wp(no_ps, psi);}
  else if (psi_no_map[no_ps] == 4){ppwx01_ax_psp_010_cdx_wp(no_ps, psi);}
  else if (psi_no_map[no_ps] == 5){ppwx01_ax_psp_010_csx_wp(no_ps, psi);}
  else if (psi_no_map[no_ps] == 6){ppwx01_ax_psp_010_cbx_wp(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
