#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwx01/header/ppwx01.phasespace.h"
void ppwx01_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppwx01_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppwx01_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppwx01_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==   0){n_channel = 60;}
  else if (psi_no_map[no_ps] ==   1){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   2){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   3){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   4){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   5){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   6){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   7){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   8){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   9){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  10){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  11){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  12){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  13){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  14){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  15){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  16){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  17){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  18){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  19){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  20){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  21){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  25){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  26){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  27){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  31){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  32){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  33){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  34){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  35){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  36){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  37){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  38){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  43){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  44){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  49){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  51){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  52){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  56){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  58){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  59){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  61){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  62){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  63){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  64){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  65){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  66){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  69){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  71){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  72){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  73){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  74){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  77){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  78){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  79){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  80){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  83){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  84){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  86){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  87){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  88){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  89){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  90){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  91){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  92){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  93){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  94){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  95){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  97){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  98){n_channel = 2;}
  else if (psi_no_map[no_ps] == 100){n_channel = 4;}
  else if (psi_no_map[no_ps] == 103){n_channel = 2;}
  else if (psi_no_map[no_ps] == 105){n_channel = 2;}
  else if (psi_no_map[no_ps] == 106){n_channel = 2;}
  else if (psi_no_map[no_ps] == 108){n_channel = 2;}
  else if (psi_no_map[no_ps] == 110){n_channel = 2;}
  else if (psi_no_map[no_ps] == 112){n_channel = 2;}
  else if (psi_no_map[no_ps] == 113){n_channel = 8;}
  else if (psi_no_map[no_ps] == 114){n_channel = 2;}
  else if (psi_no_map[no_ps] == 116){n_channel = 2;}
  else if (psi_no_map[no_ps] == 117){n_channel = 4;}
  else if (psi_no_map[no_ps] == 118){n_channel = 2;}
  else if (psi_no_map[no_ps] == 120){n_channel = 2;}
  else if (psi_no_map[no_ps] == 121){n_channel = 2;}
  else if (psi_no_map[no_ps] == 123){n_channel = 2;}
  else if (psi_no_map[no_ps] == 126){n_channel = 4;}
  else if (psi_no_map[no_ps] == 128){n_channel = 2;}
  else if (psi_no_map[no_ps] == 130){n_channel = 4;}
  else if (psi_no_map[no_ps] == 131){n_channel = 2;}
  else if (psi_no_map[no_ps] == 135){n_channel = 2;}
  else if (psi_no_map[no_ps] == 136){n_channel = 2;}
  else if (psi_no_map[no_ps] == 139){n_channel = 2;}
  else if (psi_no_map[no_ps] == 140){n_channel = 2;}
  else if (psi_no_map[no_ps] == 141){n_channel = 4;}
  else if (psi_no_map[no_ps] == 142){n_channel = 4;}
  else if (psi_no_map[no_ps] == 143){n_channel = 2;}
  else if (psi_no_map[no_ps] == 144){n_channel = 2;}
  else if (psi_no_map[no_ps] == 147){n_channel = 2;}
  else if (psi_no_map[no_ps] == 148){n_channel = 2;}
  else if (psi_no_map[no_ps] == 152){n_channel = 4;}
  else if (psi_no_map[no_ps] == 155){n_channel = 4;}
  else if (psi_no_map[no_ps] == 156){n_channel = 4;}
  else if (psi_no_map[no_ps] == 159){n_channel = 2;}
  else if (psi_no_map[no_ps] == 161){n_channel = 2;}
  else if (psi_no_map[no_ps] == 162){n_channel = 4;}
  else if (psi_no_map[no_ps] == 163){n_channel = 8;}
  else if (psi_no_map[no_ps] == 164){n_channel = 4;}
  else if (psi_no_map[no_ps] == 167){n_channel = 2;}
  else if (psi_no_map[no_ps] == 169){n_channel = 2;}
  else if (psi_no_map[no_ps] == 170){n_channel = 2;}
  else if (psi_no_map[no_ps] == 172){n_channel = 2;}
  else if (psi_no_map[no_ps] == 173){n_channel = 4;}
  else if (psi_no_map[no_ps] == 174){n_channel = 2;}
  else if (psi_no_map[no_ps] == 176){n_channel = 2;}
  else if (psi_no_map[no_ps] == 177){n_channel = 2;}
  else if (psi_no_map[no_ps] == 179){n_channel = 2;}
  else if (psi_no_map[no_ps] == 181){n_channel = 2;}
  else if (psi_no_map[no_ps] == 183){n_channel = 8;}
  else if (psi_no_map[no_ps] == 184){n_channel = 2;}
  else if (psi_no_map[no_ps] == 185){n_channel = 2;}
  else if (psi_no_map[no_ps] == 187){n_channel = 2;}
  else if (psi_no_map[no_ps] == 190){n_channel = 4;}
  else if (psi_no_map[no_ps] == 192){n_channel = 2;}
  else if (psi_no_map[no_ps] == 193){n_channel = 4;}
  else if (psi_no_map[no_ps] == 195){n_channel = 2;}
  else if (psi_no_map[no_ps] == 196){n_channel = 2;}
  else if (psi_no_map[no_ps] == 197){n_channel = 2;}
  else if (psi_no_map[no_ps] == 198){n_channel = 4;}
  else if (psi_no_map[no_ps] == 199){n_channel = 2;}
  else if (psi_no_map[no_ps] == 200){n_channel = 4;}
  else if (psi_no_map[no_ps] == 201){n_channel = 2;}
  else if (psi_no_map[no_ps] == 202){n_channel = 4;}
  else if (psi_no_map[no_ps] == 203){n_channel = 8;}
  else if (psi_no_map[no_ps] == 204){n_channel = 2;}
  else if (psi_no_map[no_ps] == 206){n_channel = 2;}
  else if (psi_no_map[no_ps] == 207){n_channel = 2;}
  else if (psi_no_map[no_ps] == 210){n_channel = 2;}
  else if (psi_no_map[no_ps] == 211){n_channel = 2;}
  else if (psi_no_map[no_ps] == 212){n_channel = 2;}
  else if (psi_no_map[no_ps] == 213){n_channel = 4;}
  else if (psi_no_map[no_ps] == 216){n_channel = 4;}
  else if (psi_no_map[no_ps] == 221){n_channel = 2;}
  else if (psi_no_map[no_ps] == 222){n_channel = 2;}
  else if (psi_no_map[no_ps] == 227){n_channel = 2;}
  else if (psi_no_map[no_ps] == 228){n_channel = 2;}
  else if (psi_no_map[no_ps] == 229){n_channel = 2;}
  else if (psi_no_map[no_ps] == 230){n_channel = 2;}
  else if (psi_no_map[no_ps] == 231){n_channel = 2;}
  else if (psi_no_map[no_ps] == 232){n_channel = 2;}
  else if (psi_no_map[no_ps] == 233){n_channel = 4;}
  else if (psi_no_map[no_ps] == 234){n_channel = 4;}
  else if (psi_no_map[no_ps] == 235){n_channel = 4;}
  else if (psi_no_map[no_ps] == 236){n_channel = 4;}
  else if (psi_no_map[no_ps] == 241){n_channel = 4;}
  else if (psi_no_map[no_ps] == 242){n_channel = 2;}
  else if (psi_no_map[no_ps] == 244){n_channel = 2;}
  else if (psi_no_map[no_ps] == 245){n_channel = 2;}
  else if (psi_no_map[no_ps] == 246){n_channel = 2;}
  else if (psi_no_map[no_ps] == 248){n_channel = 2;}
  else if (psi_no_map[no_ps] == 251){n_channel = 2;}
  else if (psi_no_map[no_ps] == 252){n_channel = 4;}
  else if (psi_no_map[no_ps] == 253){n_channel = 2;}
  else if (psi_no_map[no_ps] == 254){n_channel = 2;}
  else if (psi_no_map[no_ps] == 256){n_channel = 2;}
  else if (psi_no_map[no_ps] == 258){n_channel = 2;}
  else if (psi_no_map[no_ps] == 259){n_channel = 4;}
  else if (psi_no_map[no_ps] == 260){n_channel = 2;}
  else if (psi_no_map[no_ps] == 262){n_channel = 4;}
  else if (psi_no_map[no_ps] == 263){n_channel = 2;}
  else if (psi_no_map[no_ps] == 267){n_channel = 4;}
  else if (psi_no_map[no_ps] == 269){n_channel = 4;}
  else if (psi_no_map[no_ps] == 272){n_channel = 2;}
  else if (psi_no_map[no_ps] == 273){n_channel = 4;}
  else if (psi_no_map[no_ps] == 276){n_channel = 2;}
  else if (psi_no_map[no_ps] == 277){n_channel = 2;}
  else if (psi_no_map[no_ps] == 278){n_channel = 2;}
  else if (psi_no_map[no_ps] == 279){n_channel = 2;}
  else if (psi_no_map[no_ps] == 281){n_channel = 2;}
  else if (psi_no_map[no_ps] == 282){n_channel = 4;}
  else if (psi_no_map[no_ps] == 286){n_channel = 4;}
  else if (psi_no_map[no_ps] == 288){n_channel = 4;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppwx01_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppwx01_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==   1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  19){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  21){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  26){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  33){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  43){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  44){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  49){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  51){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  52){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  56){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  58){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  59){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  61){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  62){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  63){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  64){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  65){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  66){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  69){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  71){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  72){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  73){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  74){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  77){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  78){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  79){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  80){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  83){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  84){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  86){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  87){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  88){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  89){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  90){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  91){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  92){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  93){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  94){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  95){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  97){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  98){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 100){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 103){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 105){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 106){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 108){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 110){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 112){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 113){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 114){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 116){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 117){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 118){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 120){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 121){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 123){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 126){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 128){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 130){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 131){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 135){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 136){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 139){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 140){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 141){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 142){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 143){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 144){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 147){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 148){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 152){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 155){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 156){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 159){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 161){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 162){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 163){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 164){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 167){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 169){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 170){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 172){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 173){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 174){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 176){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 177){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 179){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 181){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 183){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 184){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 185){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 187){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 190){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 192){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 193){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 195){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 196){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 197){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 198){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 199){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 200){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 201){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 202){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 203){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 204){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 206){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 207){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 210){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 211){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 212){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 213){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 216){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 221){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 222){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 227){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 228){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 229){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 230){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 231){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 232){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 233){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 234){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 235){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 236){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 241){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 242){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 244){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 245){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 246){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 248){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 251){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 252){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 253){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 254){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 256){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 258){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 259){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 260){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 262){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 263){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 267){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 269){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 272){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 273){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 276){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 277){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 278){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 279){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 281){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 282){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 286){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 288){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppwx01_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppwx01_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==   1){ppwx01_ax_psp_210_gg_wpdux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   2){ppwx01_ax_psp_210_gg_wpdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   3){ppwx01_ax_psp_210_gg_wpsux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   4){ppwx01_ax_psp_210_gg_wpscx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   5){ppwx01_ax_psp_210_gg_wpbux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   6){ppwx01_ax_psp_210_gg_wpbcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   7){ppwx01_ax_psp_210_gu_wpgd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   8){ppwx01_ax_psp_210_gu_wpgs(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   9){ppwx01_ax_psp_210_gu_wpgb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  10){ppwx01_ax_psp_210_gc_wpgd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  11){ppwx01_ax_psp_210_gc_wpgs(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  12){ppwx01_ax_psp_210_gc_wpgb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  13){ppwx01_ax_psp_210_gdx_wpgux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  14){ppwx01_ax_psp_210_gdx_wpgcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  15){ppwx01_ax_psp_210_gsx_wpgux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  16){ppwx01_ax_psp_210_gsx_wpgcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  17){ppwx01_ax_psp_210_gbx_wpgux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  18){ppwx01_ax_psp_210_gbx_wpgcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  19){ppwx01_ax_psp_210_du_wpdd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  20){ppwx01_ax_psp_210_du_wpds(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  21){ppwx01_ax_psp_210_du_wpdb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  25){ppwx01_ax_psp_210_dc_wpdd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  26){ppwx01_ax_psp_210_dc_wpds(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  27){ppwx01_ax_psp_210_dc_wpdb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  31){ppwx01_ax_psp_210_ddx_wpdux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  32){ppwx01_ax_psp_210_ddx_wpdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  33){ppwx01_ax_psp_210_ddx_wpsux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  34){ppwx01_ax_psp_210_ddx_wpscx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  35){ppwx01_ax_psp_210_ddx_wpbux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  36){ppwx01_ax_psp_210_ddx_wpbcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  37){ppwx01_ax_psp_210_dsx_wpdux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  38){ppwx01_ax_psp_210_dsx_wpdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  43){ppwx01_ax_psp_210_dbx_wpdux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  44){ppwx01_ax_psp_210_dbx_wpdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  49){ppwx01_ax_psp_210_uu_wpdu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  51){ppwx01_ax_psp_210_uu_wpus(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  52){ppwx01_ax_psp_210_uu_wpub(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  56){ppwx01_ax_psp_210_us_wpds(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  58){ppwx01_ax_psp_210_us_wpss(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  59){ppwx01_ax_psp_210_us_wpsb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  61){ppwx01_ax_psp_210_uc_wpdu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  62){ppwx01_ax_psp_210_uc_wpdc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  63){ppwx01_ax_psp_210_uc_wpus(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  64){ppwx01_ax_psp_210_uc_wpub(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  65){ppwx01_ax_psp_210_uc_wpsc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  66){ppwx01_ax_psp_210_uc_wpcb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  69){ppwx01_ax_psp_210_ub_wpdb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  71){ppwx01_ax_psp_210_ub_wpsb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  72){ppwx01_ax_psp_210_ub_wpbb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  73){ppwx01_ax_psp_210_udx_wpgg(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  74){ppwx01_ax_psp_210_udx_wpddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  77){ppwx01_ax_psp_210_udx_wpuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  78){ppwx01_ax_psp_210_udx_wpucx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  79){ppwx01_ax_psp_210_udx_wpsdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  80){ppwx01_ax_psp_210_udx_wpssx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  83){ppwx01_ax_psp_210_udx_wpccx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  84){ppwx01_ax_psp_210_udx_wpbdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  86){ppwx01_ax_psp_210_udx_wpbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  87){ppwx01_ax_psp_210_uux_wpdux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  88){ppwx01_ax_psp_210_uux_wpdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  89){ppwx01_ax_psp_210_uux_wpsux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  90){ppwx01_ax_psp_210_uux_wpscx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  91){ppwx01_ax_psp_210_uux_wpbux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  92){ppwx01_ax_psp_210_uux_wpbcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  93){ppwx01_ax_psp_210_usx_wpgg(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  94){ppwx01_ax_psp_210_usx_wpddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  95){ppwx01_ax_psp_210_usx_wpdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  97){ppwx01_ax_psp_210_usx_wpuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  98){ppwx01_ax_psp_210_usx_wpucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 100){ppwx01_ax_psp_210_usx_wpssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 103){ppwx01_ax_psp_210_usx_wpccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 105){ppwx01_ax_psp_210_usx_wpbsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 106){ppwx01_ax_psp_210_usx_wpbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 108){ppwx01_ax_psp_210_ucx_wpdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 110){ppwx01_ax_psp_210_ucx_wpscx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 112){ppwx01_ax_psp_210_ucx_wpbcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 113){ppwx01_ax_psp_210_ubx_wpgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 114){ppwx01_ax_psp_210_ubx_wpddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 116){ppwx01_ax_psp_210_ubx_wpdbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 117){ppwx01_ax_psp_210_ubx_wpuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 118){ppwx01_ax_psp_210_ubx_wpucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 120){ppwx01_ax_psp_210_ubx_wpssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 121){ppwx01_ax_psp_210_ubx_wpsbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 123){ppwx01_ax_psp_210_ubx_wpccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 126){ppwx01_ax_psp_210_ubx_wpbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 128){ppwx01_ax_psp_210_sc_wpds(no_ps, psi);}
  else if (psi_no_map[no_ps] == 130){ppwx01_ax_psp_210_sc_wpss(no_ps, psi);}
  else if (psi_no_map[no_ps] == 131){ppwx01_ax_psp_210_sc_wpsb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 135){ppwx01_ax_psp_210_sdx_wpsux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 136){ppwx01_ax_psp_210_sdx_wpscx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 139){ppwx01_ax_psp_210_ssx_wpdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 140){ppwx01_ax_psp_210_ssx_wpdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 141){ppwx01_ax_psp_210_ssx_wpsux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 142){ppwx01_ax_psp_210_ssx_wpscx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 143){ppwx01_ax_psp_210_ssx_wpbux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 144){ppwx01_ax_psp_210_ssx_wpbcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 147){ppwx01_ax_psp_210_sbx_wpsux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 148){ppwx01_ax_psp_210_sbx_wpscx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 152){ppwx01_ax_psp_210_cc_wpdc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 155){ppwx01_ax_psp_210_cc_wpsc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 156){ppwx01_ax_psp_210_cc_wpcb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 159){ppwx01_ax_psp_210_cb_wpdb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 161){ppwx01_ax_psp_210_cb_wpsb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 162){ppwx01_ax_psp_210_cb_wpbb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 163){ppwx01_ax_psp_210_cdx_wpgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 164){ppwx01_ax_psp_210_cdx_wpddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 167){ppwx01_ax_psp_210_cdx_wpuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 169){ppwx01_ax_psp_210_cdx_wpsdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 170){ppwx01_ax_psp_210_cdx_wpssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 172){ppwx01_ax_psp_210_cdx_wpcux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 173){ppwx01_ax_psp_210_cdx_wpccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 174){ppwx01_ax_psp_210_cdx_wpbdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 176){ppwx01_ax_psp_210_cdx_wpbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 177){ppwx01_ax_psp_210_cux_wpdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 179){ppwx01_ax_psp_210_cux_wpsux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 181){ppwx01_ax_psp_210_cux_wpbux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 183){ppwx01_ax_psp_210_csx_wpgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 184){ppwx01_ax_psp_210_csx_wpddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 185){ppwx01_ax_psp_210_csx_wpdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 187){ppwx01_ax_psp_210_csx_wpuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 190){ppwx01_ax_psp_210_csx_wpssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 192){ppwx01_ax_psp_210_csx_wpcux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 193){ppwx01_ax_psp_210_csx_wpccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 195){ppwx01_ax_psp_210_csx_wpbsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 196){ppwx01_ax_psp_210_csx_wpbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 197){ppwx01_ax_psp_210_ccx_wpdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 198){ppwx01_ax_psp_210_ccx_wpdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 199){ppwx01_ax_psp_210_ccx_wpsux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 200){ppwx01_ax_psp_210_ccx_wpscx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 201){ppwx01_ax_psp_210_ccx_wpbux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 202){ppwx01_ax_psp_210_ccx_wpbcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 203){ppwx01_ax_psp_210_cbx_wpgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 204){ppwx01_ax_psp_210_cbx_wpddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 206){ppwx01_ax_psp_210_cbx_wpdbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 207){ppwx01_ax_psp_210_cbx_wpuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 210){ppwx01_ax_psp_210_cbx_wpssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 211){ppwx01_ax_psp_210_cbx_wpsbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 212){ppwx01_ax_psp_210_cbx_wpcux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 213){ppwx01_ax_psp_210_cbx_wpccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 216){ppwx01_ax_psp_210_cbx_wpbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 221){ppwx01_ax_psp_210_bdx_wpbux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 222){ppwx01_ax_psp_210_bdx_wpbcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 227){ppwx01_ax_psp_210_bsx_wpbux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 228){ppwx01_ax_psp_210_bsx_wpbcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 229){ppwx01_ax_psp_210_bbx_wpdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 230){ppwx01_ax_psp_210_bbx_wpdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 231){ppwx01_ax_psp_210_bbx_wpsux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 232){ppwx01_ax_psp_210_bbx_wpscx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 233){ppwx01_ax_psp_210_bbx_wpbux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 234){ppwx01_ax_psp_210_bbx_wpbcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 235){ppwx01_ax_psp_210_dxdx_wpdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 236){ppwx01_ax_psp_210_dxdx_wpdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 241){ppwx01_ax_psp_210_dxux_wpuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 242){ppwx01_ax_psp_210_dxux_wpuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 244){ppwx01_ax_psp_210_dxsx_wpdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 245){ppwx01_ax_psp_210_dxsx_wpdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 246){ppwx01_ax_psp_210_dxsx_wpuxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 248){ppwx01_ax_psp_210_dxsx_wpsxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 251){ppwx01_ax_psp_210_dxcx_wpuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 252){ppwx01_ax_psp_210_dxcx_wpcxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 253){ppwx01_ax_psp_210_dxbx_wpdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 254){ppwx01_ax_psp_210_dxbx_wpdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 256){ppwx01_ax_psp_210_dxbx_wpuxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 258){ppwx01_ax_psp_210_dxbx_wpcxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 259){ppwx01_ax_psp_210_uxsx_wpuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 260){ppwx01_ax_psp_210_uxsx_wpuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 262){ppwx01_ax_psp_210_uxbx_wpuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 263){ppwx01_ax_psp_210_uxbx_wpuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 267){ppwx01_ax_psp_210_sxsx_wpuxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 269){ppwx01_ax_psp_210_sxsx_wpsxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 272){ppwx01_ax_psp_210_sxcx_wpuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 273){ppwx01_ax_psp_210_sxcx_wpcxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 276){ppwx01_ax_psp_210_sxbx_wpuxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 277){ppwx01_ax_psp_210_sxbx_wpuxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 278){ppwx01_ax_psp_210_sxbx_wpsxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 279){ppwx01_ax_psp_210_sxbx_wpcxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 281){ppwx01_ax_psp_210_cxbx_wpuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 282){ppwx01_ax_psp_210_cxbx_wpcxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 286){ppwx01_ax_psp_210_bxbx_wpuxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 288){ppwx01_ax_psp_210_bxbx_wpcxbx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
