#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwxw02/header/ppwxw02.phasespace.h"
void ppwxw02_ax_psp_220_bux_wpwmbux(int no_ps, phasespace_set & psi){
  static Logger logger("ppwxw02_ax_psp_220_bux_wpwmbux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(8);
  psi_needed_v_smin[no_ps].resize(8);
  int needed_v_smin_0[] = {   2,    3,    4,    5,    6,    7,   11,   12,   14,   15}; //  10
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 10);
  int needed_v_smin_1[] = {   5,    6,    7,    2,    3,    4}; //   6
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 6);
  int needed_v_smin_2[] = {   8,   10,    1}; //   3
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 3);
  int needed_v_smin_3[] = {   8}; //   1
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 1);
  int needed_v_smin_4[] = {   9,   13,    0}; //   3
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 3);
  int needed_v_smin_5[] = {  11,   12,   14,   15}; //   4
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 4);
  int needed_v_smin_6[] = {  13,    0,    9}; //   3
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 3);
  int needed_v_smin_7[] = {   1,   10}; //   2
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 2);

  psi_v_smax[no_ps].resize(6);
  psi_needed_v_smax[no_ps].resize(6);
  int needed_v_smax_0[] = {   2,    3,    4,    5,    6,    7,   11,   12,   14,   15}; //  10
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 10);
  int needed_v_smax_1[] = {   5,    6,    7,    8,    2,    3,    4}; //   7
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 7);
  int needed_v_smax_2[] = {   8,   10,    1}; //   3
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 3);
  int needed_v_smax_3[] = {   9,   13,    0}; //   3
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 3);
  int needed_v_smax_4[] = {  11,   12,   13,    0,    9,   14,   15}; //   7
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 7);
  int needed_v_smax_5[] = {   1,   10}; //   2
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(9);
  psi_needed_g_p[no_ps].resize(9);
  int needed_g_p_0[] = {   2,    5,   11,   14}; //   4
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 4);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   3,    6,   12,   15}; //   4
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 4);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_2[] = {   4,    7}; //   2
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 2);
  psi_container_IS_name.push_back("propagator_25_smin0_smax0");
  int needed_g_p_3[] = {   5,    6,    7}; //   3
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 3);
  psi_container_IS_name.push_back("propagator_5_smin1_smax1");
  int needed_g_p_4[] = {   8,   10}; //   2
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 2);
  psi_container_IS_name.push_back("propagator_6_smin2_smax2");
  int needed_g_p_5[] = {   8}; //   1
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 1);
  psi_container_IS_name.push_back("propagator_5_smin3_smax1");
  int needed_g_p_6[] = {   9,   13}; //   2
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 2);
  psi_container_IS_name.push_back("propagator_0_smin4_smax3");
  int needed_g_p_7[] = {  11,   12}; //   2
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_8[] = {  13}; //   1
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 1);
  psi_container_IS_name.push_back("propagator_0_smin6_smax4");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(6);
  psi_needed_g_f[no_ps].resize(6);
  int needed_g_f_0[] = {   0}; //   1
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax3");
  int needed_g_f_1[] = {   0,    9}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax4");
  int needed_g_f_2[] = {   1}; //   1
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax2");
  int needed_g_f_3[] = {   1,   10}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax5");
  int needed_g_f_4[] = {   2,    3,    4}; //   3
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 3);
  psi_container_IS_name.push_back("timelikeinvariant_smin1_smax1");
  int needed_g_f_5[] = {  14,   15}; //   2
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin5_smax4");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(9);
  psi_needed_g_t[no_ps].resize(9);
  int needed_g_t_0[] = {   0,    9,   11,   12,   13,   14,   15}; //   7
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 7);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_44");
  int needed_g_t_1[] = {   0,    9}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__8_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__8_36");
  int needed_g_t_2[] = {   0}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_10__32_4");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_10__32_4");
  int needed_g_t_3[] = {   1,   10}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__8_52");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__8_52");
  int needed_g_t_4[] = {   1,   10}; //   2
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_9__32_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_9__32_20");
  int needed_g_t_5[] = {   1}; //   1
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 1);
  psi_container_IS_name.push_back("t_of_tchannel_5__9_34__4_16");
  psi_container_IS_name.push_back("phi_of_tchannel_5__9_34__4_16");
  int needed_g_t_6[] = {   2,    3,    4,    5,    6,    7,    8}; //   7
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 7);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__32_28");
  int needed_g_t_7[] = {   2,    3,    4}; //   3
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_34__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_34__12_16");
  int needed_g_t_8[] = {  14,   15}; //   2
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__12_32");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(7);
  psi_needed_g_d[no_ps].resize(7);
  int needed_g_d_0[] = {   2,    3,    4,    5,    6,    7,   11,   12,   14,   15}; //  10
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 10);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_1[] = {   5,    6,    7}; //   3
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 3);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_2[] = {   8}; //   1
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 1);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_3[] = {   8,   10}; //   2
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 2);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_4[] = {   9,   13}; //   2
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 2);
  psi_container_IS_name.push_back("costheta_of_decay_36__4_32");
  psi_container_IS_name.push_back("phi_of_decay_36__4_32");
  int needed_g_d_5[] = {  11,   12}; //   2
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 2);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_6[] = {  13}; //   1
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 1);
  psi_container_IS_name.push_back("costheta_of_decay_44__8_36");
  psi_container_IS_name.push_back("phi_of_decay_44__8_36");

  psi_c_p[no_ps].resize(16);
  psi_c_f[no_ps].resize(16);
  psi_c_t[no_ps].resize(16);
  psi_c_d[no_ps].resize(16);

  int c_p_0[] = {}; //   0
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 0);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {}; //   0
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 0);

  int c_p_1[] = {}; //   0
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 0);
  int c_f_1[] = {  2,   3}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  3,   4,   5}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {}; //   0
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 0);

  int c_p_2[] = {  0}; //   1
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 1);
  int c_f_2[] = {  4}; //   1
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 1);
  int c_t_2[] = {  6,   7}; //   2
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 2);
  int c_d_2[] = {  0}; //   1
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 1);

  int c_p_3[] = {  1}; //   1
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 1);
  int c_f_3[] = {  4}; //   1
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 1);
  int c_t_3[] = {  6,   7}; //   2
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 2);
  int c_d_3[] = {  0}; //   1
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 1);

  int c_p_4[] = {  2}; //   1
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 1);
  int c_f_4[] = {  4}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = {  6,   7}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  0}; //   1
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 1);

  int c_p_5[] = {  0,   3}; //   2
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 2);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {  6}; //   1
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 1);
  int c_d_5[] = {  1,   0}; //   2
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 2);

  int c_p_6[] = {  1,   3}; //   2
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 2);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {  6}; //   1
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 1);
  int c_d_6[] = {  1,   0}; //   2
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 2);

  int c_p_7[] = {  2,   3}; //   2
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 2);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  6}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  1,   0}; //   2
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 2);

  int c_p_8[] = {  4,   5}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {  6}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = {  2,   3}; //   2
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 2);

  int c_p_9[] = {  6}; //   1
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 1);
  int c_f_9[] = {  1}; //   1
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 1);
  int c_t_9[] = {  0,   1}; //   2
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 2);
  int c_d_9[] = {  4}; //   1
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 1);

  int c_p_10[] = {  4}; //   1
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 1);
  int c_f_10[] = {  3}; //   1
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 1);
  int c_t_10[] = {  3,   4}; //   2
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 2);
  int c_d_10[] = {  3}; //   1
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 1);

  int c_p_11[] = {  0,   7}; //   2
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 2);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  0}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  5,   0}; //   2
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 2);

  int c_p_12[] = {  1,   7}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  0}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  5,   0}; //   2
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 2);

  int c_p_13[] = {  6,   8}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  0}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  6,   4}; //   2
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 2);

  int c_p_14[] = {  0}; //   1
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 1);
  int c_f_14[] = {  5}; //   1
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 1);
  int c_t_14[] = {  0,   8}; //   2
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 2);
  int c_d_14[] = {  0}; //   1
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 1);

  int c_p_15[] = {  1}; //   1
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 1);
  int c_f_15[] = {  5}; //   1
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 1);
  int c_t_15[] = {  0,   8}; //   2
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 2);
  int c_d_15[] = {  0}; //   1
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 1);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
