#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwxw02/header/ppwxw02.phasespace.h"
void ppwxw02_ax_psp_220_gbx_wpwmgbx(int no_ps, phasespace_set & psi){
  static Logger logger("ppwxw02_ax_psp_220_gbx_wpwmgbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(10);
  psi_needed_v_smin[no_ps].resize(10);
  int needed_v_smin_0[] = {   4,    5,    7,   12,   14,   15,   25,   26,    2}; //   9
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 9);
  int needed_v_smin_1[] = {   6,   11,   13,   19,   20,   21,   36,   37,   38}; //   9
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 9);
  int needed_v_smin_2[] = {   7,   15,   26,    2,    4,   25}; //   6
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 6);
  int needed_v_smin_3[] = {   8,    9,   10,   16,   17,   18,   19,   20,   21,   22,   23,   24,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,    0}; //  25
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 25);
  int needed_v_smin_4[] = {   8,    9,   10,   16,   17,   18,   27,   28,   29,   30,   31,   32}; //  12
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 12);
  int needed_v_smin_5[] = {  11,   13,    6}; //   3
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 3);
  int needed_v_smin_6[] = {  12,   14,    5}; //   3
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 3);
  int needed_v_smin_7[] = {   0,   22,   23,   24,   33,   34,   35}; //   7
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 7);
  int needed_v_smin_8[] = {   1,    3}; //   2
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 2);
  int needed_v_smin_9[] = {   1,    3}; //   2
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 2);

  psi_v_smax[no_ps].resize(9);
  psi_needed_v_smax[no_ps].resize(9);
  int needed_v_smax_0[] = {   4,    5,    7,   12,   14,   15,   25,   26,    2}; //   9
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 9);
  int needed_v_smax_1[] = {   6,   11,   13,   19,   20,   21}; //   6
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 6);
  int needed_v_smax_2[] = {   7,    8,    9,   10,   15,   16,   17,   18,   26,   27,   28,   29,    2,    4,   25,   30,   31,   32}; //  18
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 18);
  int needed_v_smax_3[] = {   8,    9,   10,   16,   17,   18,   22,   23,   24,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,    0}; //  22
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 22);
  int needed_v_smax_4[] = {  11,   12,   13,   14,    5,    6}; //   6
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 6);
  int needed_v_smax_5[] = {  19,   20,   21}; //   3
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 3);
  int needed_v_smax_6[] = {  36,   37,   38}; //   3
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 3);
  int needed_v_smax_7[] = {   0,    1,    3,   22,   23,   24,   33,   34,   35}; //   9
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 9);
  int needed_v_smax_8[] = {   1,    3}; //   2
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(13);
  psi_needed_g_p[no_ps].resize(13);
  int needed_g_p_0[] = {   4,    5,    7,   12,   14,   15,   25,   26}; //   8
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 8);
  psi_container_IS_name.push_back("propagator_6_smin0_smax0");
  int needed_g_p_1[] = {   6,   11,   13,   19,   20,   21}; //   6
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 6);
  psi_container_IS_name.push_back("propagator_5_smin1_smax1");
  int needed_g_p_2[] = {   7,   15,   26}; //   3
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 3);
  psi_container_IS_name.push_back("propagator_5_smin2_smax2");
  int needed_g_p_3[] = {   8,   16,   22,   27,   30,   33,   36}; //   7
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 7);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_4[] = {   8,    9,   10,   16,   17,   18,   27,   28,   29}; //   9
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 9);
  psi_container_IS_name.push_back("propagator_5_smin4_smax2");
  int needed_g_p_5[] = {   9,   17,   23,   28,   31,   34,   37}; //   7
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 7);
  psi_container_IS_name.push_back("propagator_23_smin3_smax3");
  int needed_g_p_6[] = {  10,   18,   24,   29,   32,   35,   38}; //   7
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 7);
  psi_container_IS_name.push_back("propagator_25_smin3_smax3");
  int needed_g_p_7[] = {  11,   13}; //   2
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 2);
  psi_container_IS_name.push_back("propagator_6_smin5_smax4");
  int needed_g_p_8[] = {  12,   14}; //   2
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 2);
  psi_container_IS_name.push_back("propagator_6_smin6_smax4");
  int needed_g_p_9[] = {  19}; //   1
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 1);
  psi_container_IS_name.push_back("propagator_0_smin3_smax5");
  int needed_g_p_10[] = {  20}; //   1
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 1);
  psi_container_IS_name.push_back("propagator_23_smin3_smax5");
  int needed_g_p_11[] = {  21}; //   1
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 1);
  psi_container_IS_name.push_back("propagator_25_smin3_smax5");
  int needed_g_p_12[] = {  36,   37,   38}; //   3
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 3);
  psi_container_IS_name.push_back("propagator_5_smin1_smax6");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(9);
  psi_needed_g_f[no_ps].resize(9);
  int needed_g_f_0[] = {   0}; //   1
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax3");
  int needed_g_f_1[] = {   0,   22,   23,   24,   33,   34,   35}; //   7
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 7);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax7");
  int needed_g_f_2[] = {   1,    3}; //   2
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax8");
  int needed_g_f_3[] = {   1,    3}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax7");
  int needed_g_f_4[] = {   2}; //   1
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin0_smax0");
  int needed_g_f_5[] = {   2,    4,   25}; //   3
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 3);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax2");
  int needed_g_f_6[] = {   5}; //   1
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax4");
  int needed_g_f_7[] = {   6}; //   1
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin5_smax4");
  int needed_g_f_8[] = {  30,   31,   32}; //   3
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 3);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax2");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(17);
  psi_needed_g_t[no_ps].resize(17);
  int needed_g_t_0[] = {   0,    1,    3,   22,   23,   24,   33,   34,   35}; //   9
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 9);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_2__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_2__32_28");
  int needed_g_t_1[] = {   0,   22,   23,   24}; //   4
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__2_33__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__2_33__16_12");
  int needed_g_t_2[] = {   0}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_6__33_18__8_4");
  psi_container_IS_name.push_back("phi_of_tchannel_6__33_18__8_4");
  int needed_g_t_3[] = {   1,    3}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__2_33__4_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__2_33__4_24");
  int needed_g_t_4[] = {   1}; //   1
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 1);
  psi_container_IS_name.push_back("t_of_tchannel_6__33_6__8_16");
  psi_container_IS_name.push_back("phi_of_tchannel_6__33_6__8_16");
  int needed_g_t_5[] = {   2,   25,   26,   27,   28,   29,   30,   31,   32}; //   9
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 9);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_44");
  int needed_g_t_6[] = {   2,   25}; //   2
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__2_17__4_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__2_17__4_40");
  int needed_g_t_7[] = {   2}; //   1
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 1);
  psi_container_IS_name.push_back("t_of_tchannel_5__17_6__32_8");
  psi_container_IS_name.push_back("phi_of_tchannel_5__17_6__32_8");
  int needed_g_t_8[] = {   3}; //   1
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 1);
  psi_container_IS_name.push_back("t_of_tchannel_5__33_6__16_8");
  psi_container_IS_name.push_back("phi_of_tchannel_5__33_6__16_8");
  int needed_g_t_9[] = {   4,    7,    8,    9,   10}; //   5
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 5);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__2_1__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__2_1__16_44");
  int needed_g_t_10[] = {   4}; //   1
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_18__40_4");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_18__40_4");
  int needed_g_t_11[] = {   5,    6,   11,   12}; //   4
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__2_1__4_56");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__2_1__4_56");
  int needed_g_t_12[] = {   5}; //   1
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_6__40_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_6__40_16");
  int needed_g_t_13[] = {   6}; //   1
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_6__48_8");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_6__48_8");
  int needed_g_t_14[] = {  30,   31,   32}; //   3
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__2_17__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__2_17__12_32");
  int needed_g_t_15[] = {  33,   34,   35}; //   3
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__2_33__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__2_33__12_16");
  int needed_g_t_16[] = {  36,   37,   38}; //   3
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_2__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_2__48_12");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(10);
  psi_needed_g_d[no_ps].resize(10);
  int needed_g_d_0[] = {   4,    5,    7,   12,   14,   15,   25,   26}; //   8
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 8);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_1[] = {   6,   11,   13,   19,   20,   21,   36,   37,   38}; //   9
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 9);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_2[] = {   7,   15,   26}; //   3
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 3);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_3[] = {   8,    9,   10,   16,   17,   18,   27,   28,   29}; //   9
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 9);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_4[] = {   8,    9,   10,   16,   17,   18,   19,   20,   21,   22,   23,   24,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38}; //  24
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 24);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_5[] = {  11,   13}; //   2
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 2);
  psi_container_IS_name.push_back("costheta_of_decay_56__8_48");
  psi_container_IS_name.push_back("phi_of_decay_56__8_48");
  int needed_g_d_6[] = {  12,   14}; //   2
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 2);
  psi_container_IS_name.push_back("costheta_of_decay_56__16_40");
  psi_container_IS_name.push_back("phi_of_decay_56__16_40");
  int needed_g_d_7[] = {  13,   14}; //   2
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_8[] = {  15,   16,   17,   18}; //   4
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_9[] = {  19,   20,   21}; //   3
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 3);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");

  psi_c_p[no_ps].resize(39);
  psi_c_f[no_ps].resize(39);
  psi_c_t[no_ps].resize(39);
  psi_c_d[no_ps].resize(39);

  int c_p_0[] = {}; //   0
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 0);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {}; //   0
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 0);

  int c_p_1[] = {}; //   0
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 0);
  int c_f_1[] = {  2,   3}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  0,   3,   4}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {}; //   0
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 0);

  int c_p_2[] = {}; //   0
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 0);
  int c_f_2[] = {  4,   5}; //   2
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 2);
  int c_t_2[] = {  5,   6,   7}; //   3
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 3);
  int c_d_2[] = {}; //   0
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 0);

  int c_p_3[] = {}; //   0
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 0);
  int c_f_3[] = {  2,   3}; //   2
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 2);
  int c_t_3[] = {  0,   3,   8}; //   3
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 3);
  int c_d_3[] = {}; //   0
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 0);

  int c_p_4[] = {  0}; //   1
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 1);
  int c_f_4[] = {  5}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = {  9,  10}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  0}; //   1
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 1);

  int c_p_5[] = {  0}; //   1
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 1);
  int c_f_5[] = {  6}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = { 11,  12}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  0}; //   1
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 1);

  int c_p_6[] = {  1}; //   1
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 1);
  int c_f_6[] = {  7}; //   1
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 1);
  int c_t_6[] = { 11,  13}; //   2
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 2);
  int c_d_6[] = {  1}; //   1
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 1);

  int c_p_7[] = {  0,   2}; //   2
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 2);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  9}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  2,   0}; //   2
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 2);

  int c_p_8[] = {  3,   4}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {  9}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = {  3,   4}; //   2
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 2);

  int c_p_9[] = {  5,   4}; //   2
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 2);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  9}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  3,   4}; //   2
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 2);

  int c_p_10[] = {  6,   4}; //   2
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 2);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  9}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  3,   4}; //   2
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 2);

  int c_p_11[] = {  1,   7}; //   2
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 2);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = { 11}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  5,   1}; //   2
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 2);

  int c_p_12[] = {  0,   8}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = { 11}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  6,   0}; //   2
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 2);

  int c_p_13[] = {  1,   7}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {}; //   0
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 0);
  int c_d_13[] = {  7,   5,   1}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = {  0,   8}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {}; //   0
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 0);
  int c_d_14[] = {  7,   6,   0}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = {  0,   2}; //   2
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 2);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {}; //   0
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 0);
  int c_d_15[] = {  8,   2,   0}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = {  3,   4}; //   2
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 2);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {}; //   0
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 0);
  int c_d_16[] = {  8,   3,   4}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = {  5,   4}; //   2
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 2);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {}; //   0
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 0);
  int c_d_17[] = {  8,   3,   4}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = {  6,   4}; //   2
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 2);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {}; //   0
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 0);
  int c_d_18[] = {  8,   3,   4}; //   3
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 3);

  int c_p_19[] = {  1,   9}; //   2
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 2);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {}; //   0
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 0);
  int c_d_19[] = {  9,   4,   1}; //   3
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 3);

  int c_p_20[] = {  1,  10}; //   2
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 2);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {}; //   0
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 0);
  int c_d_20[] = {  9,   4,   1}; //   3
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 3);

  int c_p_21[] = {  1,  11}; //   2
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 2);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {}; //   0
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 0);
  int c_d_21[] = {  9,   4,   1}; //   3
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 3);

  int c_p_22[] = {  3}; //   1
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 1);
  int c_f_22[] = {  1}; //   1
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 1);
  int c_t_22[] = {  0,   1}; //   2
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 2);
  int c_d_22[] = {  4}; //   1
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 1);

  int c_p_23[] = {  5}; //   1
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 1);
  int c_f_23[] = {  1}; //   1
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 1);
  int c_t_23[] = {  0,   1}; //   2
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 2);
  int c_d_23[] = {  4}; //   1
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 1);

  int c_p_24[] = {  6}; //   1
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 1);
  int c_f_24[] = {  1}; //   1
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 1);
  int c_t_24[] = {  0,   1}; //   2
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 2);
  int c_d_24[] = {  4}; //   1
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 1);

  int c_p_25[] = {  0}; //   1
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 1);
  int c_f_25[] = {  5}; //   1
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 1);
  int c_t_25[] = {  5,   6}; //   2
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 2);
  int c_d_25[] = {  0}; //   1
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 1);

  int c_p_26[] = {  0,   2}; //   2
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 2);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {  5}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = {  2,   0}; //   2
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 2);

  int c_p_27[] = {  3,   4}; //   2
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 2);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {  5}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = {  3,   4}; //   2
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 2);

  int c_p_28[] = {  5,   4}; //   2
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 2);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {  5}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = {  3,   4}; //   2
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 2);

  int c_p_29[] = {  6,   4}; //   2
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 2);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {  5}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = {  3,   4}; //   2
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 2);

  int c_p_30[] = {  3}; //   1
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 1);
  int c_f_30[] = {  8}; //   1
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 1);
  int c_t_30[] = {  5,  14}; //   2
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 2);
  int c_d_30[] = {  4}; //   1
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 1);

  int c_p_31[] = {  5}; //   1
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 1);
  int c_f_31[] = {  8}; //   1
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 1);
  int c_t_31[] = {  5,  14}; //   2
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 2);
  int c_d_31[] = {  4}; //   1
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 1);

  int c_p_32[] = {  6}; //   1
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 1);
  int c_f_32[] = {  8}; //   1
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 1);
  int c_t_32[] = {  5,  14}; //   2
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 2);
  int c_d_32[] = {  4}; //   1
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 1);

  int c_p_33[] = {  3}; //   1
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 1);
  int c_f_33[] = {  1}; //   1
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 1);
  int c_t_33[] = {  0,  15}; //   2
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 2);
  int c_d_33[] = {  4}; //   1
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 1);

  int c_p_34[] = {  5}; //   1
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 1);
  int c_f_34[] = {  1}; //   1
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 1);
  int c_t_34[] = {  0,  15}; //   2
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 2);
  int c_d_34[] = {  4}; //   1
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 1);

  int c_p_35[] = {  6}; //   1
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 1);
  int c_f_35[] = {  1}; //   1
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 1);
  int c_t_35[] = {  0,  15}; //   2
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 2);
  int c_d_35[] = {  4}; //   1
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 1);

  int c_p_36[] = {  3,  12}; //   2
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 2);
  int c_f_36[] = {}; //   0
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 0);
  int c_t_36[] = { 16}; //   1
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 1);
  int c_d_36[] = {  1,   4}; //   2
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 2);

  int c_p_37[] = {  5,  12}; //   2
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 2);
  int c_f_37[] = {}; //   0
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 0);
  int c_t_37[] = { 16}; //   1
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 1);
  int c_d_37[] = {  1,   4}; //   2
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 2);

  int c_p_38[] = {  6,  12}; //   2
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 2);
  int c_f_38[] = {}; //   0
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 0);
  int c_t_38[] = { 16}; //   1
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 1);
  int c_d_38[] = {  1,   4}; //   2
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
