#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppzz02/header/ppzz02.phasespace.h"
void ppzz02_ax_psp_220_gd_zzgd(int no_ps, phasespace_set & psi){
  static Logger logger("ppzz02_ax_psp_220_gd_zzgd");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(15);
  psi_needed_v_smin[no_ps].resize(15);
  int needed_v_smin_0[] = {   8,    9,   16,   17,   24,   25,   26,   29,    2}; //   9
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 9);
  int needed_v_smin_1[] = {  10,   13,   15,   18,   20,   23}; //   6
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 6);
  int needed_v_smin_2[] = {  11,   12,   14,   19,   21,   22,   27,   28,    6}; //   9
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 9);
  int needed_v_smin_3[] = {  14,   22,   28,    6,   11,   27}; //   6
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 6);
  int needed_v_smin_4[] = {  15,   23,   10}; //   3
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 3);
  int needed_v_smin_5[] = {  16,   24,    9}; //   3
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 3);
  int needed_v_smin_6[] = {  17,   25,   29,    2,    8,   26}; //   6
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 6);
  int needed_v_smin_7[] = {  18,   20,   13}; //   3
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 3);
  int needed_v_smin_8[] = {  19,   21,   12}; //   3
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 3);
  int needed_v_smin_9[] = {   0,    4}; //   2
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 2);
  int needed_v_smin_10[] = {   0,    4}; //   2
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 2);
  int needed_v_smin_11[] = {   1,    3}; //   2
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 2);
  int needed_v_smin_12[] = {   1,    3}; //   2
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 2);
  int needed_v_smin_13[] = {   5,    7}; //   2
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 2);
  int needed_v_smin_14[] = {   5,    7}; //   2
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 2);

  psi_v_smax[no_ps].resize(10);
  psi_needed_v_smax[no_ps].resize(10);
  int needed_v_smax_0[] = {   8,    9,   16,   17,   24,   25,   26,   29,    2}; //   9
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 9);
  int needed_v_smax_1[] = {  10,   13,   15,   18,   20,   23}; //   6
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 6);
  int needed_v_smax_2[] = {  11,   12,   14,   19,   21,   22,   27,   28,    6}; //   9
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 9);
  int needed_v_smax_3[] = {  14,   17,   22,   25,   28,   29,    2,    6,    8,   11,   26,   27}; //  12
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 12);
  int needed_v_smax_4[] = {  15,   16,   23,   24,    9,   10}; //   6
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 6);
  int needed_v_smax_5[] = {  18,   19,   20,   21,   12,   13}; //   6
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 6);
  int needed_v_smax_6[] = {   0,    4}; //   2
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 2);
  int needed_v_smax_7[] = {   0,    1,    3,    4,    5,    7}; //   6
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 6);
  int needed_v_smax_8[] = {   1,    3}; //   2
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 2);
  int needed_v_smax_9[] = {   5,    7}; //   2
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(9);
  psi_needed_g_p[no_ps].resize(9);
  int needed_g_p_0[] = {   8,    9,   16,   17,   24,   25,   26,   29}; //   8
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 8);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {  10,   13,   15,   18,   20,   23}; //   6
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 6);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {  11,   12,   14,   19,   21,   22,   27,   28}; //   8
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 8);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {  14,   22,   28}; //   3
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 3);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_4[] = {  15,   23}; //   2
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 2);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_5[] = {  16,   24}; //   2
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_6[] = {  17,   25,   29}; //   3
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 3);
  psi_container_IS_name.push_back("propagator_0_smin6_smax3");
  int needed_g_p_7[] = {  18,   20}; //   2
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 2);
  psi_container_IS_name.push_back("propagator_0_smin7_smax5");
  int needed_g_p_8[] = {  19,   21}; //   2
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax5");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(14);
  psi_needed_g_f[no_ps].resize(14);
  int needed_g_f_0[] = {   0,    4}; //   2
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax6");
  int needed_g_f_1[] = {   0,    4}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax7");
  int needed_g_f_2[] = {   1,    3}; //   2
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax8");
  int needed_g_f_3[] = {   1,    3}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax7");
  int needed_g_f_4[] = {   2}; //   1
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin0_smax0");
  int needed_g_f_5[] = {   2,    8,   26}; //   3
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 3);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax3");
  int needed_g_f_6[] = {   5,    7}; //   2
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin13_smax9");
  int needed_g_f_7[] = {   5,    7}; //   2
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin14_smax7");
  int needed_g_f_8[] = {   6}; //   1
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax2");
  int needed_g_f_9[] = {   6,   11,   27}; //   3
  psi_needed_g_f[no_ps][9] = get_vector_from_array_int(needed_g_f_9, 3);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax3");
  int needed_g_f_10[] = {   9}; //   1
  psi_needed_g_f[no_ps][10] = get_vector_from_array_int(needed_g_f_10, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin5_smax4");
  int needed_g_f_11[] = {  10}; //   1
  psi_needed_g_f[no_ps][11] = get_vector_from_array_int(needed_g_f_11, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax4");
  int needed_g_f_12[] = {  12}; //   1
  psi_needed_g_f[no_ps][12] = get_vector_from_array_int(needed_g_f_12, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax5");
  int needed_g_f_13[] = {  13}; //   1
  psi_needed_g_f[no_ps][13] = get_vector_from_array_int(needed_g_f_13, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax5");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(24);
  psi_needed_g_t[no_ps].resize(24);
  int needed_g_t_0[] = {   0,    1,    3,    4,    5,    7}; //   6
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_28");
  int needed_g_t_1[] = {   0,    4}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__16_12");
  int needed_g_t_2[] = {   0}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_18__4_8");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_18__4_8");
  int needed_g_t_3[] = {   1,    3}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__8_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__8_20");
  int needed_g_t_4[] = {   1}; //   1
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_10__4_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_10__4_16");
  int needed_g_t_5[] = {   2,    6,   26,   27,   28,   29}; //   6
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_44");
  int needed_g_t_6[] = {   2,   26}; //   2
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__8_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__8_36");
  int needed_g_t_7[] = {   2}; //   1
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_10__32_4");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_10__32_4");
  int needed_g_t_8[] = {   3}; //   1
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_10__16_4");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_10__16_4");
  int needed_g_t_9[] = {   4}; //   1
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_18__8_4");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_18__8_4");
  int needed_g_t_10[] = {   5,    7}; //   2
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__4_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__4_24");
  int needed_g_t_11[] = {   5}; //   1
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_6__8_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_6__8_16");
  int needed_g_t_12[] = {   6,   27}; //   2
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__4_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__4_40");
  int needed_g_t_13[] = {   6}; //   1
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_6__32_8");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_6__32_8");
  int needed_g_t_14[] = {   7}; //   1
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_6__16_8");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_6__16_8");
  int needed_g_t_15[] = {   8,   11,   14,   17}; //   4
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_44");
  int needed_g_t_16[] = {   8}; //   1
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__36_8");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__36_8");
  int needed_g_t_17[] = {   9,   10,   15,   16}; //   4
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__8_52");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__8_52");
  int needed_g_t_18[] = {   9}; //   1
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_10__36_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_10__36_16");
  int needed_g_t_19[] = {  10}; //   1
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_10__48_4");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_10__48_4");
  int needed_g_t_20[] = {  11}; //   1
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__40_4");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__40_4");
  int needed_g_t_21[] = {  12,   13,   18,   19}; //   4
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__4_56");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__4_56");
  int needed_g_t_22[] = {  12}; //   1
  psi_needed_g_t[no_ps][22] = get_vector_from_array_int(needed_g_t_22, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_6__40_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_6__40_16");
  int needed_g_t_23[] = {  13}; //   1
  psi_needed_g_t[no_ps][23] = get_vector_from_array_int(needed_g_t_23, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_6__48_8");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_6__48_8");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(12);
  psi_needed_g_d[no_ps].resize(12);
  int needed_g_d_0[] = {   8,    9,   16,   17,   24,   25,   26,   29}; //   8
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 8);
  psi_container_IS_name.push_back("costheta_of_decay_36__4_32");
  psi_container_IS_name.push_back("phi_of_decay_36__4_32");
  int needed_g_d_1[] = {  10,   13,   15,   18,   20,   23}; //   6
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 6);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_2[] = {  11,   12,   14,   19,   21,   22,   27,   28}; //   8
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 8);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_3[] = {  14,   22,   28}; //   3
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 3);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_4[] = {  15,   23}; //   2
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 2);
  psi_container_IS_name.push_back("costheta_of_decay_52__4_48");
  psi_container_IS_name.push_back("phi_of_decay_52__4_48");
  int needed_g_d_5[] = {  16,   24}; //   2
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 2);
  psi_container_IS_name.push_back("costheta_of_decay_52__16_36");
  psi_container_IS_name.push_back("phi_of_decay_52__16_36");
  int needed_g_d_6[] = {  17,   25,   29}; //   3
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 3);
  psi_container_IS_name.push_back("costheta_of_decay_44__8_36");
  psi_container_IS_name.push_back("phi_of_decay_44__8_36");
  int needed_g_d_7[] = {  18,   20}; //   2
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 2);
  psi_container_IS_name.push_back("costheta_of_decay_56__8_48");
  psi_container_IS_name.push_back("phi_of_decay_56__8_48");
  int needed_g_d_8[] = {  19,   21}; //   2
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 2);
  psi_container_IS_name.push_back("costheta_of_decay_56__16_40");
  psi_container_IS_name.push_back("phi_of_decay_56__16_40");
  int needed_g_d_9[] = {  20,   21}; //   2
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_10[] = {  22,   25}; //   2
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_11[] = {  23,   24}; //   2
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");

  psi_c_p[no_ps].resize(30);
  psi_c_f[no_ps].resize(30);
  psi_c_t[no_ps].resize(30);
  psi_c_d[no_ps].resize(30);

  int c_p_0[] = {}; //   0
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 0);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {}; //   0
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 0);

  int c_p_1[] = {}; //   0
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 0);
  int c_f_1[] = {  2,   3}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  0,   3,   4}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {}; //   0
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 0);

  int c_p_2[] = {}; //   0
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 0);
  int c_f_2[] = {  4,   5}; //   2
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 2);
  int c_t_2[] = {  5,   6,   7}; //   3
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 3);
  int c_d_2[] = {}; //   0
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 0);

  int c_p_3[] = {}; //   0
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 0);
  int c_f_3[] = {  2,   3}; //   2
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 2);
  int c_t_3[] = {  0,   3,   8}; //   3
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 3);
  int c_d_3[] = {}; //   0
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 0);

  int c_p_4[] = {}; //   0
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 0);
  int c_f_4[] = {  0,   1}; //   2
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 2);
  int c_t_4[] = {  0,   1,   9}; //   3
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 3);
  int c_d_4[] = {}; //   0
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 0);

  int c_p_5[] = {}; //   0
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 0);
  int c_f_5[] = {  6,   7}; //   2
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 2);
  int c_t_5[] = {  0,  10,  11}; //   3
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 3);
  int c_d_5[] = {}; //   0
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 0);

  int c_p_6[] = {}; //   0
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 0);
  int c_f_6[] = {  8,   9}; //   2
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 2);
  int c_t_6[] = {  5,  12,  13}; //   3
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 3);
  int c_d_6[] = {}; //   0
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 0);

  int c_p_7[] = {}; //   0
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 0);
  int c_f_7[] = {  6,   7}; //   2
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 2);
  int c_t_7[] = {  0,  10,  14}; //   3
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 3);
  int c_d_7[] = {}; //   0
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 0);

  int c_p_8[] = {  0}; //   1
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 1);
  int c_f_8[] = {  5}; //   1
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 1);
  int c_t_8[] = { 15,  16}; //   2
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 2);
  int c_d_8[] = {  0}; //   1
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 1);

  int c_p_9[] = {  0}; //   1
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 1);
  int c_f_9[] = { 10}; //   1
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 1);
  int c_t_9[] = { 17,  18}; //   2
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 2);
  int c_d_9[] = {  0}; //   1
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 1);

  int c_p_10[] = {  1}; //   1
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 1);
  int c_f_10[] = { 11}; //   1
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 1);
  int c_t_10[] = { 17,  19}; //   2
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 2);
  int c_d_10[] = {  1}; //   1
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 1);

  int c_p_11[] = {  2}; //   1
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 1);
  int c_f_11[] = {  9}; //   1
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 1);
  int c_t_11[] = { 15,  20}; //   2
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 2);
  int c_d_11[] = {  2}; //   1
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 1);

  int c_p_12[] = {  2}; //   1
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 1);
  int c_f_12[] = { 12}; //   1
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 1);
  int c_t_12[] = { 21,  22}; //   2
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 2);
  int c_d_12[] = {  2}; //   1
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 1);

  int c_p_13[] = {  1}; //   1
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 1);
  int c_f_13[] = { 13}; //   1
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 1);
  int c_t_13[] = { 21,  23}; //   2
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 2);
  int c_d_13[] = {  1}; //   1
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 1);

  int c_p_14[] = {  2,   3}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = { 15}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  3,   2}; //   2
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 2);

  int c_p_15[] = {  1,   4}; //   2
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 2);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = { 17}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  4,   1}; //   2
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 2);

  int c_p_16[] = {  0,   5}; //   2
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 2);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = { 17}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = {  5,   0}; //   2
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 2);

  int c_p_17[] = {  0,   6}; //   2
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 2);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = { 15}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = {  6,   0}; //   2
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 2);

  int c_p_18[] = {  1,   7}; //   2
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 2);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = { 21}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = {  7,   1}; //   2
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 2);

  int c_p_19[] = {  2,   8}; //   2
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 2);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = { 21}; //   1
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 1);
  int c_d_19[] = {  8,   2}; //   2
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 2);

  int c_p_20[] = {  1,   7}; //   2
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 2);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {}; //   0
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 0);
  int c_d_20[] = {  9,   7,   1}; //   3
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 3);

  int c_p_21[] = {  2,   8}; //   2
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 2);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {}; //   0
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 0);
  int c_d_21[] = {  9,   8,   2}; //   3
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 3);

  int c_p_22[] = {  2,   3}; //   2
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 2);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {}; //   0
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 0);
  int c_d_22[] = { 10,   3,   2}; //   3
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 3);

  int c_p_23[] = {  1,   4}; //   2
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 2);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {}; //   0
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 0);
  int c_d_23[] = { 11,   4,   1}; //   3
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 3);

  int c_p_24[] = {  0,   5}; //   2
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 2);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {}; //   0
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 0);
  int c_d_24[] = { 11,   5,   0}; //   3
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 3);

  int c_p_25[] = {  0,   6}; //   2
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 2);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {}; //   0
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 0);
  int c_d_25[] = { 10,   6,   0}; //   3
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 3);

  int c_p_26[] = {  0}; //   1
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 1);
  int c_f_26[] = {  5}; //   1
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 1);
  int c_t_26[] = {  5,   6}; //   2
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 2);
  int c_d_26[] = {  0}; //   1
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 1);

  int c_p_27[] = {  2}; //   1
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 1);
  int c_f_27[] = {  9}; //   1
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 1);
  int c_t_27[] = {  5,  12}; //   2
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 2);
  int c_d_27[] = {  2}; //   1
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 1);

  int c_p_28[] = {  2,   3}; //   2
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 2);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {  5}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = {  3,   2}; //   2
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 2);

  int c_p_29[] = {  0,   6}; //   2
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 2);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {  5}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = {  6,   0}; //   2
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
