#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppzz02/header/ppzz02.phasespace.h"
void ppzz02_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppzz02_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppzz02_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppzz02_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 10;}
  else if (psi_no_map[no_ps] == 2){n_channel = 6;}
  else if (psi_no_map[no_ps] == 3){n_channel = 6;}
  else if (psi_no_map[no_ps] == 4){n_channel = 6;}
  else if (psi_no_map[no_ps] == 5){n_channel = 6;}
  else if (psi_no_map[no_ps] == 6){n_channel = 6;}
  else if (psi_no_map[no_ps] == 7){n_channel = 6;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppzz02_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppzz02_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 7){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppzz02_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppzz02_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 2){ppzz02_ax_psp_120_gd_zzd(no_ps, psi);}
  else if (psi_no_map[no_ps] == 3){ppzz02_ax_psp_120_gu_zzu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 4){ppzz02_ax_psp_120_gdx_zzdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 5){ppzz02_ax_psp_120_gux_zzux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 6){ppzz02_ax_psp_120_ddx_zzg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 7){ppzz02_ax_psp_120_uux_zzg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
