#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../include/definitions.observable.set.cxx"
void munich::integration_RA_QCD(){
  static Logger logger("munich::integration_RA_QCD");
  logger << LOG_INFO << "called" << endl;

  generic.determination_subprocess_psp(0, psi);
  generic.combination_subprocess_psp(0, psi, osi);

  osi.perform_selection_content_pdf();

  // could be modified later ??? merge with MC-mappings of dipoles ???
  psi_MC_n_channel_phasespace[0] = generic.determination_MCchannels_psp(0, psi);
  dipole.push_back(dipole_set("ME2_R", csi.type_parton[0], csi.basic_type_parton[0], psi_symmetry_factor, psi_no_map[0], psi_o_map[0], psi_no_prc[0], psi_o_prc[0], psi_MC_n_channel_phasespace[0]));

  QCD_determine_dipoles(dipole_candidate, csi.type_parton[0], csi.basic_type_parton[0]);
  QCD_selection_dipoles(dipole, dipole_candidate, psi_phasespace_order_alpha_s[0] - 1, psi_phasespace_order_alpha_e[0], psi_phasespace_order_interference[0], psi_RA_singular_region, psi_RA_singular_region_name, psi_RA_singular_region_list, psi, generic);

  psi.initialization_mapping_parameter(isi);
  psi.initialization_minimum_tau(isi);
  psi.initialization_minimum_phasespacecut(isi);

  static int n_dipoles = dipole.size();
  osi.initialization_RA(dipole);
  if (n_dipoles != osi.n_ps){logger << LOG_FATAL << "n_dipoles = " << n_dipoles << " != " << osi.n_ps << " = osi.n_ps" << endl; exit(1);}

  psi.initialization_phasespace_RA(n_dipoles, dipole);

  // generation of optimized xbs limits (including invariant-mass cuts) ???
  psi.initialization_phasespace_subprocess_dipole_RA(n_dipoles, dipole);
  generic.optimize_minv_psp(psi);
  psi.initialization_phasespace_subprocess_optimization_dipole_RA(n_dipoles, dipole);

  // check meaning of osi.switch_RS_mapping !!!
  if (osi.type_contribution == "RA"){for (int i_a = 1; i_a < n_dipoles; i_a++){if (psi_start_xbs_all[i_a][psi_xb_max / 2 - 4]){osi.switch_RS_mapping = 1;}}}

  if (osi.switch_RS_mapping){psi_MC_n_channel = psi_MC_n_channel_phasespace[0];}

  generic.ax_psp_psp(0, psi);
  if (!osi.switch_RS_mapping){
    for (int i_a = 1; i_a < n_dipoles; i_a++){generic.ax_psp_dipole(i_a, psi);}
    psi.initialization_phasespace_subprocess_dipole_IS_RA(n_dipoles, dipole);
  }

  psi.initialization_optimization(isi);
  psi.initialization_filename(isi);

  // generation of MC_tau mappings
  generic.ac_tau_psp_psp(0, psi_MC_x_dipole_mapping[0], psi);
  if (!osi.switch_RS_mapping){
    for (int i_a = 1; i_a < n_dipoles; i_a++){generic.ac_tau_psp_dipole(i_a, psi_MC_x_dipole_mapping[i_a], psi);}
    if (psi_type_contribution == "RRA"){initialization_fake_dipole_mapping_RRA(dipole, psi, generic);}
    psi.initialization_phasespace_MC_x_dipole_RA();
  }
  else if (osi.switch_RS_mapping){
    psi_tau_MC_map = psi_MC_x_dipole_mapping[0];
  }
  psi.initialization_phasespace_MC_tau();

  psi.initialization_phasespace_IS();
  psi.initialization_MC();

  osi.initialization_TSV();
  osi.initialization_CV();
  if (n_dipoles != osi.n_ps){logger << LOG_FATAL << "n_dipoles = " << n_dipoles << " != " << osi.n_ps << " = osi.n_ps" << endl;}
  osi.initialization_runtime_partonlevel();
  osi.initialization_distribution();
  osi.initialization_integration(psi);

  observable_set save_osi = osi;
  phasespace_set save_psi = psi;
  runresumption_set rsi(osi, psi, save_osi, save_psi);

  osi.initialization_LHAPDF();
  osi.initialization_OpenLoops_process(psi);
  generic.phasespacepoint_psp(osi);
  calculate_ME2check_RA_QCD(psi, osi);

  osi.max_integrand = osi.sigma_normalization; // ???

  if (psi_n_events_max == 0){osi.int_end = 1;}
  if (osi.user.int_value[osi.user.int_map["rescaling_exponent"]] != 0){psi_hcf = psi_hcf * pow(osi.user.double_value[osi.user.double_map["rescaling_factor"]], osi.user.int_value[osi.user.int_map["rescaling_exponent"]]);}

  if (osi.int_end){osi.output_zero_contribution_complete(psi);}
  osi.initialization_runtime();
  while (osi.int_end == 0){
    psi.calculate_IS();

    osi.determine_p_parton(psi);
    // replace by proper nan-check !!!
    if (psi_xbp_all[0] != psi_xbp_all[0]){errorhandling_c_psp_initial(); continue;}
    psi.calculate_IS_RA(dipole);
    if (psi_RA_x_a == 0){generic.ac_psp_psp(0, psi_MC_channel, psi);}
    else {  //  if !(osi.switch_RS_mapping){}
      if      (dipole[psi_RA_x_a].type_dipole() == 1 && dipole[psi_RA_x_a].massive() == 1){psi.ac_psp_RA_group_ij_k_massive(dipole, psi_RA_x_a);}
      else if (dipole[psi_RA_x_a].type_dipole() == 2 && dipole[psi_RA_x_a].massive() == 1){psi.ac_psp_RA_group_ij_a_massive(dipole, psi_dipole_sinx_min[psi_RA_x_a], psi_RA_x_a);}
      else if (dipole[psi_RA_x_a].type_dipole() == 3 && dipole[psi_RA_x_a].massive() == 1){psi.ac_psp_RA_group_ai_k_massive(dipole, psi_dipole_sinx_min[psi_RA_x_a], psi_RA_x_a);}
      else if (dipole[psi_RA_x_a].type_dipole() == 1 && dipole[psi_RA_x_a].massive() == 0){psi.ac_psp_RA_group_ij_k(dipole, psi_RA_x_a);}
      else if (dipole[psi_RA_x_a].type_dipole() == 2 && dipole[psi_RA_x_a].massive() == 0){psi.ac_psp_RA_group_ij_a(dipole, psi_dipole_sinx_min[psi_RA_x_a], psi_RA_x_a);}
      else if (dipole[psi_RA_x_a].type_dipole() == 3 && dipole[psi_RA_x_a].massive() == 0){psi.ac_psp_RA_group_ai_k(dipole, psi_dipole_sinx_min[psi_RA_x_a], psi_RA_x_a);}
      else if (dipole[psi_RA_x_a].type_dipole() == 5){psi.ac_psp_RA_group_ai_b(dipole, psi_dipole_sinx_min[psi_RA_x_a], psi_RA_x_a);}
    }
    psi.correct_phasespacepoint_real();
    for (int i_p = 0; i_p < osi.p_parton[0].size(); i_p++){osi.p_parton[0][psi_o_map[0][i_p]] = psi_xbp_all[0][intpow(2, i_p - 1)];}
    // replace by proper nan-check !!!
    if (psi_xbp_all[0] != psi_xbp_all[0]){errorhandling_c_xbpsp(); continue;}
    for (int ib = 1; ib < osi.p_parton[0].size(); ib++){logger << LOG_DEBUG_VERBOSE << "osi.p_parton[0][" << ib << "][0] = " << psi_xbp_all[0][intpow(2, ib - 1)] << "   " << sqrt(abs(psi_xbp_all[0][intpow(2, ib - 1)].m2())) << endl;}
    for (int ib = 0; ib < osi.p_parton[0].size(); ib++){logger << LOG_DEBUG_VERBOSE << "osi.p_parton[0][" << ib << "] = " << osi.p_parton[0][ib] << "   " << osi.p_parton[0][ib].m2() << "   " << sqrt(abs(osi.p_parton[0][ib].m2())) << endl;}

    psi.determine_dipole_phasespace_RA(dipole);
    for (int i_a = 1; i_a < n_dipoles; i_a++){for (int i_p = 0; i_p < osi.p_parton[i_a].size(); i_p++){osi.p_parton[i_a][i_p] = psi_xbp_all[i_a][intpow(2, i_p - 1)];}}
    psi.correct_phasespacepoint_dipole(); // Which phase-space is acutally corrected here (psi -- osi) ???

    // replace by proper nan-check !!!
    if (osi.p_parton[0] != osi.p_parton[0]){errorhandling_c_psp(); continue;}
    perform_event_selection(osi, generic);
    if (osi.switch_RS == 1){for (int i_a = 1; i_a < n_dipoles; i_a++){osi.cut_ps[i_a] = -1;}}
    else if (osi.switch_RS == 2){osi.cut_ps[0] = -1;}
    osi.first_non_cut_ps = -1;
    for (int i_a = 0; i_a < osi.cut_ps.size(); i_a++){if (osi.cut_ps[i_a] > -1){osi.first_non_cut_ps = i_a; break;}}
    if (osi.first_non_cut_ps == -1){psi.handling_cut_psp(); continue;}
    // from qT subtraction contribution RRA:
    for (int i_a = 0; i_a < osi.cut_ps.size(); i_a++){if (osi.cut_ps[i_a] > -1){if (osi.change_cut[osi.cut_ps[i_a] + 1] == 0){osi.change_cut[osi.cut_ps[i_a] + 1] = 1;}}}

    if (osi.switch_console_output_tau_0){psi.output_check_tau_0();}
    if (osi.switch_output_testpoint){osi.output_testpoint(psi);}
    if (psi_i_acc == psi_n_events_max){osi.int_end = 1;}
    generic.ag_psp_psp(0, 0, psi);
    if (osi.switch_RS_mapping == 0){
      for (int i_a = 1; i_a < n_dipoles; i_a++){
        if      (dipole[i_a].type_dipole() == 1 && dipole[i_a].massive() == 1){psi.ag_psp_RA_group_ij_k_massive(dipole, i_a);}
        else if (dipole[i_a].type_dipole() == 2 && dipole[i_a].massive() == 1){psi.ag_psp_RA_group_ij_a_massive(psi_dipole_sinx_min[i_a], dipole, i_a);}
        else if (dipole[i_a].type_dipole() == 3 && dipole[i_a].massive() == 1){psi.ag_psp_RA_group_ai_k_massive(psi_dipole_sinx_min[i_a], dipole, i_a);}
        else if (dipole[i_a].type_dipole() == 1 && dipole[i_a].massive() == 0){psi.ag_psp_RA_group_ij_k(dipole, i_a);}
        else if (dipole[i_a].type_dipole() == 2 && dipole[i_a].massive() == 0){psi.ag_psp_RA_group_ij_a(psi_dipole_sinx_min[i_a], dipole, i_a);}
        else if (dipole[i_a].type_dipole() == 3 && dipole[i_a].massive() == 0){psi.ag_psp_RA_group_ai_k(psi_dipole_sinx_min[i_a], dipole, i_a);}
        else if (dipole[i_a].type_dipole() == 5){psi.ag_psp_RA_group_ai_b(psi_dipole_sinx_min[i_a], dipole, i_a);}
      }
    }
    psi.calculate_g_tot();
    if (std::isnan(psi_g_tot)){errorhandling_RA_gtot(); continue;} 

    if (osi.user.string_value[osi.user.string_map["model"]] == "Bornloop"){
      osi.determine_techcut_RA(psi);
      if (psi_RA_techcut){psi_RA_techcut = 0; psi.handling_cut_psp(); continue;}
    }
    calculate_ME2_RA_QCD(osi);

    double temp_sum_RA_ME2 = accumulate(osi.RA_ME2.begin(), osi.RA_ME2.end(), 0.);
    if (std::isinf(temp_sum_RA_ME2)){errorhandling_RA_me2(3); continue;}
    if (std::isnan(temp_sum_RA_ME2)){errorhandling_RA_me2(0); continue;}
    if (!(osi.check_vanishing_ME2_end)){handling_vanishing_me2(); if (osi.flag_vanishing_ME2){continue;}}

    if (psi_g_tot == 0.){logger << LOG_INFO << "psi_g_tot == 0." << endl; errorhandling_RA_me2(1); continue;} // does that really happen?
    if (std::isinf(psi_g_tot)){psi.handling_cut_psp(); continue;}

    for (int i_a = 0; i_a < n_dipoles; i_a++){
      if (osi.cut_ps[i_a] != -1){
        generic.calculate_dynamic_scale_RA(i_a, osi);
        generic.calculate_dynamic_scale_TSV(i_a, osi);
	osi.determine_scale_RA(i_a);
      }
    }

    // add proper errorhandling, also for mu_fact !!!
    // replace by proper nan-check !!!
    if (osi.switch_CV && osi.RA_value_factor_alpha_S != osi.RA_value_factor_alpha_S){errorhandling_alpha_S(); continue;}
    if (osi.switch_TSV && osi.value_relative_factor_alpha_S != osi.value_relative_factor_alpha_S){errorhandling_alpha_S(); continue;}

    if (osi.switch_moment){generic.moments(osi);}

    osi.calculate_pdf_LHAPDF_RA_CV();
    //    calculate_pdf_LHAPDF_RA_CV(osi);
    osi.calculate_pdf_LHAPDF_TSV();
    //    calculate_pdf_LHAPDF_TSV(osi);

    osi.determine_integrand_RA(psi);

    logger << LOG_DEBUG_VERBOSE << "i_acc = " << setw(8) << right << psi_i_acc << "   MC_channel = " << setw(8) << right << psi_MC_channel << "   i_gen = " << setw(8) << right << psi_i_gen << "   integrand = " << left << setprecision(15) << setw(23) << osi.integrand << "   g_tot = " << left << setprecision(15) << setw(23) << psi_g_tot << endl;

    // introduce proper nan-check !!!
    if (osi.var_RA_ME2 != osi.var_RA_ME2){errorhandling_RA_me2(1); continue;}
    if (osi.switch_CV && osi.var_RA_ME2_CV != osi.var_RA_ME2_CV){errorhandling_RA_me2(1); continue;}
    osi.determine_techcut_RA(psi);
    if (psi_RA_techcut){psi_RA_techcut = 0; psi.handling_cut_psp(); continue;}

    // introduce proper nan-check !!!
    if (osi.var_RA_ME2_CV != osi.var_RA_ME2_CV){errorhandling_RA_me2(2); continue;}
    if (osi.switch_output_cancellation_check){osi.output_integrand_cancellation_check_RA(psi);}
    if (osi.switch_output_maxevent){osi.output_integrand_maximum_RA(psi);}
    //    logger << LOG_DEBUG << "i_acc = " << setw(8) << right << psi_i_acc << "   i_gen = " << setw(8) << right << psi_i_gen << "   integrand = " << left << setprecision(15) << setw(23) << osi.integrand << "   g_tot = " << left << setprecision(15) << setw(23) << psi_g_tot << endl;
    osi.determine_psp_weight_TSV(psi);
    osi.determine_psp_weight_RA(psi);

    if (osi.switch_distribution){determine_distribution_complete(osi);}

    static double optimization_modifier = 1.;
    if (osi.user.switch_value[osi.user.switch_map["optimization_modifier"]]){
      optimization_modifier = pow(osi.particle_event[osi.access_object["Vrec"]][0][0].pT, osi.user.switch_value[osi.user.switch_map["optimization_modifier"]]);
      logger << LOG_DEBUG << "optimization_modifier = " << optimization_modifier << endl;
    }   

    psi.psp_MCweight_optimization(osi.integrand, osi.this_psp_weight, osi.this_psp_weight2, optimization_modifier);
    psi_i_acc++;
    if (psi_i_acc % psi_n_step == 0){rsi.perform_iteration_step();}
    osi.determine_runtime(psi);
  }
  osi.output_finalization_integration(psi);
}
