#include "../include/classes.cxx"
#include "../include/definitions.observable.set.cxx"

void summary_subprocess::readin_distribution_TSV(){
  Logger logger("summary_subprocess::readin_distribution_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  distribution_N_binwise_TSV.resize(osi->extended_distribution.size());
  distribution_result_TSV.resize(osi->extended_distribution.size());
  distribution_deviation_TSV.resize(osi->extended_distribution.size());
  distribution_chi2_TSV.resize(osi->extended_distribution.size());

  logger << LOG_INFO << ycontribution->type_contribution << "." << ycontribution->type_correction << "   " << name << "   ycontribution->selection_n_qTcut = " << ycontribution->selection_n_qTcut << endl;

  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!ygeneric->switch_output_distribution[i_d]){continue;}
    distribution_result_TSV[i_d].resize(osi->extended_distribution[i_d].n_bins);
    distribution_N_binwise_TSV[i_d].resize(osi->extended_distribution[i_d].n_bins);
    distribution_deviation_TSV[i_d].resize(osi->extended_distribution[i_d].n_bins);
    distribution_chi2_TSV[i_d].resize(osi->extended_distribution[i_d].n_bins);

    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
      distribution_result_TSV[i_d][i_b].resize(ycontribution->selection_n_qTcut);
      distribution_N_binwise_TSV[i_d][i_b].resize(ycontribution->selection_n_qTcut);
      distribution_deviation_TSV[i_d][i_b].resize(ycontribution->selection_n_qTcut);
      distribution_chi2_TSV[i_d][i_b].resize(ycontribution->selection_n_qTcut);
      for (int x_q = 0; x_q < ycontribution->selection_n_qTcut; x_q++){
	distribution_result_TSV[i_d][i_b][x_q].resize(osi->n_set_TSV);
	distribution_N_binwise_TSV[i_d][i_b][x_q].resize(osi->n_set_TSV);
	distribution_deviation_TSV[i_d][i_b][x_q].resize(osi->n_set_TSV);
	distribution_chi2_TSV[i_d][i_b][x_q].resize(osi->n_set_TSV);
	for (int i_s = 0; i_s < osi->n_set_TSV; i_s++){if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	  distribution_result_TSV[i_d][i_b][x_q][i_s].resize(osi->n_scale_ren_TSV[i_s], vector<double> (osi->n_scale_fact_TSV[i_s], 0.));
	  distribution_N_binwise_TSV[i_d][i_b][x_q][i_s].resize(osi->n_scale_ren_TSV[i_s], vector<long long> (osi->n_scale_fact_TSV[i_s], 0));
	  distribution_deviation_TSV[i_d][i_b][x_q][i_s].resize(osi->n_scale_ren_TSV[i_s], vector<double> (osi->n_scale_fact_TSV[i_s], 0.));
	  distribution_chi2_TSV[i_d][i_b][x_q][i_s].resize(osi->n_scale_ren_TSV[i_s], vector<double> (osi->n_scale_fact_TSV[i_s], 0.));
	}
      }
    }
  }

  distribution_run_N_binwise_TSV.resize(ycontribution->directory.size(), distribution_N_binwise_TSV);
  distribution_run_result_TSV.resize(ycontribution->directory.size(), distribution_result_TSV);
  distribution_run_deviation_TSV.resize(ycontribution->directory.size(), distribution_deviation_TSV);
  distribution_run_N_TSV.resize(ycontribution->directory.size(), 0);
  distribution_N_TSV = 0;

  all_distribution_N_binwise_TSV.resize(osi->extended_distribution.size());
  combination_all_distribution_N_binwise_TSV.resize(2, vector<vector<long long> > (osi->extended_distribution.size()));


  for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
    string distribution_file;
    distribution_file = "distribution_" + name + ".txt";
    logger << LOG_DEBUG << "distribution_file = " << distribution_file << endl;
    for (int x_q = 0; x_q < ycontribution->selection_n_qTcut; x_q++){
      for (int i_s = 0; i_s < osi->n_set_TSV; i_s++){if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	if (osi->switch_distribution_TSV[i_s] == 1){
	  distribution_file = "distribution_" + name + ".txt";
	  string filename = "../" + ycontribution->directory[i_z] + "/distribution/" + osi->name_set_TSV[i_s] + "/" + distribution_file;
	  logger << LOG_DEBUG << "filename = " << filename << endl;
	  
	  vector<string> readin;
	  vector<vector<string> > readin_data;
	  char LineBuffer[128];
	  ifstream in_result(filename.c_str());  
	  while (in_result.getline(LineBuffer, 128)){readin.push_back(LineBuffer);}
	  in_result.close();
	  logger << LOG_DEBUG_VERBOSE << "number of input lines in " << filename << " = " << readin.size() << endl;
	  if (readin.size() > 0){
	    
	    for (int i = 0; i < readin.size(); i++){
	      vector<string> temp_s(1);
	      int temp_comment = 0;
	      for (int i_s = 0; i_s < readin[i].size(); i_s++){
		if (readin[i][0] == '#'){temp_comment = 1; break;}
		else if (readin[i][i_s] == ' ' || readin[i][i_s] == char(9)){
		  if (temp_s[temp_s.size() - 1].size() == 0){}
		  else{temp_s.push_back("");}
		}
		else {temp_s[temp_s.size() - 1].push_back(readin[i][i_s]);}
	      }
	      if (temp_comment == 0){
		if (temp_s[temp_s.size() - 1] == ""){temp_s.erase(temp_s.end());}
		readin_data.push_back(temp_s);
	      }
	    }
	    // defintion of default_size ???
	    int default_size = 0;
	    int temp_distfactor = 0;
	    for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){temp_distfactor += osi->extended_distribution[i_d].n_bins;}
	    default_size = ycontribution->selection_n_qTcut * (1 + temp_distfactor * osi->n_scale_ren_TSV[i_s] * osi->n_scale_fact_TSV[i_s]);
	    //	    default_size = osi->n_qTcut * (1 + temp_distfactor * osi->n_scale_ren_TSV[i_s] * osi->n_scale_fact_TSV[i_s]);
	    if (default_size != readin_data.size()){logger << LOG_DEBUG_VERBOSE << "default_size = " << default_size << " != " << readin_data.size() << " = readin_data.size()" << endl;}
	    default_size = readin_data.size();//osi->n_qTcut * (1 + osi->n_scale_ren_TSV[i_s] * osi->n_scale_fact_TSV[i_s]);
	    if (default_size == readin_data.size()){
	      distribution_run_N_TSV[i_z] = atoll(readin_data[0][0].c_str());
	      logger << LOG_DEBUG_VERBOSE << "N_TSV[" << i_z << "] = " << distribution_run_N_TSV[i_z] << endl;
	      int proc = 1;
	      for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
		if (!ygeneric->switch_output_distribution[i_d]){proc += osi->extended_distribution[i_d].n_bins * osi->n_scale_ren_TSV[i_s] * osi->n_scale_fact_TSV[i_s]; continue;}
		// logger << LOG_DEBUG << "osi->extended_distribution[" << i_d << "].xdistribution_name = " << osi->extended_distribution[i_d].xdistribution_name << endl;
		int temp_factor_qTcut = temp_distfactor * osi->n_scale_ren_TSV[i_s] * osi->n_scale_fact_TSV[i_s];
		for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
		  for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
		    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
		      double temp = atof(readin_data[proc + x_q * temp_factor_qTcut + i_b + osi->extended_distribution[i_d].n_bins * (i_r * osi->n_scale_fact_TSV[i_s] + i_f)][0].c_str());
		      distribution_run_N_binwise_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] = (long long)temp;
		      distribution_run_N_binwise_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] = atol(readin_data[proc + x_q * temp_factor_qTcut + i_b + osi->extended_distribution[i_d].n_bins * (i_r * osi->n_scale_fact_TSV[i_s] + i_f)][0].c_str());
		      distribution_run_result_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] = atof(readin_data[proc + x_q * temp_factor_qTcut + i_b + osi->extended_distribution[i_d].n_bins * (i_r * osi->n_scale_fact_TSV[i_s] + i_f)][1].c_str());
		      distribution_run_deviation_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] = atof(readin_data[proc + x_q * temp_factor_qTcut + i_b + osi->extended_distribution[i_d].n_bins * (i_r * osi->n_scale_fact_TSV[i_s] + i_f)][2].c_str());
		    }
		  }
		}
		proc += osi->extended_distribution[i_d].n_bins * osi->n_scale_ren_TSV[i_s] * osi->n_scale_fact_TSV[i_s];
	      }
	    }
	    else {
	      logger << LOG_DEBUG_VERBOSE << "TSV: result_file= " << filename << " has not the expected content!" <<  endl;
	    }
	  }
	  else {
	    logger << LOG_DEBUG_VERBOSE << "TSV: result_file = " << filename << " is empty!" <<  endl;
	  }
	}
      }
      // alternatively: add to proc here !!!
    }
  }
  
  //  first_DS  could be replaced by the reference TSV scale !!!
  int first_DS = 0;
  for (int i_s = 0; i_s < osi->n_set_TSV; i_s++){if (!ygeneric->switch_output_scaleset[i_s]){continue;}if (osi->switch_distribution_TSV[i_s] != 0){first_DS = i_s; break;}}
  for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
    distribution_N_TSV += distribution_run_N_TSV[i_z];
  }
  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!ygeneric->switch_output_distribution[i_d]){continue;}
    all_distribution_N_binwise_TSV[i_d].resize(osi->extended_distribution[i_d].n_bins, 0);
    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
      for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	all_distribution_N_binwise_TSV[i_d][i_b] += distribution_run_N_binwise_TSV[i_z][i_d][i_b][0][first_DS][0][0];
      }
      for (int x_z = 0; x_z < 2; x_z++){
	combination_all_distribution_N_binwise_TSV[x_z][i_d].resize(osi->extended_distribution[i_d].n_bins, 0);
	for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	  if ((x_z == 0 && ycontribution->directory_extra[i_z] == 0) || (x_z == 1 && ycontribution->directory_extra[i_z] == 1)){
	    combination_all_distribution_N_binwise_TSV[x_z][i_d][i_b] += distribution_run_N_binwise_TSV[i_z][i_d][i_b][0][first_DS][0][0];
	  }
	}
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}



void summary_subprocess::combination_distribution_TSV(){
  Logger logger("summary_subprocess::combination_distribution_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_combination = 2;

  distribution_N_combination_TSV.resize(osi->extended_distribution.size(), vector<long long> (n_combination, 0));
  distribution_N_bin_combination_TSV.resize(osi->extended_distribution.size());
  distribution_N_bin_combination_qTcut_TSV.resize(osi->extended_distribution.size());
  distribution_N_combination_qTcut_TSV.resize(osi->extended_distribution.size());

  counter_remove_distribution_run_qTcut_TSV.resize(osi->extended_distribution.size());
  counter_nonzero_distribution_run_qTcut_TSV.resize(osi->extended_distribution.size());

  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!ygeneric->switch_output_distribution[i_d]){continue;}
    distribution_N_bin_combination_TSV[i_d].resize(osi->extended_distribution[i_d].n_bins, vector<long long> (n_combination, 0)); // for each x_q value ???
    distribution_N_combination_qTcut_TSV[i_d].resize(ycontribution->selection_n_qTcut, vector<long long> (n_combination, 0)); // for each x_q value ???
    distribution_N_bin_combination_qTcut_TSV[i_d].resize(osi->extended_distribution[i_d].n_bins, vector<vector<long long> > (ycontribution->selection_n_qTcut, vector<long long> (n_combination, 0))); // for each x_q value ???

    counter_remove_distribution_run_qTcut_TSV[i_d].resize(osi->extended_distribution[i_d].n_bins, vector<int> (ycontribution->selection_n_qTcut, 0));
    counter_nonzero_distribution_run_qTcut_TSV[i_d].resize(osi->extended_distribution[i_d].n_bins, vector<int> (ycontribution->selection_n_qTcut, 0));

    for (int x_z = 0; x_z < n_combination; x_z++){
      for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	if ((x_z == 0 && ycontribution->directory_extra[i_z] == 0) || (x_z == 1 && ycontribution->directory_extra[i_z] == 1)){
	  for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	    distribution_N_bin_combination_TSV[i_d][i_b][x_z] += distribution_run_N_binwise_TSV[i_z][i_d][i_b][0][0][0][0];
	    distribution_N_combination_TSV[i_d][x_z] += distribution_run_N_binwise_TSV[i_z][i_d][i_b][0][0][0][0];
	    for (int x_q = 0; x_q < ycontribution->selection_n_qTcut; x_q++){
	      distribution_N_combination_qTcut_TSV[i_d][x_q][x_z] += distribution_run_N_binwise_TSV[i_z][i_d][i_b][x_q][0][0][0];
	      distribution_N_bin_combination_qTcut_TSV[i_d][i_b][x_q][x_z] += distribution_run_N_binwise_TSV[i_z][i_d][i_b][x_q][0][0][0];
	    }
	  }
	}
      }
    }
    
    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
      int validity_extra = 0;
      for (int x_q = 0; x_q < ycontribution->selection_n_qTcut; x_q++){
	switch_off_run = vector<vector<int> > (n_combination, vector<int> (ycontribution->directory.size(), 0));
	combination_N_tot = vector<long long> (n_combination, 0);
	combination_N_bin = vector<long long> (n_combination, 0);
	combination_N_bin_min = vector<long long> (n_combination, 1000000000);
	combination_fraction = vector<double> (n_combination, 0.);
	combination_result = vector<double> (n_combination, 0.);
	combination_deviation = vector<double> (n_combination, 0.);
	remove_run_bin = vector<int> (ycontribution->directory.size(), 0);
	
	double tolerance_factor = ygeneric->deviation_tolerance_factor;
	int temp_n_nonzero_runs = 0;

	// replace by reference value ???
	int i_s = 0;
	int i_r = (osi->n_scale_ren_TSV[i_s] - 1) / 2;
	int i_f = (osi->n_scale_fact_TSV[i_s] - 1) / 2;

	vector<double> deviation_measure(ycontribution->directory.size(), 0.);
	vector<double> deviation_measure_sorted;
	double min_deviation_measure = 1.e99;
	double max_deviation_measure = 0.;
	for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	  if (distribution_run_N_TSV[i_z] > 0){
	    deviation_measure[i_z] = sqrt(distribution_run_deviation_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] - pow(distribution_run_result_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f], 2) / distribution_run_N_TSV[i_z]) / (distribution_run_N_TSV[i_z] - 1) * sqrt(distribution_run_N_TSV[i_z]);
	    if (deviation_measure[i_z] > 0.){
	      temp_n_nonzero_runs++;
	      if (deviation_measure[i_z] < min_deviation_measure){min_deviation_measure = deviation_measure[i_z];}
	      if (deviation_measure[i_z] > max_deviation_measure){max_deviation_measure = deviation_measure[i_z];}
	      deviation_measure_sorted.push_back(deviation_measure[i_z]);
	    }
	  }
	}
	if (deviation_measure_sorted.size() > 0){
	  sort(deviation_measure_sorted.begin(), deviation_measure_sorted.end());
	  // in order to ignore runs with too low error estimates:
	  min_deviation_measure = deviation_measure_sorted[deviation_measure_sorted.size() / 10];	  

	  double temp_fraction = double(distribution_N_bin_combination_qTcut_TSV[i_d][i_b][x_q][0]) / distribution_N_combination_qTcut_TSV[i_d][x_q][0];
	  tolerance_factor = tolerance_factor * (1. - log10(temp_fraction));
	  
	  for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	    if (distribution_N_bin_combination_qTcut_TSV[i_d][i_b][x_q][0] > 1000 && deviation_measure[i_z] > tolerance_factor * min_deviation_measure){
	      remove_run_bin[i_z] = 1;
	    }
	  }

	  counter_remove_distribution_run_qTcut_TSV[i_d][i_b][x_q] = accumulate(remove_run_bin.begin(), remove_run_bin.end(), 0);
	  counter_nonzero_distribution_run_qTcut_TSV[i_d][i_b][x_q] = temp_n_nonzero_runs;
  	  
	  // test output -> temporary !!!
	  /*
	  if (accumulate(remove_run_bin.begin(), remove_run_bin.end(), 0) > 0){
	    if (osi->extended_distribution[i_d].xdistribution_name == "XS" ||
		osi->extended_distribution[i_d].xdistribution_name == "pT.V" ||
		osi->extended_distribution[i_d].xdistribution_name == "pT.miss_20.0" ||
		osi->extended_distribution[i_d].xdistribution_name == "mT.W_10.0" ||
		osi->extended_distribution[i_d].xdistribution_name == "m.Z_10.0"){
	      cout << setw(5) << ycontribution->type_contribution 
		   << "   " << setw(15) << name 
		   << "   " << setw(19) << osi->extended_distribution[i_d].xdistribution_name 
		   << " >= " << setw(8) << osi->extended_distribution[i_d].bin_edge[i_b] 
		   << "   (x_q = " << setw(2) << x_q << ")"
		   << "   N_bin = " << distribution_N_bin_combination_qTcut_TSV[i_d][i_b][x_q][0] 
		   << " ( " << distribution_N_combination_qTcut_TSV[i_d][x_q][0] << ")" 
		   << "   fraction = " << temp_fraction 
		   << "   threshold = " << tolerance_factor
		   << "   erased: " << setw(8) << accumulate(remove_run_bin.begin(), remove_run_bin.end(), 0)
		   << " (" << temp_n_nonzero_runs << ")" 
		   << endl;
	      for (int i_z = 0; i_z < deviation_measure_sorted.size(); i_z++){
		cout << setprecision(3) << setw(5) << deviation_measure_sorted[i_z] / min_deviation_measure  << " ";
	      }
	      if (accumulate(remove_run_bin.begin(), remove_run_bin.end(), 0) > temp_n_nonzero_runs / 2){cout << "   WARNING";}
	      cout << endl;
	    }
	  }
	  */
	  //
	}
      



	for (int x_z = 0; x_z < n_combination; x_z++){
	  if (x_z == 1 && validity_extra == 0){continue;}
	  for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	    if ((x_z == 0 && ycontribution->directory_extra[i_z] == 1) || (x_z == 1 && ycontribution->directory_extra[i_z] == 0)){switch_off_run[x_z][i_z] = 1;}
	    if (switch_off_run[x_z][i_z] == 0){
	      if (!remove_run_bin[i_z]){
		combination_N_tot[x_z] += distribution_run_N_TSV[i_z];
		combination_N_bin[x_z] += distribution_run_N_binwise_TSV[i_z][i_d][i_b][x_q][0][0][0];
		if (distribution_run_N_binwise_TSV[i_z][i_d][i_b][x_q][0][0][0] > 0 && distribution_run_N_binwise_TSV[i_z][i_d][i_b][x_q][0][0][0] < combination_N_bin_min[x_z]){
		  combination_N_bin_min[x_z] = distribution_run_N_binwise_TSV[i_z][i_d][i_b][x_q][0][0][0];
		}
	      }
	    }
	  }
	  if (distribution_N_combination_TSV[i_d][x_z] == 0){combination_fraction[x_z] = 0;}
	  else {combination_fraction[x_z] = double(combination_all_distribution_N_binwise_TSV[x_z][i_d][i_b]) / double(distribution_N_combination_TSV[i_d][x_z]);}
	  // calculates fractions of "events in bin" over "events in all bins" !!!
	  // logger << LOG_DEBUG_VERBOSE << setw(15) << name << "   combination_fraction[" << x_z << "] = " << setw(15) << setprecision(8) << combination_fraction[x_z] << "   N_binwise = " << setw(12) << combination_all_distribution_N_binwise_TSV[x_z][i_d][i_b] << "       N_tot = " << setw(12) << distribution_N_combination_TSV[i_d][x_z] << endl;
	  // logger << LOG_DEBUG_VERBOSE << setw(15) << name << "                       [" << x_z << "] = " << setw(15) << setprecision(8) << combination_fraction[x_z] << "   com_N_bin = " << setw(12) << combination_N_bin[x_z] << "   com_N_tot = " << setw(12) << combination_N_tot[x_z] << endl;
	}

	// test output -> temporary !!!
	/*
	if (osi->extended_distribution[i_d].xdistribution_name == "XS" ||
	    osi->extended_distribution[i_d].xdistribution_name == "pT.V"){
	  cout << setw(5) << ycontribution->type_contribution 
	       << "   " << setw(15) << name 
	       << "   " << setw(19) << osi->extended_distribution[i_d].xdistribution_name 
	       << " >= " << setw(8) << osi->extended_distribution[i_d].bin_edge[i_b] 
	       << "   (x_q = " << setw(2) << x_q << ")"
	       << "   N_bin = " << setw(10) << distribution_N_bin_combination_qTcut_TSV[i_d][i_b][x_q][0] 
	       << " ( " << setw(10) << distribution_N_combination_qTcut_TSV[i_d][x_q][0] << ")" 
	       << "   N_min_binwise = " << setw(10) << combination_N_bin_min[0] << endl;
	}
	*/
	//
	
	for (int i_s = 0; i_s < osi->n_set_TSV; i_s++){if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	      for (int x_z = 0; x_z < n_combination; x_z++){
		if (x_z > 0 && validity_extra < x_z){continue;}
		if (combination_all_distribution_N_binwise_TSV[x_z][i_d][i_b] == 0){}
		else {
		  //		  if (0 > 100){
		  //		  if (combination_N_bin[x_z] > 1000){
		  if (combination_N_bin_min[x_z] > 100){
		    result_subprocess = 0.;
		    deviation_subprocess = 0.;
		    temp_N_binwise = 0;
		    
		    combine_distribution_hybrid_TSV(x_z, x_q, i_d, i_b, i_s, i_r, i_f);
		    /*
		    // hybrid version should include both extreme cases.
		    // check why the standard conservative method does not work !!!
		    if (ycontribution->average_factor == 0){combine_distribution_aggressive_TSV(x_z, x_q, i_d, i_b, i_s, i_r, i_f);}
		    //		    else if (ycontribution->average_factor == 1){combine_distribution_conservative_TSV(x_z, x_q, i_d, i_b, i_s, i_r, i_f);}
		    else {combine_distribution_hybrid_TSV(x_z, x_q, i_d, i_b, i_s, i_r, i_f);}
		    */

		    if (combination_result[x_z] != combination_result[x_z]){
		      if (temp_N_binwise != 0){
			logger << LOG_INFO << setw(15) << name << "   " << setw(15) << osi->extended_distribution[i_d].xdistribution_name << "   [x_z = " << setw(2) << x_z << "]   [i_d = " << setw(2) << i_d << "][i_b = " << setw(3) << i_b << "][x_q = " << setw(2) << x_q << "][i_s = " << setw(2) << i_s << "][i_r = " << setw(2) << i_r << "][i_f = " << setw(2) << i_f << "]" << "   a 'nan' result has been corrected:   distribution_N_TSV = " << distribution_N_TSV << endl;
			logger << LOG_INFO << setw(36) << "result_subprocess    = " << result_subprocess << endl;
			logger << LOG_INFO << setw(36) << "deviation_subprocess = " << deviation_subprocess << endl;
			logger << LOG_INFO << setw(36) << "distribution_N_TSV   = " << distribution_N_TSV << endl;
			for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
			  logger << LOG_INFO << setw(36) << "x_z = " << setw(3) << x_z << "   i_z = " << setw(3) << i_z << "   distribution_run_N_TSV[" << i_z << "] = " << distribution_run_N_TSV[i_z] << endl;
			  logger << LOG_INFO << setw(54) << "distribution_run_result_TSV[" << i_z << "]    = " << distribution_run_result_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] << endl;
			  logger << LOG_INFO << setw(54) << "distribution_run_deviation_TSV[" << i_z << "] = " << distribution_run_deviation_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] << endl;
			}
		      }
		      combination_result[x_z] = 0.;
		      combination_deviation[x_z] = 0.;
		    }
		  }
		  else {
		    combine_distribution_conservative_TSV(x_z, x_q, i_d, i_b, i_s, i_r, i_f);
		  }
		}
	      }
	      
	      logger << LOG_DEBUG_VERBOSE << "combination_result[0] = " << setw(23) << setprecision(15) << combination_result[0] << "   combination_result[1] = " << setw(23) << setprecision(15) << combination_result[1] << endl;
	      
	      if (combination_result[0] == 0. && combination_result[1] == 0.){
		distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = 0.;
		distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = 0.;
	      }
	      else if (combination_result[1] == 0. || validity_extra == 0){ // only 0-contribution valid 
		distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_result[0];
		distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_deviation[0];
	      }
	      else if (validity_extra == 1){ // always use high-energy result if valid !!!
		distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_result[1];
		distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_deviation[1];
	      }
	      else if (combination_result[0] == 0.){
		logger << LOG_INFO << "Should not happen (1) !" << endl;
		distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_result[1];
		distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_deviation[1];
	      }
	      else if (combination_fraction[0] >= combination_fraction[1]){
		logger << LOG_INFO << "Should not happen (2) !" << endl;
		distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_result[0];
		distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_deviation[0];
	      }
	      else if (combination_all_distribution_N_binwise_TSV[0][i_d][i_b] * 100 < combination_all_distribution_N_binwise_TSV[1][i_d][i_b] && 
		       combination_fraction[0] * 10 < combination_fraction[1]){
		logger << LOG_INFO << "Should not happen (3) !" << endl;
		distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_result[1];
		distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_deviation[1];
	      }
	      else if (combination_fraction[0] * 100 < combination_fraction[1]){
		logger << LOG_INFO << "Should not happen (4) !" << endl;
		distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_result[1];
		distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_deviation[1];
	      }
	      else if (combination_fraction[1] > combination_fraction[0] && 
		       combination_all_distribution_N_binwise_TSV[1][i_d][i_b] > 10 * combination_all_distribution_N_binwise_TSV[0][i_d][i_b]){ // combination_deviation[0] > combination_deviation[1]
		logger << LOG_INFO << "Should not happen (5) !" << endl;
		double result_subprocess = 0.;
		double deviation_subprocess = 0.;
		vector<double> deltasigma(2, 0.);
		vector<double> singleweight(2, 0.);
		for (int x_z = 0; x_z < 2; x_z++){
		  singleweight[x_z] = 1. / pow(combination_deviation[x_z], 2);
		  result_subprocess += singleweight[x_z] * combination_result[x_z];
		  deviation_subprocess += singleweight[x_z];
		}
		distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = result_subprocess / deviation_subprocess;
		distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = 1. / sqrt(deviation_subprocess);
	      }
	      else {
		logger << LOG_INFO << "Should not happen (6) !" << endl;
		distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_result[0];
		distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = combination_deviation[0];
	      }


	      //  chi2 calculation:

	      distribution_chi2_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = 0.;
	      logger << LOG_DEBUG_VERBOSE << "chi2 evaluation in " << ycontribution->resultdirectory << " -- " << ycontribution->infix_contribution << " -- " << ycontribution->infix_order_contribution <<  " -- " << ycontribution->infix_path_contribution << " --- " << name << endl;
	      logger << LOG_DEBUG_VERBOSE << "combined result = " << setw(15) << setprecision(9) << distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f] << " +- " << setw(15) << setprecision(9) << distribution_deviation_TSV[i_d][i_b][x_q][i_s][i_r][i_f] << endl;
	      if (counter_nonzero_distribution_run_qTcut_TSV[i_d][i_b][x_q] > 0){
		for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
		  logger << LOG_DEBUG_VERBOSE << "result[" << setw(5) << i_z << "]   = " << setw(15) << setprecision(9) << distribution_run_result_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] << " +- " << setw(15) << setprecision(9) << distribution_run_deviation_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] << "   ---   " << distribution_run_N_TSV[i_z] << endl;
		  logger << LOG_DEBUG_VERBOSE << "result[" << setw(5) << i_z << "]   = " << setw(15) << setprecision(9) << distribution_run_result_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] / distribution_run_N_TSV[i_z] << " +- " << setw(15) << setprecision(9) << sqrt(distribution_run_deviation_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] - pow(distribution_run_result_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f], 2) / distribution_run_N_TSV[i_z]) / (distribution_run_N_TSV[i_z] - 1) << endl;
		  if (!(distribution_run_result_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] == 0. && distribution_run_deviation_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] == 0.)){
		    double temp_run_result = distribution_run_result_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] / distribution_run_N_TSV[i_z];
		    double temp_run_deviation = sqrt(distribution_run_deviation_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] - pow(distribution_run_result_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f], 2) / distribution_run_N_TSV[i_z]) / (distribution_run_N_TSV[i_z] - 1);
		    distribution_chi2_TSV[i_d][i_b][x_q][i_s][i_r][i_f] += pow((temp_run_result - distribution_result_TSV[i_d][i_b][x_q][i_s][i_r][i_f]) / temp_run_deviation, 2.);
		  }
		}
		distribution_chi2_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = distribution_chi2_TSV[i_d][i_b][x_q][i_s][i_r][i_f] / counter_nonzero_distribution_run_qTcut_TSV[i_d][i_b][x_q];
	      }
	      if (counter_nonzero_distribution_run_qTcut_TSV[i_d][i_b][x_q] < 2){distribution_chi2_TSV[i_d][i_b][x_q][i_s][i_r][i_f] = 0.;}
	      //  chi2 cannot be reasonably defined for only one run.

	    }
	  }
	}
      }
    }
  }

  vector<long long> ().swap(distribution_run_N_TSV);
  vector<vector<vector<vector<vector<vector<vector<long long> > > > > > > ().swap(distribution_run_N_binwise_TSV);
  vector<vector<vector<vector<vector<vector<vector<double> > > > > > > ().swap(distribution_run_result_TSV);
  vector<vector<vector<vector<vector<vector<vector<double> > > > > > > ().swap(distribution_run_deviation_TSV);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}



void summary_subprocess::combine_distribution_conservative_TSV(int x_z, int x_q, int i_d, int i_b, int i_s, int i_r, int i_f){
  Logger logger("summary_subprocess::combine_distribution_conservative_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  logger << LOG_DEBUG_VERBOSE << "original calculation" << endl;

  result_subprocess = 0.;
  deviation_subprocess = 0.;
  N_subprocess = 0;
  
  for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
    if (distribution_run_N_TSV[i_z] != 0 && switch_off_run[x_z][i_z] == 0){
      N_subprocess += distribution_run_N_TSV[i_z];
      if (distribution_run_N_binwise_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] > 0){
	result_subprocess += distribution_run_result_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f];
	deviation_subprocess += distribution_run_deviation_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f];
      }
    }
  }
  if (N_subprocess != 0){
    combination_result[x_z] = result_subprocess / N_subprocess; 
    combination_deviation[x_z] = sqrt((N_subprocess * deviation_subprocess - pow(result_subprocess, 2)) / N_subprocess) / (N_subprocess - 1);
  }
  else {
    combination_result[x_z] = 0.;
    combination_deviation[x_z] = 0.;
  }
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}



void summary_subprocess::combine_distribution_hybrid_TSV(int x_z, int x_q, int i_d, int i_b, int i_s, int i_r, int i_f){
  Logger logger("summary_subprocess::combine_distribution_hybrid_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_conservative = ycontribution->average_factor;
  int temp_n_conservative = 0;
  int temp_n_runs = 0;
  vector<int> temp_list_no_run;
  for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
    if (!remove_run_bin[i_z]){
      if (distribution_run_N_TSV[i_z] != 0){
	temp_n_runs++;
	temp_list_no_run.push_back(i_z);
      }
    }
  }
  if (temp_n_runs < n_conservative){temp_n_conservative = temp_n_runs;}
  else {temp_n_conservative = n_conservative;}
  if (ycontribution->average_factor == 0){temp_n_conservative = temp_n_runs;}

  vector<double> conservative_result_run_TSV(temp_n_conservative, 0.);
  vector<double> conservative_deviation_run_TSV(temp_n_conservative, 0.);
  vector<double> conservative_chi2_TSV(temp_n_conservative, 0.);
  vector<long long> conservative_N_all(temp_n_conservative, 0);
  vector<long long> conservative_no_results(temp_n_conservative, 0);
  
  for (int i_z = 0; i_z < temp_list_no_run.size(); i_z++){
    int conservative_i_z = i_z % temp_n_conservative;

    if (!(distribution_run_result_TSV[temp_list_no_run[i_z]][i_d][i_b][x_q][i_s][i_r][i_f] == 0. && distribution_run_deviation_TSV[temp_list_no_run[i_z]][i_d][i_b][x_q][i_s][i_r][i_f] == 0.)){
      ///      if (!remove_run_bin[temp_list_no_run[i_z]]){
      temp_N_binwise += distribution_run_N_binwise_TSV[temp_list_no_run[i_z]][i_d][i_b][x_q][i_s][i_r][i_f];
      conservative_N_all[conservative_i_z] += distribution_run_N_TSV[temp_list_no_run[i_z]];
      conservative_no_results[conservative_i_z]++;
      // input different for distributions
      conservative_result_run_TSV[conservative_i_z] += distribution_run_result_TSV[temp_list_no_run[i_z]][i_d][i_b][x_q][i_s][i_r][i_f];
      // distribution_run_result_TSV   should be sum over weights
      conservative_deviation_run_TSV[conservative_i_z] += distribution_run_deviation_TSV[temp_list_no_run[i_z]][i_d][i_b][x_q][i_s][i_r][i_f];
      // distribution_run_result_TSV   should be sum over squared weights
      // logger << LOG_DEBUG << "conservative_N_all[" << setw(3) << conservative_i_z << "] = " << setw(10) << conservative_N_all[conservative_i_z] << "   distribution_run_N_TSV[" << setw(3) << i_z << "] = " << setw(10) << distribution_run_N_TSV[i_z] << "   result = " << distribution_run_result_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] << " +- " << distribution_run_deviation_TSV[i_z][i_d][i_b][x_q][i_s][i_r][i_f] << endl;
	///      }
	///      else {logger << LOG_INFO << "Should never happen !!!" << endl;}
    }
  }

  for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
    conservative_deviation_run_TSV[conservative_i_z] = sqrt((conservative_N_all[conservative_i_z] * conservative_deviation_run_TSV[conservative_i_z] - pow(conservative_result_run_TSV[conservative_i_z], 2)) / conservative_N_all[conservative_i_z]) / (conservative_N_all[conservative_i_z] - 1); 
    conservative_result_run_TSV[conservative_i_z] = conservative_result_run_TSV[conservative_i_z] / conservative_N_all[conservative_i_z];
  }
  for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
    //    conservative_chi2_TSV[conservative_i_z] = conservative_chi2_TSV[conservative_i_z] / conservative_no_results[conservative_i_z];
    if (conservative_no_results[conservative_i_z] == 0){
      conservative_result_run_TSV[conservative_i_z] = 0.;
      conservative_deviation_run_TSV[conservative_i_z] = 0.;
    }
  }
  
  combination_N_event_all = 0;
  for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
    combination_N_event_all += conservative_N_all[conservative_i_z];
    if (conservative_N_all[conservative_i_z] > 0){no_results++;}
  }
  if (combination_N_event_all != 0){
    combination_result[x_z] = 0.;
    combination_deviation[x_z] = 0.;
    for (int i_z = 0; i_z < temp_n_conservative; i_z++){
      if (distribution_run_N_TSV[i_z] != 0 && conservative_result_run_TSV[i_z] != 0. && conservative_deviation_run_TSV[i_z] != 0.){
	double temp_singleweight = 1. / pow(conservative_deviation_run_TSV[i_z], 2);
	logger << LOG_DEBUG_VERBOSE << "z_result_TSV[" << i_z << "] = " << setw(23) << setprecision(15) << conservative_result_run_TSV[i_z] << " +- = " << setw(23) << setprecision(15) << conservative_deviation_run_TSV[i_z] << endl;
	combination_result[x_z] += temp_singleweight * conservative_result_run_TSV[i_z];
	combination_deviation[x_z] += temp_singleweight;
      }
      else if (distribution_run_N_TSV[i_z] != 0 && conservative_result_run_TSV[i_z] == 0. && conservative_deviation_run_TSV[i_z] == 0.){
	combination_result[x_z] += 0.;
	combination_deviation[x_z] += 0.;
	logger << LOG_DEBUG_VERBOSE << "empty: z_result_TSV[" << i_z << "] = " << setw(23) << setprecision(15) << conservative_result_run_TSV[i_z] << " +- = " << setw(23) << setprecision(15) << conservative_deviation_run_TSV[i_z] << endl;
      }
    }
    if (combination_N_event_all != 0 && combination_result[x_z] != 0. && combination_deviation[x_z] != 0.){
      combination_result[x_z] = combination_result[x_z] / combination_deviation[x_z];
      combination_deviation[x_z] = 1. / sqrt(combination_deviation[x_z]);
    }
    else {
      combination_result[x_z] = 0.;
      combination_deviation[x_z] = 0.;
    }
  }
  else if (combination_N_event_all == 0){
    combination_result[x_z] = 0.;
    combination_deviation[x_z] = 0.;
  }
  
  for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
    if (!(distribution_run_result_TSV[conservative_i_z][i_d][i_b][x_q][i_s][i_r][i_f] == 0. && 
	  distribution_run_deviation_TSV[conservative_i_z][i_d][i_b][x_q][i_s][i_r][i_f] == 0.)){
      conservative_chi2_TSV[conservative_i_z] += pow((conservative_result_run_TSV[conservative_i_z] - combination_result[x_z]) / conservative_deviation_run_TSV[conservative_i_z], 2.);
    }
    conservative_chi2_TSV[conservative_i_z] = conservative_chi2_TSV[conservative_i_z] / temp_n_conservative;
  }
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}








void summary_subprocess::readin_distribution_CV(){
  Logger logger("summary_subprocess::readin_distribution_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  distribution_N_CV.resize(osi->extended_distribution.size(), 0);
  distribution_N_binwise_CV.resize(osi->extended_distribution.size());
  distribution_result_CV.resize(osi->extended_distribution.size());
  distribution_deviation_CV.resize(osi->extended_distribution.size());
  distribution_chi2_CV.resize(osi->extended_distribution.size());

  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!ygeneric->switch_output_distribution[i_d]){continue;}
    distribution_N_binwise_CV[i_d].resize(osi->extended_distribution[i_d].n_bins, 0);
    distribution_result_CV[i_d].resize(osi->extended_distribution[i_d].n_bins, vector<double> (osi->n_scales_CV, 0.));
    distribution_deviation_CV[i_d].resize(osi->extended_distribution[i_d].n_bins, vector<double> (osi->n_scales_CV, 0.));
    distribution_chi2_CV[i_d].resize(osi->extended_distribution[i_d].n_bins, vector<double> (osi->n_scales_CV, 0.));
  }

  distribution_run_N_CV.resize(ycontribution->directory.size(), distribution_N_CV);
  //  (roughly) equivalent of distribution_run_N_TSV
  distribution_run_N_binwise_CV.resize(ycontribution->directory.size(), distribution_N_binwise_CV);
  distribution_run_result_CV.resize(ycontribution->directory.size(), distribution_result_CV);
  distribution_run_deviation_CV.resize(ycontribution->directory.size(), distribution_deviation_CV);
  //  distribution_N_TSV = 0;
  // !!! missing: equivalent of distribution_N_TSV

  all_distribution_N_binwise_CV.resize(osi->extended_distribution.size());
  combination_all_distribution_N_binwise_CV.resize(2, vector<vector<long long> > (osi->extended_distribution.size()));
  // newly introduced: equivalent of  all_distribution_N_binwise_TSV  and  combination_all_distribution_N_binwise_TSV

  //  distribution_run_deltasigma.resize(ycontribution->directory.size(), distribution_result_CV);
  //  distribution_run_weight.resize(ycontribution->directory.size(), distribution_result_CV);
  
  
  for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
    for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
      if (!ygeneric->switch_output_distribution[i_d]){continue;}
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	string filename = "../" + ycontribution->directory[i_z] + "/distribution/CV/" + osi->directory_name_scale_CV[i_s] + "/" + osi->extended_distribution[i_d].xdistribution_name + "_" + name + ".dat";
	vector<string> readin;
	char LineBuffer[128];
	ifstream in_result(filename.c_str());  
	while (in_result.getline(LineBuffer, 128)){readin.push_back(LineBuffer);}
	in_result.close();
	logger << LOG_DEBUG_VERBOSE << filename << "   number of lines: " << setw(5) << readin.size() << endl;
	if (readin.size() != 0){
	  distribution_run_N_CV[i_z][i_d] = atoll(readin[0].c_str());
	  for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	    distribution_run_N_binwise_CV[i_z][i_d][i_b] = atoll(readin[1 + i_b * 3].c_str());
	    //  N[i_z][i_p][i_d][i_b] = N[i_z][i_p][i_d][i_b] / (osi->n_scales_CV + 1); // !!! ???
	    distribution_run_result_CV[i_z][i_d][i_b][i_s] = atof(readin[2 + i_b * 3].c_str());
	    distribution_run_deviation_CV[i_z][i_d][i_b][i_s] = atof(readin[3 + i_b * 3].c_str());
	    //  distribution_run_deviation_CV[i_z][i_d][i_b][i_s] = distribution_run_deviation_CV[i_z][i_d][i_b][i_s] * 2; // !!! ???
	  }
	}
	else {
	  distribution_run_N_CV[i_z][i_d] = 0;
	  for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	    distribution_run_N_binwise_CV[i_z][i_d][i_b] = 0;
	    distribution_run_result_CV[i_z][i_d][i_b][i_s] = 0.;
	    distribution_run_deviation_CV[i_z][i_d][i_b][i_s] = 0.;
	  }
	}
      }
    }
  }

  //  distribution_N_TSV-equivalent filled here ???
  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!ygeneric->switch_output_distribution[i_d]){continue;}
    distribution_N_CV[i_d] = 0;
    for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
      distribution_N_CV[i_d] += distribution_run_N_CV[i_z][i_d];
    }
    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
      distribution_N_binwise_CV[i_d][i_b] = 0;
      for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	distribution_N_binwise_CV[i_d][i_b] += distribution_run_N_binwise_CV[i_z][i_d][i_b];
      }
    }
  }


  //  new: definition of
  //  all_distribution_N_binwise_CV
  //  combination_all_distribution_N_binwise_CV
  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!ygeneric->switch_output_distribution[i_d]){continue;}
    all_distribution_N_binwise_CV[i_d].resize(osi->extended_distribution[i_d].n_bins, 0);
    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
      for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	all_distribution_N_binwise_CV[i_d][i_b] += distribution_run_N_binwise_CV[i_z][i_d][i_b];
      }
      for (int x_z = 0; x_z < 2; x_z++){
	combination_all_distribution_N_binwise_CV[x_z][i_d].resize(osi->extended_distribution[i_d].n_bins, 0);
	for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	  if ((x_z == 0 && ycontribution->directory_extra[i_z] == 0) || (x_z == 1 && ycontribution->directory_extra[i_z] == 1)){
	    combination_all_distribution_N_binwise_CV[x_z][i_d][i_b] += distribution_run_N_binwise_CV[i_z][i_d][i_b];
	  }
	}
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}



void summary_subprocess::combination_distribution_CV(){
  Logger logger("summary_subprocess::combination_distribution_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_combination = 2;

  distribution_N_combination_CV.resize(osi->extended_distribution.size(), vector<long long> (n_combination, 0));
  distribution_N_bin_combination_CV.resize(osi->extended_distribution.size());

  counter_remove_distribution_run_CV.resize(osi->extended_distribution.size());
  counter_nonzero_distribution_run_CV.resize(osi->extended_distribution.size());

  for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
    if (!ygeneric->switch_output_distribution[i_d]){continue;}
    distribution_N_bin_combination_CV[i_d].resize(osi->extended_distribution[i_d].n_bins, vector<long long> (n_combination, 0));

    counter_remove_distribution_run_CV[i_d].resize(osi->extended_distribution[i_d].n_bins, 0);
    counter_nonzero_distribution_run_CV[i_d].resize(osi->extended_distribution[i_d].n_bins, 0);

    for (int x_z = 0; x_z < n_combination; x_z++){
      for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	if ((x_z == 0 && ycontribution->directory_extra[i_z] == 0) || (x_z == 1 && ycontribution->directory_extra[i_z] == 1)){
	  for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	    distribution_N_bin_combination_CV[i_d][i_b][x_z] += distribution_run_N_binwise_CV[i_z][i_d][i_b];
	    distribution_N_combination_CV[i_d][x_z] += distribution_run_N_binwise_CV[i_z][i_d][i_b];
	  }
	}
      }
    }
    
    for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
      int validity_extra = 0;
      for (int x_q = 0; x_q < ycontribution->selection_n_qTcut; x_q++){
	switch_off_run = vector<vector<int> > (n_combination, vector<int> (ycontribution->directory.size(), 0));
	combination_N_tot = vector<long long> (n_combination, 0);
	combination_N_bin = vector<long long> (n_combination, 0);
	combination_N_bin_min = vector<long long> (n_combination, 1000000000);
	combination_fraction = vector<double> (n_combination, 0.);
	combination_result = vector<double> (n_combination, 0.);
	combination_deviation = vector<double> (n_combination, 0.);
	remove_run_bin = vector<int> (ycontribution->directory.size(), 0);
	
	double tolerance_factor = ygeneric->deviation_tolerance_factor;
	int temp_n_nonzero_runs = 0;
	int i_s = (osi->n_scales_CV - 1) / 2;
	vector<double> deviation_measure(ycontribution->directory.size(), 0.);
	vector<double> deviation_measure_sorted;
	double min_deviation_measure = 1.e99;
	double max_deviation_measure = 0.;
	for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	  if (distribution_run_N_CV[i_z][i_d] > 0){
	    deviation_measure[i_z] = sqrt(distribution_run_deviation_CV[i_z][i_d][i_b][i_s] - pow(distribution_run_result_CV[i_z][i_d][i_b][i_s], 2) / distribution_run_N_CV[i_z][i_d]) / (distribution_run_N_CV[i_z][i_d] - 1) * sqrt(distribution_run_N_CV[i_z][i_d]);
	    if (deviation_measure[i_z] > 0.){
	      temp_n_nonzero_runs++;
	      if (deviation_measure[i_z] < min_deviation_measure){min_deviation_measure = deviation_measure[i_z];}
	      if (deviation_measure[i_z] > max_deviation_measure){max_deviation_measure = deviation_measure[i_z];}
	      deviation_measure_sorted.push_back(deviation_measure[i_z]);
	    }
	  }
	}
	if (deviation_measure_sorted.size() > 0){
	  sort(deviation_measure_sorted.begin(), deviation_measure_sorted.end());
	  // in order to ignore runs with too low error estimates:
	  min_deviation_measure = deviation_measure_sorted[deviation_measure_sorted.size() / 10];	  

	  double temp_fraction = double(distribution_N_bin_combination_CV[i_d][i_b][0]) / distribution_N_combination_CV[i_d][0];
	  tolerance_factor = tolerance_factor * (1. - log10(temp_fraction));
	  
	  for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	    if (distribution_N_bin_combination_CV[i_d][i_b][0] > 1000 && deviation_measure[i_z] > tolerance_factor * min_deviation_measure){
	      remove_run_bin[i_z] = 1;
	    }
	  }

	  counter_remove_distribution_run_CV[i_d][i_b] = accumulate(remove_run_bin.begin(), remove_run_bin.end(), 0);
	  counter_nonzero_distribution_run_CV[i_d][i_b] = temp_n_nonzero_runs;
	}

	for (int x_z = 0; x_z < n_combination; x_z++){
	  if (x_z == 1 && validity_extra == 0){continue;}
	  for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	    if ((x_z == 0 && ycontribution->directory_extra[i_z] == 1) || (x_z == 1 && ycontribution->directory_extra[i_z] == 0)){switch_off_run[x_z][i_z] = 1;}
	    if (switch_off_run[x_z][i_z] == 0){
	      if (!remove_run_bin[i_z]){
		combination_N_tot[x_z] += distribution_run_N_CV[i_z][i_d];
		combination_N_bin[x_z] += distribution_run_N_binwise_CV[i_z][i_d][i_b];
		if (distribution_run_N_binwise_CV[i_z][i_d][i_b] > 0 && distribution_run_N_binwise_CV[i_z][i_d][i_b] < combination_N_bin_min[x_z]){
		  combination_N_bin_min[x_z] = distribution_run_N_binwise_CV[i_z][i_d][i_b];
		}
	      }
	    }
	  }
	  if (distribution_N_combination_CV[i_d][x_z] == 0){combination_fraction[x_z] = 0;}
	  else {combination_fraction[x_z] = double(combination_all_distribution_N_binwise_CV[x_z][i_d][i_b]) / double(distribution_N_combination_CV[i_d][x_z]);}
	  // calculates fractions of "events in bin" over "events in all bins" !!!
	}

	for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	  for (int x_z = 0; x_z < n_combination; x_z++){
	    if (x_z > 0 && validity_extra < x_z){continue;}
	    if (combination_all_distribution_N_binwise_CV[x_z][i_d][i_b] == 0){}
	    else {
	      //		  if (0 > 100){
	      //		  if (combination_N_bin[x_z] > 1000){
	      if (combination_N_bin_min[x_z] > 100){
		result_subprocess = 0.;
		deviation_subprocess = 0.;
		temp_N_binwise = 0;
		
		combine_distribution_hybrid_CV(x_z, i_d, i_b, i_s);

		if (combination_result[x_z] != combination_result[x_z]){
		  if (temp_N_binwise != 0){
		    logger << LOG_INFO << setw(15) << name << "   " << setw(15) << osi->extended_distribution[i_d].xdistribution_name << "   [x_z = " << setw(2) << x_z << "]   [i_d = " << setw(2) << i_d << "][i_b = " << setw(3) << i_b << "][x_q = " << setw(2) << x_q << "][i_s = " << setw(2) << i_s << "]" << "   a 'nan' result has been corrected:   distribution_N_CV[" << setw(2) << i_d << "] = " << distribution_N_CV[i_d] << endl;
		    logger << LOG_INFO << setw(36) << "result_subprocess    = " << result_subprocess << endl;
		    logger << LOG_INFO << setw(36) << "deviation_subprocess = " << deviation_subprocess << endl;
		    logger << LOG_INFO << setw(36) << "distribution_N_CV[" << setw(2) << i_d << "]   = " << distribution_N_CV[i_d] << endl;
		    for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
		      logger << LOG_INFO << setw(36) << "x_z = " << setw(3) << x_z << "   i_z = " << setw(3) << i_z << "   distribution_run_N_CV[" << i_z << "][" << i_d << "] = " << distribution_run_N_CV[i_z][i_d] << endl;
		      logger << LOG_INFO << setw(54) << "distribution_run_result_CV[" << i_z << "]    = " << distribution_run_result_CV[i_z][i_d][i_b][i_s] << endl;
		      logger << LOG_INFO << setw(54) << "distribution_run_deviation_CV[" << i_z << "] = " << distribution_run_deviation_CV[i_z][i_d][i_b][i_s] << endl;
		    }
		  }
		  combination_result[x_z] = 0.;
		  combination_deviation[x_z] = 0.;
		}
	      }
	      else {
		combine_distribution_conservative_CV(x_z, i_d, i_b, i_s);
	      }
	    }
	  }
	  
	  logger << LOG_DEBUG_VERBOSE << "combination_result[0] = " << setw(23) << setprecision(15) << combination_result[0] << "   combination_result[1] = " << setw(23) << setprecision(15) << combination_result[1] << endl;
	  
	  if (combination_result[0] == 0. && combination_result[1] == 0.){
	    distribution_result_CV[i_d][i_b][i_s] = 0.;
	    distribution_deviation_CV[i_d][i_b][i_s] = 0.;
	  }
	  else if (combination_result[1] == 0. || validity_extra == 0){ // only 0-contribution valid 
	    logger << LOG_DEBUG_VERBOSE << "(combination_result[1] == 0. || validity_extra == 0)" << endl;
	    distribution_result_CV[i_d][i_b][i_s] = combination_result[0];
	    distribution_deviation_CV[i_d][i_b][i_s] = combination_deviation[0];
	  }
	  else if (validity_extra == 1){ // always use high-energy result if valid !!!
	    distribution_result_CV[i_d][i_b][i_s] = combination_result[1];
	    distribution_deviation_CV[i_d][i_b][i_s] = combination_deviation[1];
	  }
	  else if (combination_result[0] == 0.){
	    logger << LOG_INFO << "Should not happen (1) !" << endl;
	    distribution_result_CV[i_d][i_b][i_s] = combination_result[1];
	    distribution_deviation_CV[i_d][i_b][i_s] = combination_deviation[1];
	  }
	  else if (combination_fraction[0] >= combination_fraction[1]){
	    logger << LOG_INFO << "Should not happen (2) !" << endl;
	    distribution_result_CV[i_d][i_b][i_s] = combination_result[0];
	    distribution_deviation_CV[i_d][i_b][i_s] = combination_deviation[0];
	  }
	  else if (combination_all_distribution_N_binwise_CV[0][i_d][i_b] * 100 < combination_all_distribution_N_binwise_CV[1][i_d][i_b] && 
		   combination_fraction[0] * 10 < combination_fraction[1]){
	    logger << LOG_INFO << "Should not happen (3) !" << endl;
	    distribution_result_CV[i_d][i_b][i_s] = combination_result[1];
	    distribution_deviation_CV[i_d][i_b][i_s] = combination_deviation[1];
	  }
	  else if (combination_fraction[0] * 100 < combination_fraction[1]){
	    logger << LOG_INFO << "Should not happen (4) !" << endl;
	    distribution_result_CV[i_d][i_b][i_s] = combination_result[1];
	    distribution_deviation_CV[i_d][i_b][i_s] = combination_deviation[1];
	  }
	  else if (combination_fraction[1] > combination_fraction[0] && 
		   combination_all_distribution_N_binwise_CV[1][i_d][i_b] > 10 * combination_all_distribution_N_binwise_CV[0][i_d][i_b]){ // combination_deviation[0] > combination_deviation[1]
	    logger << LOG_INFO << "Should not happen (5) !" << endl;
	    double result_subprocess = 0.;
	    double deviation_subprocess = 0.;
	    vector<double> deltasigma(2, 0.);
	    vector<double> singleweight(2, 0.);
	    for (int x_z = 0; x_z < 2; x_z++){
	      singleweight[x_z] = 1. / pow(combination_deviation[x_z], 2);
	      result_subprocess += singleweight[x_z] * combination_result[x_z];
	      deviation_subprocess += singleweight[x_z];
	    }
	    distribution_result_CV[i_d][i_b][i_s] = result_subprocess / deviation_subprocess;
	    distribution_deviation_CV[i_d][i_b][i_s] = 1. / sqrt(deviation_subprocess);
	  }
	  else {
	    logger << LOG_INFO << "Should not happen (6) !" << endl;
	    distribution_result_CV[i_d][i_b][i_s] = combination_result[0];
	    distribution_deviation_CV[i_d][i_b][i_s] = combination_deviation[0];
	  }

	  
	  //  chi2 calculation:
	  
	  distribution_chi2_CV[i_d][i_b][i_s] = 0.;
	  logger << LOG_DEBUG_VERBOSE << "chi2 evaluation in " << ycontribution->resultdirectory << " -- " << ycontribution->infix_contribution << " -- " << ycontribution->infix_order_contribution <<  " -- " << ycontribution->infix_path_contribution << " --- " << name << endl;
	  logger << LOG_DEBUG_VERBOSE << "combined result = " << setw(15) << setprecision(9) << distribution_result_CV[i_d][i_b][i_s] << " +- " << setw(15) << setprecision(9) << distribution_deviation_CV[i_d][i_b][i_s] << endl;
	  if (counter_nonzero_distribution_run_CV[i_d][i_b] > 0){
	    for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
	      logger << LOG_DEBUG_VERBOSE << "result[" << setw(5) << i_z << "]   = " << setw(15) << setprecision(9) << distribution_run_result_CV[i_z][i_d][i_b][i_s] << " +- " << setw(15) << setprecision(9) << distribution_run_deviation_CV[i_z][i_d][i_b][i_s] << "   ---   " << distribution_run_N_CV[i_z][i_d] << endl;
	      logger << LOG_DEBUG_VERBOSE << "result[" << setw(5) << i_z << "]   = " << setw(15) << setprecision(9) << distribution_run_result_CV[i_z][i_d][i_b][i_s] / distribution_run_N_CV[i_z][i_d] << " +- " << setw(15) << setprecision(9) << sqrt(distribution_run_deviation_CV[i_z][i_d][i_b][i_s] - pow(distribution_run_result_CV[i_z][i_d][i_b][i_s], 2) / distribution_run_N_CV[i_z][i_d]) / (distribution_run_N_CV[i_z][i_d] - 1) << endl;
	      if (!(distribution_run_result_CV[i_z][i_d][i_b][i_s] == 0. && distribution_run_deviation_CV[i_z][i_d][i_b][i_s] == 0.)){
		double temp_run_result = distribution_run_result_CV[i_z][i_d][i_b][i_s] / distribution_run_N_CV[i_z][i_d];
		double temp_run_deviation = sqrt(distribution_run_deviation_CV[i_z][i_d][i_b][i_s] - pow(distribution_run_result_CV[i_z][i_d][i_b][i_s], 2) / distribution_run_N_CV[i_z][i_d]) / (distribution_run_N_CV[i_z][i_d] - 1);
		distribution_chi2_CV[i_d][i_b][i_s] += pow((temp_run_result - distribution_result_CV[i_d][i_b][i_s]) / temp_run_deviation, 2.);
	      }
	    }
	    distribution_chi2_CV[i_d][i_b][i_s] = distribution_chi2_CV[i_d][i_b][i_s] / counter_nonzero_distribution_run_CV[i_d][i_b];
	  }
	  if (counter_nonzero_distribution_run_CV[i_d][i_b] < 2){distribution_chi2_CV[i_d][i_b][i_s] = 0.;}
	  //  chi2 cannot be reasonably defined for only one run.
	  
	}
      }
    }
  }

  vector<vector<long long> > ().swap(distribution_run_N_CV);
  vector<vector<vector<long long> > > ().swap(distribution_run_N_binwise_CV);
  
  vector<vector<vector<vector<double> > > > ().swap(distribution_run_result_CV);
  vector<vector<vector<vector<double> > > > ().swap(distribution_run_deviation_CV);
  //  vector<vector<vector<vector<double> > > > ().swap(distribution_run_deltasigma);
  //  vector<vector<vector<vector<double> > > > ().swap(distribution_run_weight);
 
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}



void summary_subprocess::combine_distribution_conservative_CV(int x_z, int i_d, int i_b, int i_s){
  Logger logger("summary_subprocess::combine_distribution_conservative_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  //  original calculation begin
  logger << LOG_DEBUG_VERBOSE << "original calculation" << endl;

  result_subprocess = 0.;
  deviation_subprocess = 0.;
  N_subprocess = 0;
  
  for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
    if (distribution_run_N_CV[i_z][i_d] != 0 && switch_off_run[x_z][i_z] == 0){
      N_subprocess += distribution_run_N_CV[i_z][i_d];
      if (distribution_run_N_binwise_CV[i_z][i_d][i_b] > 0){
	result_subprocess += distribution_run_result_CV[i_z][i_d][i_b][i_s];
	deviation_subprocess += distribution_run_deviation_CV[i_z][i_d][i_b][i_s];
      }
    }
  }
  if (N_subprocess != 0){
    combination_result[x_z] = result_subprocess / N_subprocess; 
    combination_deviation[x_z] = sqrt((N_subprocess * deviation_subprocess - pow(result_subprocess, 2)) / N_subprocess) / (N_subprocess - 1);
  }
  else {
    combination_result[x_z] = 0.;
    combination_deviation[x_z] = 0.;
  }
  //  original calculation end
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}



void summary_subprocess::combine_distribution_hybrid_CV(int x_z, int i_d, int i_b, int i_s){
  Logger logger("summary_subprocess::combine_distribution_hybrid_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_conservative = ycontribution->average_factor;
  int temp_n_conservative = 0;
  int temp_n_runs = 0;
  vector<int> temp_list_no_run;
  for (int i_z = 0; i_z < ycontribution->directory.size(); i_z++){
    if (!remove_run_bin[i_z]){
      if (distribution_run_N_CV[i_z][i_d] != 0){
	temp_n_runs++;
	temp_list_no_run.push_back(i_z);
      }
    }
  }
  if (temp_n_runs < n_conservative){temp_n_conservative = temp_n_runs;}
  else {temp_n_conservative = n_conservative;}
  if (ycontribution->average_factor == 0){temp_n_conservative = temp_n_runs;}

  vector<double> conservative_result_run(temp_n_conservative, 0.);
  vector<double> conservative_deviation_run(temp_n_conservative, 0.);
  vector<double> conservative_chi2(temp_n_conservative, 0.);
  vector<long long> conservative_N_all(temp_n_conservative, 0);
  vector<long long> conservative_no_results(temp_n_conservative, 0);
  
  for (int i_z = 0; i_z < temp_list_no_run.size(); i_z++){
    int conservative_i_z = i_z % temp_n_conservative;

    if (!(distribution_run_result_CV[temp_list_no_run[i_z]][i_d][i_b][i_s] == 0. && distribution_run_deviation_CV[temp_list_no_run[i_z]][i_d][i_b][i_s] == 0.)){
      ///      if (!remove_run_bin[temp_list_no_run[i_z]]){
      temp_N_binwise += distribution_run_N_binwise_CV[temp_list_no_run[i_z]][i_d][i_b];
      conservative_N_all[conservative_i_z] += distribution_run_N_CV[temp_list_no_run[i_z]][i_d];
      conservative_no_results[conservative_i_z]++;
      // input different for distributions
      conservative_result_run[conservative_i_z] += distribution_run_result_CV[temp_list_no_run[i_z]][i_d][i_b][i_s];
      // distribution_run_result_CV   should be sum over weights
      conservative_deviation_run[conservative_i_z] += distribution_run_deviation_CV[temp_list_no_run[i_z]][i_d][i_b][i_s];
      // distribution_run_result_CV   should be sum over squared weights
      // logger << LOG_DEBUG << "conservative_N_all[" << setw(3) << conservative_i_z << "] = " << setw(10) << conservative_N_all[conservative_i_z] << "   distribution_run_N_CV[" << setw(3) << i_z << "][i_d] = " << setw(10) << distribution_run_N_CV[i_z][i_d] << "   result = " << distribution_run_result_CV[i_z][i_d][i_b][i_s] << " +- " << distribution_run_deviation_CV[i_z][i_d][i_b][i_s] << endl;
	///      }
	///      else {logger << LOG_INFO << "Should never happen !!!" << endl;}
    }
  }

  for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
    conservative_deviation_run[conservative_i_z] = sqrt((conservative_N_all[conservative_i_z] * conservative_deviation_run[conservative_i_z] - pow(conservative_result_run[conservative_i_z], 2)) / conservative_N_all[conservative_i_z]) / (conservative_N_all[conservative_i_z] - 1); 
    conservative_result_run[conservative_i_z] = conservative_result_run[conservative_i_z] / conservative_N_all[conservative_i_z];
  }
  for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
    //    conservative_chi2[conservative_i_z] = conservative_chi2[conservative_i_z] / conservative_no_results[conservative_i_z];
    if (conservative_no_results[conservative_i_z] == 0){
      conservative_result_run[conservative_i_z] = 0.;
      conservative_deviation_run[conservative_i_z] = 0.;
    }
  }
  
  combination_N_event_all = 0;
  for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
    combination_N_event_all += conservative_N_all[conservative_i_z];
    if (conservative_N_all[conservative_i_z] > 0){no_results++;}
  }
  if (combination_N_event_all != 0){
    combination_result[x_z] = 0.;
    combination_deviation[x_z] = 0.;
    for (int i_z = 0; i_z < temp_n_conservative; i_z++){
      if (distribution_run_N_CV[i_z][i_d] != 0 && conservative_result_run[i_z] != 0. && conservative_deviation_run[i_z] != 0.){
	double temp_singleweight = 1. / pow(conservative_deviation_run[i_z], 2);
	logger << LOG_DEBUG_VERBOSE << "conservative_result_run[" << i_z << "] = " << setw(23) << setprecision(15) << conservative_result_run[i_z] << " +- = " << setw(23) << setprecision(15) << conservative_deviation_run[i_z] << endl;
	combination_result[x_z] += temp_singleweight * conservative_result_run[i_z];
	combination_deviation[x_z] += temp_singleweight;
      }
      else if (distribution_run_N_CV[i_z][i_d] != 0 && conservative_result_run[i_z] == 0. && conservative_deviation_run[i_z] == 0.){
	combination_result[x_z] += 0.;
	combination_deviation[x_z] += 0.;
	logger << LOG_DEBUG_VERBOSE << "empty: conservative_result_run[" << i_z << "] = " << setw(23) << setprecision(15) << conservative_result_run[i_z] << " +- = " << setw(23) << setprecision(15) << conservative_deviation_run[i_z] << endl;
      }
    }
    if (combination_N_event_all != 0 && combination_result[x_z] != 0. && combination_deviation[x_z] != 0.){
      combination_result[x_z] = combination_result[x_z] / combination_deviation[x_z];
      combination_deviation[x_z] = 1. / sqrt(combination_deviation[x_z]);
    }
    else {
      combination_result[x_z] = 0.;
      combination_deviation[x_z] = 0.;
    }
  }
  else if (combination_N_event_all == 0){
    combination_result[x_z] = 0.;
    combination_deviation[x_z] = 0.;
  }
  
  for (int conservative_i_z = 0; conservative_i_z < temp_n_conservative; conservative_i_z++){
    if (!(distribution_run_result_CV[conservative_i_z][i_d][i_b][i_s] == 0. && 
	  distribution_run_deviation_CV[conservative_i_z][i_d][i_b][i_s] == 0.)){
      conservative_chi2[conservative_i_z] += pow((conservative_result_run[conservative_i_z] - combination_result[x_z]) / conservative_deviation_run[conservative_i_z], 2.);
    }
    conservative_chi2[conservative_i_z] = conservative_chi2[conservative_i_z] / temp_n_conservative;
  }
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}















