      subroutine gen2ymfixed(r,p,wt2,*)
      implicit none
      include 'types.f'
! hacked version of gen2 with Y and M fixed
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'limits.f'
      include 'mxdim.f'
      include 'phasemin.f'
      include 'nodecay.f'
      include 'breit.f'
      include 'x1x2.f'
      include 'debug.f'
      integer:: j,nu
      real(dp):: r(mxdim),p(mxpart,4),rdk1,rdk2,s34min
      real(dp):: ymax,yave,ydif,xjac,y3,y4,phi,wt0,wt2,w3
      real(dp):: pt,s34,rtshat,udif
      real(dp):: thetastar,ystar
      include 'energy.f'
      include 'mcfmparameters.f'
      parameter(wt0=one/16._dp/pi)

      p(:,:)=zip

      xx(1)=born_fixed_M/sqrts*exp(+born_fixed_Y)
      xx(2)=born_fixed_M/sqrts*exp(-born_fixed_Y)

      p(1,4)=-0.5_dp*xx(1)*sqrts
      p(1,1)=0._dp
      p(1,2)=0._dp
      p(1,3)=-0.5_dp*xx(1)*sqrts

      p(2,4)=-0.5_dp*xx(2)*sqrts
      p(2,1)=0._dp
      p(2,2)=0._dp
      p(2,3)=+0.5_dp*xx(2)*sqrts

!     now construct kinematics of the decay
!     angle in the partonic CM frame
      thetastar = pi*r(1)
!     transverse momentum (invariant under boost)
      pt        = born_fixed_M/2._dp*sin(thetastar)
!     ystar = arccosh(1/sin(thetastar))
      ystar     = log(1._dp/sin(thetastar)+sqrt((1._dp/sin(thetastar)-1._dp)*(1._dp/sin(thetastar)+1._dp)))
!     boost to the CM frame
      y3        = born_fixed_Y + ystar
      y4        = born_fixed_Y - ystar

!     azimuthal angle
      phi=2._dp*pi*r(2)

      p(3,4)=+pt*cosh(y3)
      p(3,1)=+pt*sin(phi)
      p(3,2)=+pt*cos(phi)
      p(3,3)=+pt*sinh(y3)

      p(4,4)=+pt*cosh(y4)
      p(4,1)=-pt*sin(phi)
      p(4,2)=-pt*cos(phi)
      p(4,3)=+pt*sinh(y4)

!     the two body phase space is
!     1/(8 pi) 1/2 dcos(thetastar) 1/(2pi) dphi 1/shat
!     the jacobian is thus
!     1/(8 pi) 1/2 1/(2pi) 1/shat * j1 * j2 = wt0*pi/sqrts**2
!     with j1 = pi, j2 = 2 pi
      wt2=wt0*pi/sqrts**2
      return

      end