#include <iostream>
#include <iomanip>

#include "ampVVprime.h"

using namespace std;

int main(int argc, char* argv[]) {
  VVprime amp;
  
  amp.initAmplitude(5);
  
  double s, t, ma2, mb2;
  s = 15625.;
  t = -2384.89727896833;
  ma2 = 6467.215561;
  mb2 = 625.;
  
  amp.computeAmplitude(s,t,ma2,mb2);
  
  int nloop=3;
  int ntype=4;
  int nEcoeff=9;
  
  cout << setprecision(15);
  for (int l = 0 ; l < nloop; ++l) {
    for (int i = 1 ; i <= nEcoeff; ++i) {
      cout << l << " \t" << i;
      for (int j = 0 ; j < ntype; ++j) {
        double Er, Ei;
        amp.getAmplitude(l,i,j,Er,Ei);
         cout << " \t" << Er;
         cout << " \t" << Ei;
      }
      cout << "\n";
    }
  }
  cout << endl;
}